package com.lea.dao;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.util.Collection;
import java.util.Vector;

import javax.crypto.BadPaddingException;
import javax.crypto.Cipher;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.NoSuchPaddingException;

import org.apache.commons.net.ftp.FTPClient;
import org.dom4j.DocumentException;

import com.lea.domain.Ftp;
import com.lea.exception.LoadingException;



public abstract class AbstractFtpDAO implements DataAccessConstants{
	
	public abstract void writeAutoConfig(Cipher cipher, Ftp ftp,String path) throws NoSuchAlgorithmException, NoSuchPaddingException, InvalidKeyException, IllegalBlockSizeException, IOException;

	public abstract Ftp readAutoConfig(Cipher cipher, String path) throws FileNotFoundException, IOException, ClassNotFoundException, NoSuchAlgorithmException, NoSuchPaddingException, InvalidKeyException, IllegalBlockSizeException, BadPaddingException;

	public abstract Collection<Ftp> readFtpHistory(Cipher cipher,String intallationPath) throws LoadingException;
	
	public abstract void writeFtpHistory (Cipher cipher,Ftp ftp, String intallationPath) throws IllegalBlockSizeException, IOException;

	public abstract boolean removeFtpHistory(Ftp ftp,String intallationPath);
	
	public abstract void upload(String fileName, FTPClient ftpcClient) throws FileNotFoundException, IOException;
	
	public abstract FtpDAO getFtpDAO();

	public abstract String downloadXMLupdateFile(String installPath,FTPClient ftpClient) throws FileNotFoundException, IOException, DocumentException;

	public abstract long getFtpFilesSize(Vector selectedFiles, FTPClient ftpClient) throws IOException;

	public abstract void setDownload(String fileName, String localActualPath, FTPClient ftpClient) throws FileNotFoundException;

	public abstract void download(String fileName, FTPClient ftpClient) throws IOException;

	public abstract void setUpload(File file,FTPClient ftpClient) throws FileNotFoundException ;
	
}
