package com.lea.dao;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.ArrayList;

import com.lea.controler.Observable;
import com.lea.controler.Observateur;
import com.lea.domain.Mission;




public abstract class AbstractMissionDAO implements DataAccessConstants, Observable  {
	
	protected ArrayList<Observateur> listObservateur = new ArrayList<Observateur>();
	protected double count = 0;

	public abstract void save(Mission mission, String missionFolderPath) throws FileNotFoundException, IOException;
	
	public abstract Mission load(String missionFilePath) throws FileNotFoundException, IOException, ClassNotFoundException;

	public abstract Mission parse(String missionSQFfilePath) throws FileNotFoundException, IOException, ClassNotFoundException;

	public abstract void deleteMissionFile(Mission mission, String missionsFolderPath);
	
	public abstract void extractPBO(File sourceFile, File destinationFile) throws IOException, InterruptedException;
	
	public abstract void makePBO(String installPath, String missionFolderPath, String missionFileName) throws IOException, InterruptedException;

	public abstract void backupMissionSQM(String missionSQMPath) throws IOException;
	
	public abstract void deleteMissionSQM(String missionSQMPath);
	
	public abstract void generateMissionSQM(Mission mission,String missionFolderPath) throws FileNotFoundException, IOException;
	
	public abstract void rollBackMissionSQM(String missionFolderPath) throws IOException;
	
	public abstract void copyMission(String missionsFolderPath, String destinationPath) throws IOException;
	
	public abstract String findLeaFolder(String path);
	
	@Override
	public void addObservateur(Observateur obs) {
		this.listObservateur.add(obs);
	}

	@Override
	public void delObservateur() {
		this.listObservateur = new ArrayList<Observateur>();
	}

	@Override
	public void updateObservateur() {
		for (Observateur obs : this.listObservateur) {
			obs.update(this.count);
		}
	}
}
