package com.lea.dao;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Collection;
import java.util.HashMap;

import com.lea.domain.Profile;
import com.lea.exception.LoadingException;




public abstract class AbstractProfileDAO {
	
	public abstract void save(Profile profile, String profilePath) throws FileNotFoundException, IOException;

	public abstract Collection<Profile> loadAll(String profilesFolderPath);

	public abstract Profile getProfile(int profileId);

	public abstract HashMap<Integer, Profile> getMap();

	public  abstract int add(String profileName, String profilePath, boolean value) throws FileNotFoundException, IOException;

	public abstract void remove(int profileId, String profilePath) ;

	public abstract void load(String path, String installationPath) throws FileNotFoundException, IOException, ClassNotFoundException;

}
