package com.lea.dao;

import java.io.File;
import java.lang.ref.WeakReference;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.StringTokenizer;
import java.util.TreeSet;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.swing.ImageIcon;

import org.dom4j.Document;
import org.dom4j.DocumentException;
import org.dom4j.Element;
import org.dom4j.Node;
import org.dom4j.io.SAXReader;

import com.lea.controler.Observable;
import com.lea.controler.Observateur;
import com.lea.domain.Weapon;
import com.lea.exception.DataAccessException;
import com.lea.exception.FinderException;



public abstract class AbstractWeaponDAO implements DataAccessConstants,Observable {

	protected static HashMap<String, Weapon> mapRifle = new HashMap<String, Weapon>();
	protected static HashMap<String, Weapon> mapSniper = new HashMap<String, Weapon>();
	protected static HashMap<String, Weapon> mapMG = new HashMap<String, Weapon>();
	protected static HashMap<String, Weapon> mapAR = new HashMap<String, Weapon>();
	protected static HashMap<String, Weapon> mapRuck = new HashMap<String, Weapon>();
	protected static HashMap<String, Weapon> mapEquip = new HashMap<String, Weapon>();
	protected static HashMap<String, Weapon> mapLauncher = new HashMap<String, Weapon>();
	protected static HashMap<String, Weapon> mapItem = new HashMap<String, Weapon>();
	protected static HashMap<String, Weapon> mapPistol = new HashMap<String, Weapon>();
	protected static HashMap<String, Weapon> mapWeapon = new HashMap<String, Weapon>();
	private static ArrayList<Document> documentWeapons = null;
	private static List<String> factions = null;
	private static Set<String> availableMods = new TreeSet<String>();

	protected ArrayList<Observateur> listObservateur = new ArrayList<Observateur>();
	protected int count = 0;

	public int readWeaponsClasslist(String installationPath) {

		documentWeapons = new ArrayList<Document>();
		SAXReader reader = new SAXReader();
		
		File directory = new File(installationPath + "/" + WEAPONS_CLASSLIST_FILES);
		File[] subfiles = directory.listFiles();
		int numberWeapons = 0;
		String classlistXmlPath ="";
		try {
			for (int i = 0; i < subfiles.length; i++) {
				classlistXmlPath = subfiles[i].getAbsolutePath();
				Document documentWeapon = reader.read(classlistXmlPath);
				Element root = documentWeapon.getRootElement();
				numberWeapons = root.elements().size();
				documentWeapons.add(documentWeapon);
			}
		} catch (DocumentException e) {
			e.printStackTrace();
			System.out.println(installationPath);
			throw new DataAccessException(
					"file classlist " + classlistXmlPath + " not found: "
							+ e.getMessage(), e);
		}
		return numberWeapons;
	}

	public void createDBWeapons() {

		for (int l = 0; l < documentWeapons.size(); l++) {

			Element root = documentWeapons.get(l).getRootElement();
			for (Iterator i = root.elementIterator(); i.hasNext();) {
				Element element = (Element) i.next();

				try {
					Weapon weapon = new Weapon();
					String type = "";
					String classname = "";
					String name = "";
					String caliber = "";
					double aceWeight = 0;
					boolean ace = false;
					List<String> listMagazine = new ArrayList<String>();
					List<String> listFaction = new ArrayList<String>();
					ImageIcon imageIcon = null;
					String mod = "";

					classname = element.selectSingleNode("name").getText();
					name = element.selectSingleNode("displayname").getText();
					type = element.selectSingleNode("type").getText();
					
					caliber = element.selectSingleNode("caliber").getText();
					ace = Boolean.parseBoolean(element.selectSingleNode("ace")
							.getText());
					String number = element.selectSingleNode("ace_weight")
							.getText();

					Pattern pattern = Pattern.compile(",");
					Matcher matcher = pattern.matcher(number);
					if (matcher.find()) {
						StringTokenizer sb = new StringTokenizer(number, ",");
						String integer = sb.nextToken();
						String decimal = sb.nextToken();
						number = integer + "." + decimal;
						aceWeight = Double.parseDouble(number);
					}

					List<Element> listmuzzlenodes = element
							.selectNodes("muzzles/muzzle");
					for (Element muzzle : listmuzzlenodes) {
						Element magazinesNode = (Element) muzzle
								.selectSingleNode("magazines");
						treeWalk(magazinesNode, listMagazine);
					}
	
					Element factionsElement = (Element) element
							.selectSingleNode("factions");
					treeWalk(factionsElement, listFaction);

					mod = element.selectSingleNode("mod").getText();

					weapon.setName(name);
					weapon.setClassname(classname);
					weapon.setAceWeight(aceWeight);
					weapon.setCaliber(caliber);

					weapon.setListMagazineClassname(listMagazine);
					weapon.setListFaction(listFaction);
					weapon.setAce(ace);
					weapon.setMod(mod);
					weapon.setType(type);
					weapon.checkData();

					mapWeapon.put(classname, weapon);
					this.updateObservateur();
					count++;
					if (!mod.equals("")){
						availableMods.add(mod.toUpperCase());
					}
					
					if (type.equals("Rifle"))
						mapRifle.put(weapon.getClassname(), weapon);
					else if (type.equals("MG")) {
						mapMG.put(weapon.getClassname(), weapon);
					} 
					else if (type.equals("AR"))
						mapAR.put(weapon.getClassname(), weapon);
					else if (type.equals("Ruck"))
						mapRuck.put(weapon.getClassname(), weapon);
					else if (type.equals("Launcher"))
						mapLauncher.put(weapon.getClassname(), weapon);
					else if (type.equals("Sniper"))
						mapSniper.put(weapon.getClassname(), weapon);
					else if (type.equals("Item"))
						mapItem.put(weapon.getClassname(), weapon);
					else if (type.equals("Equip"))
						mapEquip.put(weapon.getClassname(), weapon);
					else if (type.equals("Pistol"))
						mapPistol.put(weapon.getClassname(), weapon);
				} catch (Exception e) {
					e.printStackTrace();
					throw new DataAccessException(
							"error in parsing classlist_weapons_ace.xml : "
									+ e.getMessage(), e);
				}
				
			}
		}
		documentWeapons=null;
	}

	private void treeWalk(Element element, List<String> list) {

		for (int i = 0, size = element.nodeCount(); i < size; i++) {
			Node node = element.node(i);
			if (node instanceof Element) {
				if (node.getName().equals("name")) {
					if (!list.contains(node.getText()))
						list.add(node.getText());
				}
				treeWalk((Element) node, list);
			}
		}
	}

	public Collection findAll() {
		return getMap().values();
	}

	public Collection findByFaction(String factionName) {
		Collection<Weapon> weapons = new ArrayList<Weapon>();
		Set<Map.Entry<String, Weapon>> entrees = getMap().entrySet();
		Iterator<Map.Entry<String, Weapon>> iter = entrees.iterator();
		while (iter.hasNext()) {
			Map.Entry<String, Weapon> entree = (Map.Entry) iter.next();
			Weapon weapon = ((Weapon) entree.getValue());
			if (weapon.getListFaction().contains(factionName)) {
				weapons.add(weapon);
			}
		}
		return weapons;
	}

	public Weapon findByClassname(String weaponClassname) {
		Weapon weapon = getMap().get(weaponClassname.trim());
		return weapon;
	}

	public Collection<String> findMagazines(String weaponClassname) {
		Collection<String> magazines = new ArrayList<String>();
		Weapon weapon = findByClassname(weaponClassname);
		if (weapon != null) {
			List<String> wapeonMagazines = weapon.getListMagazineClassname();
			for (String mag : wapeonMagazines) {
				magazines.add(mag);
			}
		}
		return magazines;
	}

	public abstract HashMap<String, Weapon> getMap();

	public Collection<String> findFactions(Collection<String> selectedMods) {

		factions = new ArrayList<String>();
		factions.add("ALL");

		Set<Map.Entry<String, Weapon>> entrees = getMap().entrySet();
		Iterator<Map.Entry<String, Weapon>> iter = entrees.iterator();
		while (iter.hasNext()) {
			Map.Entry<String, Weapon> entree = (Map.Entry) iter.next();
			Weapon weapon = ((Weapon) entree.getValue());
			List<String> list = weapon.getListFaction();
			if (selectedMods.contains(weapon.getMod().toUpperCase())||weapon.getMod().equals("")){
				for (String s : list) {
					if (!factions.contains(s))
						factions.add(s);
				}
			}
		}
		factions.remove("CIV");
		factions.remove("Default");
		Collections.sort(factions);
		return factions;
	}

	public static List<String> getFactions() {
		return factions;
	}

	public WeakReference<ImageIcon> findImageIcon(String installPath,String weaponClassname) {

		String stg = installPath + "/" + WEAPON_PICTURES + "/" + weaponClassname + ".png";

		ImageIcon imageIcon = new ImageIcon(stg);
		imageIcon.setDescription(weaponClassname);
		WeakReference<ImageIcon> ref = new WeakReference<ImageIcon>(imageIcon);
		return ref;
	}

	public WeakReference<ImageIcon> findImageIconInIconesFolder(String installPath,
			String weaponClassname) throws FinderException {

		String stg =  installPath + "/"  + WEAPON_ICONES + "/" + weaponClassname + ".png";

		ImageIcon imageIcon = new ImageIcon(stg);

		if (imageIcon == null) {
			throw new FinderException("Can't find icone for weapon "
					+ weaponClassname);
		}

		imageIcon.setDescription(weaponClassname);
		WeakReference<ImageIcon> ref = new WeakReference<ImageIcon>(imageIcon);
		return ref;
	}
	
	public Set<String> getAvailableMods() {
		return availableMods;
	}

	/* Observer/Observable pattern */
	
	public void addObservateur(Observateur obs) {
		this.listObservateur.add(obs);
	}

	public void delObservateur() {
		this.listObservateur = new ArrayList<Observateur>();
	}

	public void updateObservateur() {
		for (Observateur obs : this.listObservateur) {
			obs.update(this.count);
		}
	}
}
