package com.lea.dao;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Properties;
import java.util.Stack;
import java.util.StringTokenizer;

import com.lea.domain.Ftp;

public class CommonDAO extends AbstractCommonDAO {

	private static String installationPath;
	private static Properties properties = new Properties();
	private static final String REGQUERY_UTIL = "reg query ";
	private static final String REGSTR_TOKEN = "REG_SZ";

	@Override
	public void determineInstallationPath() {
		installationPath = System.getProperty("user.dir");

		// try {
		// File file = new File("");
		// String path = file.getAbsolutePath();
		// installationPath = path.replace("\\", "/");
		// FileOutputStream oStream = new FileOutputStream(installationPath
		// + "/" + PROPERTIES_FILE);
		// properties.setProperty("installPath", installationPath);
		// properties.store(oStream, "installPath");
		// oStream.close();
		//
		// } catch (Exception e) {
		// e.printStackTrace();
		// throw new DataAccessException(
		// "error in reading installProperties : " + e.getMessage(), e);
		// }
	}

	public String getInstallationPath() {
		return installationPath;
	}

	@Override
	public String getMods() {
		String listMods = null;
		try {
			FileInputStream stream = new FileInputStream(installationPath + "/" + PROPERTIES_FILE);
			properties.load(stream);
			listMods = properties.getProperty("mods");
			stream.close();
		} catch (Exception e) {
			// e.printStackTrace();
			try {
				FileOutputStream oStream = new FileOutputStream(
						installationPath + "/" + PROPERTIES_FILE);
				properties.setProperty("mods", "");
				properties.store(oStream, "mods");
				oStream.close();
			} catch (Exception e1) {
				e1.printStackTrace();
			}
		} finally {
			if (listMods == null) {
				listMods = "ACRE,HEXAGON,R3F ARMES,RH AK,RH HK416,RH M14,RH M4,RH M40,RH MGS,RH MK18,RH PISTOL,RH PWD,RH SMG,ACE,M109A6 Paladin";
			}
		}
		return listMods;
	}

	@Override
	public void setMods(String listMods) {
		try {
			FileOutputStream oStream = new FileOutputStream(installationPath
					+ "/" + PROPERTIES_FILE);
			properties.setProperty("mods", listMods);
			properties.store(oStream, "mods");
			oStream.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	@Override
	public Collection<Ftp> getFtpHistory() {

		Collection<Ftp> ftps = new ArrayList<Ftp>();
		try {
			FileInputStream stream = new FileInputStream(installationPath + "/"
					+ PROPERTIES_FILE);
			properties.load(stream);
			String listIdentifiers = properties.getProperty("ftphistory");
			if (listIdentifiers != null) {
				StringTokenizer stg = new StringTokenizer(listIdentifiers, ";");
				while (stg.hasMoreTokens()) {
					String identifiers = stg.nextToken();
					StringTokenizer stgFtp = new StringTokenizer(identifiers,
							",");
					while (stgFtp.hasMoreTokens()) {
						Ftp ftp = new Ftp();
						ftp.setUrl(stgFtp.nextToken());
						ftp.setPort(stgFtp.nextToken());
						ftp.setLogin(stgFtp.nextToken());
						ftp.setPassword(stgFtp.nextToken());
						ftps.add(ftp);
					}
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return ftps;
	}

	@Override
	public void updateFtpHistory(Ftp ftp) {
		try {
			FileInputStream stream = new FileInputStream(installationPath + "/"
					+ PROPERTIES_FILE);
			properties.load(stream);
			stream.close();
			String listIdentifiers = properties.getProperty("ftphistory");
			listIdentifiers = listIdentifiers + ftp.getUrl() + ","
					+ ftp.getPort() + "," + ftp.getLogin() + ","
					+ ftp.getPassword() + ";";
			FileOutputStream oStream = new FileOutputStream(installationPath
					+ "/" + PROPERTIES_FILE);
			properties.setProperty("ftphistory", listIdentifiers);
			properties.store(oStream, "mods");
			oStream.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	@Override
	public String getUserconfigLeaPath() {
		FileInputStream stream;
		String userconfig = null;

		try {
			stream = new FileInputStream(installationPath + "/"
					+ PROPERTIES_FILE);
			properties.load(stream);
			userconfig = properties.getProperty("userconfig");
			stream.close();

			if (userconfig == null) {
				Process process = Runtime
						.getRuntime()
						.exec(
								REGQUERY_UTIL
										+ "\"HKLM\\SOFTWARE\\Wow6432Node\\Bohemia Interactive Studio\\ArmA 2 OA");
				StreamReader reader = new StreamReader(process.getInputStream());

				reader.start();
				process.waitFor();
				reader.join();

				String result = reader.getResult();
				String keyREG_SZ = REGSTR_TOKEN;

				int pkeyREG_SZ = result.indexOf(keyREG_SZ);

				if (pkeyREG_SZ == -1) {
					return null;
				}

				result = result.substring(pkeyREG_SZ + REGSTR_TOKEN.length())
						.trim();
				String keyReg_BINARY = "KEY";
				int pkeyReg_BINARY = result.indexOf(keyReg_BINARY);
				result = result.substring(0, pkeyReg_BINARY).trim();
				userconfig = result.trim() + "\\userconfig";
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return userconfig;
	}

	@Override
	public void setUserConfigLeaPath(String path) {
		try {
			FileOutputStream oStream = new FileOutputStream(installationPath
					+ "/" + PROPERTIES_FILE);
			properties.setProperty("userconfig", path);
			properties.store(oStream, "userconfig");
			oStream.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	@Override
	public void setTopStackEditedMission(String missionFileName) {
		try {
			FileInputStream stream = new FileInputStream(installationPath + "/"
					+ PROPERTIES_FILE);
			properties.load(stream);
			String missionStack = properties
					.getProperty("resentlyOpenedMissionStack");
			stream.close();
			StringBuffer stringBuffer = new StringBuffer();
			if (missionStack != null) {
				StringTokenizer stk = new StringTokenizer(missionStack, ",");
				Stack<String> stackFileNames = new Stack<String>();
				stackFileNames.add(missionFileName);
				int count = 0;
				while (stk.hasMoreTokens() && count < 3) {
					String name = stk.nextToken();
					if (!stackFileNames.contains(name)) {
						stackFileNames.add(name);
						count++;
					}
				}

				for (int i = 0; i < stackFileNames.size(); i++) {
					stringBuffer.append(stackFileNames.elementAt(i));
					stringBuffer.append(",");
				}
			} else {
				stringBuffer.append(missionFileName);
			}

			FileOutputStream oStream = new FileOutputStream(installationPath
					+ "/" + PROPERTIES_FILE);
			properties.setProperty("resentlyOpenedMissionStack", stringBuffer
					.toString());
			properties.store(oStream, "resentlyOpenedMissionStack");
			oStream.close();

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public Stack<String> getStackEditedMission() {

		Stack<String> stackFileNames = new Stack<String>();
		try {
			FileInputStream stream = new FileInputStream(installationPath + "/"
					+ PROPERTIES_FILE);
			properties.load(stream);
			String missionStack = properties
					.getProperty("resentlyOpenedMissionStack");
			stream.close();
			if (missionStack != null) {
				StringTokenizer stk = new StringTokenizer(missionStack, ",");
				while (stk.hasMoreTokens()) {
					String name = stk.nextToken();
					stackFileNames.add(name);
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return stackFileNames;
	}

	@Override
	public void removeFromStackEditedMission(String missionFileName) {

		Stack<String> stackFileNames = new Stack<String>();
		try {
			FileInputStream stream = new FileInputStream(installationPath + "/"
					+ PROPERTIES_FILE);
			properties.load(stream);
			String missionStack = properties
					.getProperty("resentlyOpenedMissionStack");
			stream.close();
			if (missionStack != null) {
				StringTokenizer stk = new StringTokenizer(missionStack, ",");
				while (stk.hasMoreTokens()) {
					String name = stk.nextToken();
					if (!name.equals(missionFileName)) {
						stackFileNames.add(name);
					}
				}
			}

			StringBuffer stringBuffer = new StringBuffer();
			for (int i = 0; i < stackFileNames.size(); i++) {
				stringBuffer.append(stackFileNames.elementAt(i));
				stringBuffer.append(",");
			}

			FileOutputStream oStream = new FileOutputStream(installationPath
					+ "/" + PROPERTIES_FILE);
			properties.setProperty("resentlyOpenedMissionStack", stringBuffer
					.toString());
			properties.store(oStream, "resentlyOpenedMissionStack");
			oStream.close();

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	@Override
	public String getProfilesListItemsPreferences() {
		
		String listItemsPreferences = null;
		try {
			FileInputStream stream = new FileInputStream(installationPath + "/" + PROPERTIES_FILE);
			properties.load(stream);
			listItemsPreferences = properties.getProperty("profilesListItemsPreferences");
			stream.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return listItemsPreferences;
	}

	@Override
	public void setProfilesListItemsPreferences(String listItemsPreferences) {
		
		try {
			FileOutputStream oStream = new FileOutputStream(installationPath + "/" + PROPERTIES_FILE);
			properties.setProperty("profilesListItemsPreferences", listItemsPreferences);
			properties.store(oStream, "profilesListItemsPreferences");
			oStream.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	@Override
	public String getProfilesListOpticalsPreferences() {
		
		String listOpticalsPreferences = null;
		try {
			FileInputStream stream = new FileInputStream(installationPath + "/" + PROPERTIES_FILE);
			properties.load(stream);
			listOpticalsPreferences = properties.getProperty("profilesListOpticalsPreferences");
			stream.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return listOpticalsPreferences;
	}

	@Override
	public void setProfilesListOpticalsPreferences(String listOpticalsPreferences) {
		
		try {
			FileOutputStream oStream = new FileOutputStream(installationPath + "/" + PROPERTIES_FILE);
			properties.setProperty("profilesListOpticalsPreferences", listOpticalsPreferences);
			properties.store(oStream, "profilesListOpticalsPreferences");
			oStream.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	@Override
	public String getProfilesListEquipPreferences() {
		
		String listEquipPreferences = null;
		try {
			FileInputStream stream = new FileInputStream(installationPath + "/" + PROPERTIES_FILE);
			properties.load(stream);
			listEquipPreferences = properties.getProperty("profilesListEquipPreferences");
			stream.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return listEquipPreferences;
	}

	@Override
	public void setProfilesListEquipPreferences(String listEquipPreferences) {
		
		try {
			FileOutputStream oStream = new FileOutputStream(installationPath + "/" + PROPERTIES_FILE);
			properties.setProperty("profilesListEquipPreferences", listEquipPreferences);
			properties.store(oStream, "profilesListEquipPreferences");
			oStream.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
