package com.lea.dao;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

import com.lea.domain.Mission;
import com.lea.exception.WritingException;



public class LoadoutInitDAO extends AbstractScriptDAO {

	@Override
	public void writeScript(Object object, String path,boolean noACE) throws WritingException, IOException {

		File file = new File(path + "/lea");
		if (!file.exists()) {
			file.mkdir();
		}
		
		Mission mission = (Mission) object;
		
		String missionFolderPath = mission.getMissionFolderPath();
		String relativePath =  path.subSequence(missionFolderPath.length(), path.length()).toString();
		
		if (relativePath.length()!=0){
			relativePath =	relativePath.substring(1) + "\\";
		}
		
		PrintWriter fWo = new PrintWriter(new FileWriter(path + "/lea/loadout-init.sqf"));

		fWo.println("/**");
		fWo.println("* Generated by LEA for Arma 2 Combined Operation & ACE 2");
		fWo.println("* Init call for loadout scripts.");
		fWo.println("*/");
		fWo.println("");
		fWo.println("enable_lea_addon=false;");
		fWo.println("");
		fWo.println("if (isMultiplayer) then {");
		fWo.println("\t" + "_dummy = [] execVM " + "\""  + relativePath + "lea\\loadout-multi.sqf"
				+ "\"" + ";");
		fWo.println("}");
		fWo.println("else {");
		fWo.println("\t" + "_dummy = [] execVM " + "\"" + relativePath + "lea\\loadout-solo.sqf"
				+ "\"" + ";");
		fWo.println("};");
		fWo.close();
	}
}
