package com.lea.domain;

import java.io.Serializable;

import com.lea.exception.CheckException;


public class Ftp implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = -6018927123166125073L;
	private String login;
	private String password;
	private String url;
	private String port;
	private String remoteMissionsFolderPath;
	private String remoteProfilesFolderPath;
	private String remotePbosFolderPath;

	public String getRemoteMissionsFolderPath() {
		return remoteMissionsFolderPath;
	}

	public void setRemoteMissionsFolderPath(String remoteMissionsFolderPath) {
		this.remoteMissionsFolderPath = remoteMissionsFolderPath;
	}

	public String getRemoteProfilesFolderPath() {
		return remoteProfilesFolderPath;
	}

	public void setRemoteProfilesFolderPath(String remoteProfilesFolderPath) {
		this.remoteProfilesFolderPath = remoteProfilesFolderPath;
	}
	
	public Ftp() {
	}

	public Ftp(String url, String port, String login, String password, String remoteMissionsFolderPath, String remoteProfilesFolderPath,String remotePbosFolderPath) {
		this.url = url;
		this.login = login;
		this.port = port;
		this.password = password;
		this.remoteMissionsFolderPath= remoteMissionsFolderPath;
		this.remoteProfilesFolderPath = remoteProfilesFolderPath;
		this.remotePbosFolderPath = remotePbosFolderPath;
	}

	public Ftp(String url, String port, String login, String password) {
		this.url = url;
		this.login = login;
		this.port = port;
		this.password = password;
	}

	public String getLogin() {
		return login;
	}

	public void setLogin(String login) {
		this.login = login;
	}

	public String getPassword() {
		return password;
	}

	public void setPassword(String password) {
		this.password = password;
	}

	public String getUrl() {
		return url;
	}

	public void setUrl(String url) {
		this.url = url;
	}

	public String getPort() {
		return port;
	}

	public void setPort(String port) {
		this.port = port;
	}
	
	public String getRemotePbosFolderPath() {
		return remotePbosFolderPath;
	}

	public void setRemotePbosFolderPath(String remotePbosFolderPath) {
		this.remotePbosFolderPath = remotePbosFolderPath;
	}

	/* Business methodes */
	public void checkData() throws CheckException {
		if ("".equals(getUrl()) || getUrl() == null) {
			throw new CheckException("URL field is empty!");
		} 
		if ("".equals(getLogin()) || getLogin() == null) {
			throw new CheckException("Login field is empty!");
		} 
		if ((getPassword().equals("")) && !getLogin().equals("anonymous")) {
			throw new CheckException("Password field is empty!");
		}
		if ("".equals(getPort()) || getPort() == null) {
			throw new CheckException("Port field is empty!");
		}
		try {
			Integer.parseInt(port);
		} catch (NumberFormatException e) {
			throw new CheckException("Port is invalid!");
		}
	}
}
