package com.lea.domain;

import java.util.ArrayList;
import java.util.List;

import com.lea.exception.CheckException;


public class Magazine extends DomainObject implements java.lang.Comparable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 7905774720315816037L;
	private String caliber;
	private boolean ace;
	private List<String> listFaction = new ArrayList<String>();
	private String type;
	private  String category;
	private int slot;

	public Magazine(String classname) {
		setClassname(classname);
	}

	public Magazine() {
	}

	public boolean isAce() {
		return ace;
	}

	public String getCaliber() {
		return caliber;
	}

	public void setCaliber(String caliber) {
		this.caliber = caliber;
	}
	
	public List<String> getListFaction() {
		return listFaction;
	}

	public void setListFaction(List<String> listFaction) {
		this.listFaction = listFaction;
	}

	public void setAce(boolean ace) {
		this.ace = ace;
	}

	public boolean getAce() {
		return ace;
	}
	
	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	public void checkData() throws CheckException {
		if ("".equals(getClassname()) || "".equals(getName())) {
			throw new CheckException(
					"magazine classname or magazine name does not exist "
							+ getClassname() + " " + getName());
		}
		if (getClassname() == null || getName() == null) {
			throw new CheckException(
					"magazine classname or magazine name does not exist " + getClassname() + " " + getName());
		}
//		if (getImageIcon() == null
//				|| !getImageIcon().getDescription().equals(getClassname())) {
//			throw new CheckException(
//					"imageicon description must be equal to classname of magazine "
//							+ getClassname() + " "
//							+ getImageIcon().getDescription());
//		}
	}

	public String toString() {
		return ("classname = " + getClassname() + ",\n" + "name = " + getName()
				+ ",\n" + "weight = " + getAceWeight() + ",\n" + "caliber = "
				+ getCaliber() + ",\n" + "number of magazines = "
				+ "number of factions = " + getListFaction().size() + ",\n" + getAce());
	}
	
	public int compareTo(Object other) {
		String name =  ((Magazine) other).getName();
		int result = 1;
		if (name.compareToIgnoreCase(getName()) > 0)
			result = -1;
		else if (name.compareToIgnoreCase(getName()) == 0)
			result = 0;
		return result;
	}

	public String getCategory() {
		return category;
	}

	public void setCategory(String category) {
		this.category = category;
	}

	public int getSlot() {
		return slot;
	}

	public void setSlot(int slot) {
		this.slot = slot;
	}


}
