package com.lea.domain;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.TreeMap;
import java.util.TreeSet;

public class Mission implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 3652677111453252218L;
	private String missionName; // mission name given in ArmA 2 Editor
	private String missionDescription;
	private int numberPlayers;
	private Map<Integer,Unit> mapUnit = new TreeMap<Integer, Unit>();
	private List<Group> listGroup = new ArrayList<Group>();
	private Set<String> listMods = new TreeSet<String>();
	private List<Weapon> listItemsPreferences = new ArrayList<Weapon>();
	private List<Weapon> listOpticalsPreferences = new ArrayList<Weapon>();
	private List<Magazine> listEquipPreferences = new ArrayList<Magazine>();
	private String missionFileName; //folder name of the ArmA 2 mission
	private String missionPath; // mission.sqm file absolute path
	private String MissionFolderPath;//mission folder absolute path
	private int versionID;

	public String getName() {
		return missionName;
	}

	public void setName(String name) {
		this.missionName = name;
	}

	public String getDescription() {
		return missionDescription;
	}

	public void setDescription(String description) {
		this.missionDescription = description;
	}

	public int getNumberPlayers() {
		return numberPlayers;
	}

	public void setNumberPlayers(int numberPlayers) {
		this.numberPlayers = numberPlayers;
	}
	public Map<Integer, Unit> getMapUnit() {
		return mapUnit;
	}

	public void setMapUnit(Map<Integer, Unit> listUnit) {
		this.mapUnit = listUnit;
	}
	
	public String getMissionFileName() {
		return missionFileName;
	}

	public void setMissionFileName(String missionFileName) {
		this.missionFileName = missionFileName;
	}

	public String getMissionPath() {
		return missionPath;
	}

	public void setMissionPath(String missionPath) {
		this.missionPath = missionPath;
	}
	
	public void setMissionFolderPath(String missionFolderPath) {
		this.MissionFolderPath=missionFolderPath;
		
	}

	public String getMissionFolderPath() {
		return MissionFolderPath;
	}

	public Set<String> getListMods() {
		return listMods;
	}

	public void setListMods(Set<String> listMods) {
		this.listMods = listMods;
	}

	public List<Weapon> getListItemsPreferences() {
		return listItemsPreferences;
	}

	public void setListItemsPreferences(List<Weapon> listItemsPreferences) {
		this.listItemsPreferences = listItemsPreferences;
	}

	public List<Weapon> getListOpticalsPreferences() {
		return listOpticalsPreferences;
	}

	public void setListOpticalsPreferences(List<Weapon> listOpticalsPreferences) {
		this.listOpticalsPreferences = listOpticalsPreferences;
	}

	public void setListEquipPreferences(List<Magazine> listEquipPreferences) {
		this.listEquipPreferences = listEquipPreferences;
	}

	public List<Magazine> getListEquipPreferences() {
		return listEquipPreferences;
	}

	public int getVersionID() {
		return versionID;
	}

	public void setVersionID(int versionID) {
		this.versionID = versionID;
	}

	public List<Group> getListGroup() {
		return listGroup;
	}

	public void setListGroup(List<Group> listGroup) {
		this.listGroup = listGroup;
	}

}
