package com.lea.domain;

import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;

import com.lea.exception.CheckException;


public class Unit extends DomainObject {

	/**
	 * 
	 */
	private static final long serialVersionUID = 2920424330653711127L;
	private int id;
	private  boolean ace;
	private int numberPrimarySlot;
	private int numberSecondarySlot;
	private  String faction;
	private String side="";
	private String type="AI";
	private boolean vehicle;
	private boolean editable=true;
	private boolean leader=false;
	private int groupNumber;
	private String editorName="";
	private String editorDescription="Empty";
	private List<String> listMagazineClassname = new ArrayList<String>();
	private List<String> listWeaponClassname = new ArrayList<String>();
	private Weapon primaryWeaponLoadout = new Weapon();
	private Weapon secondaryWeaponLoadout = new Weapon();
	private Weapon backWeaponLoadout = new Weapon();
	private Weapon pistolLoadout= new Weapon();
	private Set<Weapon> opticalLoadout = new TreeSet<Weapon>();
	private List<Weapon> ruckWeaponLoadout = new ArrayList<Weapon>();
	private List<Magazine> ruckMagazineLoadout = new ArrayList<Magazine>();
	private Set<Weapon> itemLoadout = new TreeSet<Weapon>();
	private List<Magazine> primaryMagazineLoadout = new ArrayList<Magazine>();
	private List<Magazine> secondaryMagazineLoadout =  new ArrayList<Magazine>();
	private List<Magazine> firstAidMagazineLoadout =  new ArrayList<Magazine>();
	private Set<String> modsLoadout = new TreeSet<String>();
	private String unitProfileName;
	
	public Unit() {
		primaryWeaponLoadout.setClassname("");
		secondaryWeaponLoadout.setClassname("");
		backWeaponLoadout.setClassname("");
		pistolLoadout.setClassname("");
		setName("Unknown");
		setUnitProfileName("none");
		setNumberPrimarySlot(12);
		setNumberSecondarySlot(8);
		Magazine bandage = new Magazine("ACE_Bandage");
		bandage.setQuantity(0);
		Magazine morphine = new Magazine("ACE_Morphine");
		morphine.setQuantity(0);
		Magazine epinephrine = new Magazine("ACE_Epinephrine");
		epinephrine.setQuantity(0);
		Magazine medkit = new Magazine("ACE_Medkit");
		medkit.setQuantity(0);
		firstAidMagazineLoadout.add(bandage);
		firstAidMagazineLoadout.add(morphine);
		firstAidMagazineLoadout.add(epinephrine);
		firstAidMagazineLoadout.add(medkit);
	}

	public Unit(String unitClassname) {
		setClassname(unitClassname);
		primaryWeaponLoadout.setClassname("");
		secondaryWeaponLoadout.setClassname("");
		backWeaponLoadout.setClassname("");
		pistolLoadout.setClassname("");
		setName("Unknown");
		setUnitProfileName("none");
		setNumberPrimarySlot(12);
		setNumberSecondarySlot(8);
		Magazine bandage = new Magazine("ACE_Bandage");
		bandage.setQuantity(0);
		Magazine morphine = new Magazine("ACE_Morphine");
		morphine.setQuantity(0);
		Magazine epinephrine = new Magazine("ACE_Epinephrine");
		epinephrine.setQuantity(0);
		Magazine medkit = new Magazine("ACE_Medkit");
		medkit.setQuantity(0);
		firstAidMagazineLoadout.add(bandage);
		firstAidMagazineLoadout.add(morphine);
		firstAidMagazineLoadout.add(epinephrine);
		firstAidMagazineLoadout.add(medkit);
	}
	
	public String getSide() {
		return side;
	}

	public void setSide(String side) {
		this.side = side;
	}

	public int getGroupNumber() {
		return groupNumber;
	}

	public void setGroupNumber(int group) {
		this.groupNumber = group;
	}

	public String getEditorName() {
		return editorName;
	}

	public void setEditorName(String editorName) {
		this.editorName = editorName;
	}

	public String getEditorDescription() {
		return editorDescription;
	}

	public void setEditorDescription(String editorDescription) {
		this.editorDescription = editorDescription;
	}

	public List<String> getListMagazineClassname() {
		return listMagazineClassname;
	}

	public void setListMagazineClassname(List<String> listMagazineClassname) {
		this.listMagazineClassname = listMagazineClassname;
	}

	public List<String> getListWeaponClassname() {
		return listWeaponClassname;
	}

	public void setListWeaponClassname(List<String> listWeaponClassname) {
		this.listWeaponClassname = listWeaponClassname;
	}

	public boolean getAce() {
		return ace;
	}

	public void setAce(boolean ace) {
		this.ace = ace;
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}
	
	public Set<Weapon> getItemLoadout() {
		return itemLoadout;
	}

	public void setItemLoadout(Set<Weapon> itemLoadout) {
		this.itemLoadout = itemLoadout;
	}

	public List<Magazine> getPrimaryMagazineLoadout() {
		return primaryMagazineLoadout;
	}

	public void setPrimaryMagazineLoadout(List<Magazine> primaryMagazineLoadout) {
		this.primaryMagazineLoadout = primaryMagazineLoadout;
	}

	public List<Magazine> getSecondaryMagazineLoadout() {
		return secondaryMagazineLoadout;
	}

	public void setSecondaryMagazineLoadout(List<Magazine> secondaryMagazineLoadout) {
		this.secondaryMagazineLoadout = secondaryMagazineLoadout;
	}

	public boolean getLeader() {
		return leader;
	}

	public void setLeader(boolean leader) {
		this.leader = leader;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}
	
	public void checkData() throws CheckException {
		if ("".equals(getClassname()) || "".equals(getName())) {
			throw new CheckException(
					"Unit classname or display name does not exist "
							+ getClassname() + " " + getName());
		}
		if (getClassname() == null || getName() == null) {
			throw new CheckException(
					"Unit classname or display name does not exist "
							+ getClassname() + " " + getName());
		}
	}

	public void checkDataForMissionSQMParsing() throws CheckException {
		if ("".equals(getClassname()) || "".equals(getEditorName())) {
			throw new CheckException(
					"Unit classname or editor name does not exist "
							+ getClassname() + " " + getEditorName());
		}
		if (getClassname() == null || getEditorName() == null) {
			throw new CheckException(
					"Unit classname or editor name does not exist "
							+ getClassname() + " " + getEditorName());
		}
	}

	public void checkDataForSQFscript() throws CheckException {
		if ("".equals(getEditorName())) {
			throw new CheckException("Editor name does not exist "
					+ getEditorName());
		}
		if (getEditorName() == null) {
			throw new CheckException("Editor name does not exist "
					+ getEditorName());
		}
	}

	public String toString() {
		return ("classname = " + getClassname() + ",\n" + "name = " + getName()
				+ ",\n" + "EditorDescription = " + getEditorDescription() + ",\n" + "EditorName = "
				+ getEditorName() + ",\n" + "Id = "
				+ getId() + ",\n"
				+ "Side = " + getSide() + ",\n" + "Type = " + getType()+",\n" + "GroupNumber = "+ getGroupNumber());
	}

	public Weapon getPrimaryWeaponLoadout() {
		return primaryWeaponLoadout;
	}

	public void setPrimaryWeaponLoadout(Weapon primaryWeaponLoadout) {
		this.primaryWeaponLoadout = primaryWeaponLoadout;
	}

	public Weapon getSecondaryWeaponLoadout() {
		return secondaryWeaponLoadout;
	}

	public void setSecondaryWeaponLoadout(Weapon secondaryWeaponLoadout) {
		this.secondaryWeaponLoadout = secondaryWeaponLoadout;
	}

	public Weapon getBackWeaponLoadout() {
		return backWeaponLoadout;
	}

	public void setBackWeaponLoadout(Weapon backWeaponLoadout) {
		this.backWeaponLoadout = backWeaponLoadout;
	}

	public Weapon getPistolLoadout() {
		return pistolLoadout;
	}

	public void setPistolLoadout(Weapon pistolLoadout) {
		this.pistolLoadout = pistolLoadout;
	}

	public String getFaction() {
		return faction;
	}

	public void setFaction(String faction) {
		this.faction=faction;
	}

	public Set<String> getModsLoadout() {
		return modsLoadout;
	}

	public void setModsLoadout(Set<String> modsLoadout) {
		this.modsLoadout = modsLoadout;
	}

	public List<Weapon> getRuckWeaponLoadout() {
		return ruckWeaponLoadout;
	}
	
	public List<Magazine> getRuckMagazineLoadout() {
		return ruckMagazineLoadout;
	}

	public void setRuckWeaponLoadout(List<Weapon> ruckWeaponLoadout) {
		this.ruckWeaponLoadout = ruckWeaponLoadout;
	}
	
	public void setRuckMagazineLoadout(List<Magazine> ruckMagazineLoadout) {
		this.ruckMagazineLoadout = ruckMagazineLoadout;
	}

	public boolean isVehicle() {
		return vehicle;
	}

	public void setVehicle(boolean vehicle) {
		this.vehicle = vehicle;
	}

	public Set<Weapon> getOpticalLoadout() {
		return opticalLoadout;
	}

	public void setOpticalLoadout(Set<Weapon> opticalLoadout) {
		this.opticalLoadout = opticalLoadout;
	}

	public String getUnitProfileName() {
		return unitProfileName;
	}

	public void setUnitProfileName(String unitProfileName) {
		this.unitProfileName = unitProfileName;
	}

	public List<Magazine> getFirstAidMagazineLoadout() {
		return firstAidMagazineLoadout;
	}

	public void setFirstAidMagazineLoadout(List<Magazine> firstAidMagazineLoadout) {
		this.firstAidMagazineLoadout = firstAidMagazineLoadout;
	}

	public boolean isEditable() {
		return editable;
	}

	public void setEditable(boolean editable) {
		this.editable = editable;
	}

	public int getNumberPrimarySlot() {
		return numberPrimarySlot;
	}

	public void setNumberPrimarySlot(int numberPrimarySlot) {
		this.numberPrimarySlot = numberPrimarySlot;
	}

	public int getNumberSecondarySlot() {
		return numberSecondarySlot;
	}

	public void setNumberSecondarySlot(int numberSecondarySlot) {
		this.numberSecondarySlot = numberSecondarySlot;
	}
}
