package com.lea.domain;

import java.util.ArrayList;
import java.util.List;

import com.lea.exception.CheckException;


public class Weapon extends DomainObject implements java.lang.Comparable  {

	/**
	 * 
	 */
	private static final long serialVersionUID = 7893737808403941158L;
	private  String caliber;
	private  List<String> listMagazineClassname = new ArrayList<String>();
	private  List<String> listFaction = new ArrayList<String>();
	private  Boolean ace;
	private String type;

	public Weapon() {
	}

	public Weapon(String classname) {
		setClassname(classname);
	}

	public List<String> getListMagazineClassname() {
		return listMagazineClassname;
	}

	public void setListMagazineClassname(List<String> listMagazineClassname) {
		this.listMagazineClassname = listMagazineClassname;
	}

	public Boolean getAce() {
		return ace;
	}

	public void setAce(Boolean ace) {
		this.ace = ace;
	}

	public String getCaliber() {
		return caliber;
	}

	public void setCaliber(String caliber) {
		this.caliber = caliber;
	}

	public List<String> getListFaction() {
		return listFaction;
	}

	public void setListFaction(List<String> listFaction) {
		this.listFaction = listFaction;
	}

	public void checkData() throws CheckException {
		if ("".equals(getClassname()) || "".equals(getName())) {
			throw new CheckException(
					"weapon classname or weapon name does not exist "
							+ getClassname() + " " + getName());
		}
		if (getClassname() == null || getName() == null) {
			throw new CheckException("weapon classname or weapon name is null");
		}
	}

	public String toString() {
		return ("classname = " + getClassname() + ",\n" + "name = " + getName()
				+ ",\n" + "weight = " + getAceWeight() + ",\n" + "caliber = "
				+ getCaliber() + ",\n" + "number of magazines = "
				+ getListMagazineClassname().size() + ",\n"
				+ "number of factions = " + getListFaction().size() + ",\n"
				+ "ace = " + getAce() + ",\n");
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	public int compareTo(Object other) {
		String name =  ((Weapon) other).getName();
		int result = 1;
		if (name.compareToIgnoreCase(getName()) > 0)
			result = -1;
		else if (name.compareToIgnoreCase(getName()) == 0)
			result = 0;
		return result;
	}

}
