package com.lea.service;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Stack;
import java.util.StringTokenizer;

import com.lea.dao.AbstractCommonDAO;
import com.lea.dao.CommonDAO;


public class CommonService {

	private static final AbstractCommonDAO commonDAO = new CommonDAO();
	private static final int INT_NOVALUE = Integer.MAX_VALUE;
	private static final String FILE_MISSION_EXTENSION = ".lea.mission";
	private static final String FILE_PROFILE_EXTENSION = ".lea.profile";
	private static String WIKI = "http://www.sonsofexiled.fr/joomla/wiki/index.php/1._LEA:_Loadout_Editor_For_Arma_2_co_and_ACE_2";

	public void determineInstallationPath() {
		commonDAO.determineInstallationPath();
	}

	public String getInstallationPath() {
		return commonDAO.getInstallationPath();
	}
	
	public void setUserconfigLeaPath(String path){
		commonDAO.setUserConfigLeaPath(path);
	}
	
	public String getUserconfigLeaPath(){
		return commonDAO.getUserconfigLeaPath();
	}

	public Collection<String> getSelectedMods() {
		Collection<String> selectedMods = new ArrayList<String>();
		String listMods = commonDAO.getMods();
		StringTokenizer stringTokenizer = new StringTokenizer(listMods, ",");
		while (stringTokenizer.hasMoreTokens()) {
			selectedMods.add(stringTokenizer.nextToken());
		}
		return selectedMods;
	}

	public void setSelectedMods(Collection<String> listMods) {

		StringBuffer stringBuffer = new StringBuffer();

		for (String stg : listMods) {
			stringBuffer.append(stg);
			stringBuffer.append(",");
		}
		commonDAO.setMods(stringBuffer.toString());
	}
	
	public boolean isACESelected() {

		boolean response = true;
		String listMods = commonDAO.getMods();
		StringTokenizer stringTokenizer = new StringTokenizer(listMods, ",");
		while (stringTokenizer.hasMoreTokens()) {
			String mod = stringTokenizer.nextToken().toUpperCase();
			if (mod.equals("ACE")) {
				response = false;
			}
		}
		return response;
	}
	
	public boolean isACRESelected() {
		
		boolean response = true;
		String listMods = commonDAO.getMods();
		StringTokenizer stringTokenizer = new StringTokenizer(listMods, ",");
		while (stringTokenizer.hasMoreTokens()) {
			String mod = stringTokenizer.nextToken().toUpperCase();
			if (mod.equals("ACRE")) {
				response = false;
			}
		}
		return response;
	}
	
	public void setResentlyEditedMission(String missionFileName) {
		commonDAO.setTopStackEditedMission(missionFileName);
	}
	
	public void removeResentlyEditedMission(String missionFileName) {
		commonDAO.removeFromStackEditedMission(missionFileName);
	}
	
	public Stack<String> getResentlyEditedMissions() {
		return commonDAO.getStackEditedMission();
	}

	public String getMissionsFolderPath() {
		return commonDAO.getInstallationPath() + "/"
				+ commonDAO.MISSIONS_FOLDER;
	}

	public String getProfilesFolderPath() {
		return commonDAO.getInstallationPath() + "/"
				+ commonDAO.PROFILES_FOLDER;
	}

	public String getPbosFolderPath() {
		return commonDAO.getInstallationPath() + "/" 
				+ commonDAO.PBOS_FOLDER;
	}

	public static int intNoValue() {
		return INT_NOVALUE;
	}
	
	public String getFileMissionExtension(){
		return FILE_MISSION_EXTENSION;
	}
	
	public String getFileProfileExtension() {
		return FILE_PROFILE_EXTENSION;
	}

	public String getWiki() {
		return WIKI;
	}

}
