package com.lea.ui;

import java.util.ArrayList;
import java.util.Set;
import java.util.TreeSet;

import com.lea.controler.Observable2;
import com.lea.controler.Observateur2;


public class AddonsList implements Observable2 {

	private ArrayList<Observateur2> listObservateur = new ArrayList<Observateur2>();
	private Set<String> list = new TreeSet<String>();

	public void add(String addon){
		if (!addon.equals("")){
			list.add(addon);
		}
		updateObservateur();
	}
	
	public void remove(String addon){
		list.remove(addon);
		updateObservateur();
	}

	public void reset(){
		list.clear();
		updateObservateur();
	}
	
	public Set<String> getList(){
		return list;
	}
	
	@Override
	public void addObservateur(Observateur2 obs) {
		this.listObservateur.add(obs);
	}
	@Override
	public void delObservateur() {
		this.listObservateur = new ArrayList<Observateur2>();
	}
	@Override
	public void updateObservateur() {
		for (Observateur2 obs : this.listObservateur) {
			obs.update(this.list);
		}
	}
}
