package com.lea.ui;

import java.awt.Image;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.UnsupportedLookAndFeelException;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.TableColumn;

import com.lea.service.CommonService;
import com.lea.service.MagazineService;
import com.lea.service.WeaponService;

/**
 * This code was edited or generated using CloudGarden's Jigloo
 * SWT/Swing GUI Builder, which is free for non-commercial
 * use. If Jigloo is being used commercially (ie, by a corporation,
 * company or business for any purpose whatever) then you
 * should purchase a license for each developer using Jigloo.
 * Please visit www.cloudgarden.com for details.
 * Use of Jigloo implies acceptance of these licensing terms.
 * A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
 * THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
 * LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
 */
/**
 * Addons manager dialog.
 * 
 */

public class AddonsManagerPanel extends JDialog {

	private Facade facade;
	private JTable tableMods;
	private JScrollPane jScrollPane1;
	private JButton unselectAllButton;
	private JButton selectAllButton;
	private JLabel labelMods;
	private JButton okButton;
	private MyTableModel model;

	public AddonsManagerPanel(Facade facade) {
		super(facade.getMissionEditor(), "Addons Manager", true);

		this.facade = facade;
		setResizable(false);
		this.setLayout(null);
		this.setResizable(false);
		this.setSize(300, 396);
		Image icone = Toolkit
				.getDefaultToolkit()
				.getImage(
						java.lang.ClassLoader
								.getSystemResource("resources/pictures/system/lea.png"));
		setIconImage(icone);

		this.setLocation((int) facade.getMissionEditor().getLocation().getX()
				+ facade.getMissionEditor().getWidth() / 2 - this.getWidth()
				/ 2, (int) facade.getMissionEditor().getLocation().getY()
				+ facade.getMissionEditor().getHeight() / 2 - this.getHeight()
				/ 2);

		getContentPane().setLayout(null);

		{
			model = new MyTableModel();
			tableMods = new JTable(model);
			tableMods.setShowGrid(false);
			tableMods.setFillsViewportHeight(true);
			tableMods.setRowSelectionAllowed(true);
			tableMods.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			tableMods.setBounds(31, 49, 226, 221);
			tableMods.setBackground(new java.awt.Color(245, 245, 245));
			TableColumn col1 = tableMods.getColumnModel().getColumn(0);
			col1.setResizable(false);
			// col1.setPreferredWidth(5);
			TableColumn col2 = tableMods.getColumnModel().getColumn(1);
			col2.setResizable(false);
			// col2.setPreferredWidth(5);
		}
		{
			jScrollPane1 = new JScrollPane(tableMods);
			getContentPane().add(jScrollPane1);
			jScrollPane1.setBounds(26, 34, 242, 277);
			jScrollPane1.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));

		}
		{
			okButton = new JButton();
			getContentPane().add(okButton);
			okButton.setText("Close");
			okButton.setBounds(204, 323, 77, 30);
		}
		{
			labelMods = new JLabel();
			getContentPane().add(labelMods);
			labelMods.setText("Select addons to use in LEA");
			labelMods.setBounds(76, 11, 144, 15);
		}
		{
			selectAllButton = new JButton();
			getContentPane().add(selectAllButton);
			selectAllButton.setText("Select All");
			selectAllButton.setBounds(17, 323, 89, 30);
		}
		{
			unselectAllButton = new JButton();
			getContentPane().add(unselectAllButton);
			unselectAllButton.setText("Unselect All");
			unselectAllButton.setBounds(111, 323, 88, 30);
		}

		okButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				onClosePerformed();
			}
		});
		selectAllButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				onSelectAllPerformed();
			}
		});
		unselectAllButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				onUnselectAllPerformed();
			}
		});
		// Add Listeners
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				onClosePerformed();
			}
		});
		init();
	}

	private void init() {

		CommonService commonService = new CommonService();
		WeaponService weaponService = new WeaponService();
		MagazineService magazineService = new MagazineService();
		Set<String> availableModWeapons = weaponService.getAvailableMods();
		Set<String> availableModMagazines = magazineService.getAvailableMods();
		Collection<String> selectedMods = commonService.getSelectedMods();

		Set<String> listMods = new TreeSet<String>();
		for (String stg : availableModWeapons) {
			listMods.add(stg.toUpperCase());
		}

		for (String stg : availableModMagazines) {
			listMods.add(stg.toUpperCase());
		}

		model.setDataSize(listMods.size());
		Iterator<String> iter = listMods.iterator();
		int i = 0;
		while (iter.hasNext()) {
			String modName = iter.next();
			model.addRow(i, i);
			model.setValueAt(modName, i, 0);
			if (selectedMods.contains(modName)) {
				model.setValueAt(new Boolean(true), i, 1);
			} else {
				model.setValueAt(new Boolean(false), i, 1);
			}
			i++;
		}
	}

	class MyTableModel extends AbstractTableModel {
		private String[] columnNames = { "Addon", "          Selection", };
		private Object[][] data = {};

		public int getColumnCount() {
			return columnNames.length;
		}

		public int getRowCount() {
			return data.length;
		}

		public String getColumnName(int col) {
			return columnNames[col];
		}

		public Object getValueAt(int row, int col) {
			return data[row][col];
		}

		/*
		 * JTable uses this method to determine the default renderer/ editor for
		 * each cell. If we didn't implement this method, then the last column
		 * would contain text ("true"/"false"), rather than a check box.
		 */
		public Class getColumnClass(int c) {
			return getValueAt(0, c).getClass();
		}

		/*
		 * Don't need to implement this method unless your table's editable.
		 */
		public boolean isCellEditable(int row, int col) {
			// Note that the data/cell address is constant,
			// no matter where the cell appears onscreen.
			if (col < 1) {
				return false;
			} else {
				return true;
			}
		}

		/*
		 * Don't need to implement this method unless your table's data can
		 * change.
		 */
		public void setValueAt(Object value, int row, int col) {
			data[row][col] = value;
			fireTableCellUpdated(row, col);
		}

		public void addRow(int firstRow, int lastRow) {
			fireTableRowsInserted(firstRow, lastRow);
		}

		public void setDataSize(int numberRows) {
			data = new Object[numberRows][2];
		}

		public Object[][] getData() {
			return data;
		}

	}

	private void onClosePerformed() {
		CommonService commonService = new CommonService();
		Collection<String> listMods = new ArrayList<String>();
		for (int i = 0; i < model.getData().length; i++) {
			boolean value = (Boolean) model.getValueAt(i, 1);
			if (value == true) {
				String modName = (String) model.getValueAt(i, 0);
				listMods.add(modName);
			}
		}

		if (!listMods.contains("ACE")) {
			facade.setNoACE(true);
		} else {
			facade.setNoACE(false);
		}
		
		if (!listMods.contains("ACRE")) {
			facade.setNoACRE(true);
		} else {
			facade.setNoACRE(false);
		}

		commonService.setSelectedMods(listMods);
		dispose();
		facade.setFactionSelected(true);
		facade.getAmmoPanel().init();
		facade.setFactionSelected(false);
	}

	private void onSelectAllPerformed() {
		for (int i = 0; i < model.getData().length; i++) {
			model.setValueAt(new Boolean(true), i, 1);
		}
	}

	private void onUnselectAllPerformed() {
		for (int i = 0; i < model.getData().length; i++) {
			model.setValueAt(new Boolean(false), i, 1);
		}
	}
}
