package com.lea.ui;

import java.awt.Color;
import java.awt.Image;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.UnsupportedLookAndFeelException;

import com.lea.dto.UnitDTO;
import com.lea.exception.CheckException;
import com.lea.exception.FinderException;
import com.lea.exception.WritingException;
import com.lea.service.MissionService;



/**
 * This code was edited or generated using CloudGarden's Jigloo SWT/Swing GUI
 * Builder, which is free for non-commercial use. If Jigloo is being used
 * commercially (ie, by a corporation, company or business for any purpose
 * whatever) then you should purchase a license for each developer using Jigloo.
 * Please visit www.cloudgarden.com for details. Use of Jigloo implies
 * acceptance of these licensing terms. A COMMERCIAL LICENSE HAS NOT BEEN
 * PURCHASED FOR THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED LEGALLY FOR
 * ANY CORPORATE OR COMMERCIAL PURPOSE.
 */
public class AssignPanel extends JDialog {

	private Facade facade;
	private JButton buttonUnassign;
	private JButton buttonCancel;
	private JButton buttonAssign;
	private JTextField textFieldDescription;
	private JLabel labelDescription;
	private JLabel labelName;
	private JTextField textFieldName;

	public AssignPanel(Facade facade) {
		super(facade.getMissionEditor(), "Assign", true);

		this.facade = facade;
		setResizable(false);
		try {
			javax.swing.UIManager
					.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
		} catch (ClassNotFoundException e) {
		} catch (InstantiationException e) {
		} catch (IllegalAccessException e) {
		} catch (UnsupportedLookAndFeelException e) {
		}

		this.setLayout(null);
		this.setResizable(false);
		this.setSize(310, 165);
		Image icone = Toolkit
				.getDefaultToolkit()
				.getImage(
						java.lang.ClassLoader
								.getSystemResource("resources/pictures/system/lea.png"));
		setIconImage(icone);

		this.setLocation((int) facade.getMissionEditor().getLocation().getX()
				+ facade.getMissionEditor().getWidth() / 2 - this.getWidth()
				/ 2, (int) facade.getMissionEditor().getLocation().getY()
				+ facade.getMissionEditor().getHeight() / 2 - this.getHeight()
				/ 2);
		{
			textFieldName = new JTextField();
			getContentPane().add(textFieldName);
			textFieldName.setBounds(82, 20, 203, 23);
		}
		{
			labelName = new JLabel();
			getContentPane().add(labelName);
			labelName.setText("Name");
			labelName.setBounds(19, 20, 57, 23);
		}
		{
			labelDescription = new JLabel();
			getContentPane().add(labelDescription);
			labelDescription.setText("Description");
			labelDescription.setBounds(19, 60, 53, 22);
		}
		{
			textFieldDescription = new JTextField();
			getContentPane().add(textFieldDescription);
			textFieldDescription.setBounds(82, 59, 203, 23);
		}
		{
			buttonAssign = new JButton();
			getContentPane().add(buttonAssign);
			buttonAssign.setText("Assign");
			buttonAssign.setBounds(114, 98, 75, 23);
		}
		{
			buttonCancel = new JButton();
			getContentPane().add(buttonCancel);
			buttonCancel.setText("Cancel");
			buttonCancel.setBounds(199, 98, 75, 23);
		}
		{
			buttonUnassign = new JButton();
			getContentPane().add(buttonUnassign);
			buttonUnassign.setText("Unassign");
			buttonUnassign.setBounds(29, 98, 75, 23);
		}
		buttonCancel.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				menuExitPerformed();
			}
		});
		buttonAssign.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				menuAssignPerformed();
			}
		});
		buttonUnassign.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				menuUnassignPerformed();
			}
		});

		// Add Listeners
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				menuExitPerformed();
			}
		});
		init();
	}

	private void init() {
		MissionService missionService = new MissionService();
		try {
			UnitDTO unitDTO = missionService.loadUnit(facade.getId());
			String name = unitDTO.getEditorName();
			String description = unitDTO.getEditorDescription();
			textFieldName.setText(name);
			textFieldDescription.setText(description);
		} catch (FinderException e) {
			e.printStackTrace();
			JOptionPane.showMessageDialog(this, e.getMessage(), "Error",
					JOptionPane.ERROR_MESSAGE);
		} finally {
			this.dispose();
		}
	}

	private void menuAssignPerformed() {

		MissionService missionService = new MissionService();
		try {
			String name = textFieldName.getText();
			missionService.checkUnitEditorName(name,facade.getId());
			missionService.checkMissionSQMExists();
			assign();
			this.dispose();
			
		} catch (CheckException e) {
			//e.printStackTrace();
			JOptionPane.showMessageDialog(this, e.getMessage(), "Error",
					JOptionPane.WARNING_MESSAGE);
		}
	}

	private void menuUnassignPerformed() {

		MissionService missionService = new MissionService();
		try {
			missionService.checkMissionSQMExists();
			textFieldName.setText("not assigned");
			textFieldDescription.setText("Empty");
			facade.getLoadoutPanel().init();
			facade.getLoadoutPanel().initVisibilityPrimaryMagazinePanels();
			facade.getLoadoutPanel().initVisibilitySecondaryMagazinePanels();
			facade.getRuckandModsPanel().init();
			facade.getMissionEditor().saveUnitLoadout(facade.getId());
			missionService.saveUnitProfileName("none", facade.getId());
			missionService.setUnitEditable(true, facade.getId());
			facade.getMissionEditor().getCheckBoxEditable().setSelected(false);
			facade.getMissionEditor().getCheckBoxEditable().setForeground(Color.black);
			assign();
			this.dispose();
		} catch (CheckException e) {
			//e.printStackTrace();
			JOptionPane.showMessageDialog(this, e.getMessage(), "Error",
					JOptionPane.WARNING_MESSAGE);
		}
	}

	private void assign() {

		MissionService missionService = new MissionService();
		try {
			String name = textFieldName.getText();
			String description = textFieldDescription.getText();

			missionService.saveUnitEditorName(facade.getId(), name);
			missionService.saveEditorDescription(facade.getId(), description);
			facade.getMissionEditor().updateMissionSQM();
			missionService.saveMission();
			missionService.setUnitEditable(true, facade.getId());
			String type = this.facade.getMissionEditor()
					.getComboBoxTypeSelectedItem();
			String display = this.facade.getMissionEditor()
					.getComboBoxDisplayOptionsSelectedItem();
			facade.getMissionEditor().setLabelDescription(description);
			facade.getUnitsPanel().init();
			facade.getUnitsPanel().update(type, display);
		} catch (FinderException e) {
			e.printStackTrace();
			JOptionPane.showMessageDialog(this,
					"Fail to reassign name of unit(s).", "Error",
					JOptionPane.ERROR_MESSAGE);
		} catch (WritingException e) {
			e.printStackTrace();
			JOptionPane.showMessageDialog(this, e.getMessage(), "Error",
					JOptionPane.ERROR_MESSAGE);
		}
	}

	private void menuExitPerformed() {
		this.dispose();
	}
}
