package com.lea.ui;

import java.awt.Color;
import java.awt.Image;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Collection;

import javax.swing.JButton;

import javax.swing.ButtonGroup;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.JRadioButton;
import javax.swing.SwingUtilities;
import javax.swing.UnsupportedLookAndFeelException;

import com.lea.dto.UnitDTO;
import com.lea.exception.CheckException;
import com.lea.exception.FinderException;
import com.lea.exception.LoadingException;
import com.lea.exception.WritingException;
import com.lea.service.CommonService;
import com.lea.service.MissionService;



/**
 * This code was edited or generated using CloudGarden's Jigloo SWT/Swing GUI
 * Builder, which is free for non-commercial use. If Jigloo is being used
 * commercially (ie, by a corporation, company or business for any purpose
 * whatever) then you should purchase a license for each developer using Jigloo.
 * Please visit www.cloudgarden.com for details. Use of Jigloo implies
 * acceptance of these licensing terms. A COMMERCIAL LICENSE HAS NOT BEEN
 * PURCHASED FOR THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED LEGALLY FOR
 * ANY CORPORATE OR COMMERCIAL PURPOSE.
 */
public class AutoAssignPanel extends JDialog {

	private Facade facade;
	private JRadioButton radioButtonUnit;
	private JRadioButton radioButtonGroup;
	private JButton buttonUnAssign;
	private JButton buttonAssign;
	private JButton buttonCancel;
	private JRadioButton radioButtonSide;

	public AutoAssignPanel(Facade facade) {
		super(facade.getMissionEditor(), "Auto assign", true);

		this.facade = facade;
		setResizable(false);
		this.setLayout(null);
		this.setResizable(false);
		this.setSize(270, 125);
		Image icone = Toolkit
				.getDefaultToolkit()
				.getImage(
						java.lang.ClassLoader
								.getSystemResource("resources/pictures/system/lea.png"));
		setIconImage(icone);

		this.setLocation((int) facade.getMissionEditor().getLocation().getX()
				+ facade.getMissionEditor().getWidth() / 2 - this.getWidth()
				/ 2, (int) facade.getMissionEditor().getLocation().getY()
				+ facade.getMissionEditor().getHeight() / 2 - this.getHeight()
				/ 2);
		{
			radioButtonUnit = new JRadioButton();
			getContentPane().add(radioButtonUnit);
			radioButtonUnit.setText("This Unit");
			radioButtonUnit.setBounds(13, 14, 74, 23);
		}
		{
			radioButtonGroup = new JRadioButton();
			getContentPane().add(radioButtonGroup);
			radioButtonGroup.setText("This Group");
			radioButtonGroup.setBounds(89, 12, 77, 26);
		}
		{
			radioButtonSide = new JRadioButton();
			getContentPane().add(radioButtonSide);
			radioButtonSide.setText("This Side");
			radioButtonSide.setBounds(175, 12, 67, 27);
		}
		{
			buttonCancel = new JButton();
			getContentPane().add(buttonCancel);
			buttonCancel.setText("Cancel");
			buttonCancel.setBounds(180, 52, 75, 26);
		}
		{
			buttonAssign = new JButton();
			getContentPane().add(buttonAssign);
			buttonAssign.setText("Assign");
			buttonAssign.setBounds(95, 52, 75, 26);
		}
		{
			buttonUnAssign = new JButton();
			getContentPane().add(buttonUnAssign);
			buttonUnAssign.setText("Unassign");
			buttonUnAssign.setBounds(10, 52, 75, 26);
		}

		ButtonGroup buttonsGroupe = new ButtonGroup();
		buttonsGroupe.add(radioButtonUnit);
		buttonsGroupe.add(radioButtonGroup);
		buttonsGroupe.add(radioButtonSide);

		buttonCancel.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				menuExitPerformed();
			}
		});
		buttonAssign.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				onAssignPerformed();
			}
		});
		buttonUnAssign.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				onUnassignPerformed();
			}
		});
		// Add Listeners
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				menuExitPerformed();
			}
		});
		init();
	}

	private void init() {
		radioButtonUnit.setSelected(true);
	}

	private void menuExitPerformed() {
		this.dispose();
	}

	private void onAssignPerformed() {

		MissionService missionService = new MissionService();
		
		try {
			missionService.checkMissionSQMExists();
			missionService.saveMission();

			if (radioButtonUnit.isSelected()) {
				missionService.generateEditorName(facade.getId());
				missionService.setUnitEditable(true, facade.getId());
			} else if (radioButtonGroup.isSelected()) {
				UnitDTO uDTO = missionService.loadUnit(facade.getId());
				int groupNumber = uDTO.getGroupNumber();
				Collection<UnitDTO> unitsDTO = missionService.loadUnits(groupNumber);
				for (UnitDTO unitDTO : unitsDTO) {
					missionService.generateEditorName(unitDTO.getId());
					missionService.setUnitEditable(true, unitDTO.getId());
				}
			} else if (radioButtonSide.isSelected()) {
				UnitDTO uDTO = missionService.loadUnit(facade.getId());
				String side = uDTO.getSide();
				Collection<UnitDTO> unitsDTO = missionService.loadUnits(side);
				for (UnitDTO unitDTO : unitsDTO) {
					missionService.generateEditorName(unitDTO.getId());
					missionService.setUnitEditable(true, unitDTO.getId());
				}
			}
			facade.getMissionEditor().updateMissionSQM();
			missionService.saveMission();
			
			facade.getUnitsPanel().init();
			final String type = facade.getMissionEditor()
					.getComboBoxTypeSelectedItem();
			final String name = facade.getMissionEditor()
					.getComboBoxDisplayOptionsSelectedItem();
			facade.getUnitsPanel().update(type, name);
			this.dispose();
		} catch (FinderException e) {
			e.printStackTrace();
			JOptionPane.showMessageDialog(this,
					"Fail to reassign name of unit(s).", "Error",
					JOptionPane.ERROR_MESSAGE);
		} catch (WritingException e) {
			e.printStackTrace();
			JOptionPane.showMessageDialog(this, e.getMessage(), "Error",
					JOptionPane.ERROR_MESSAGE);
		} catch (CheckException e) {
			e.printStackTrace();
			JOptionPane.showMessageDialog(this, e.getMessage(), "Error",
					JOptionPane.WARNING_MESSAGE);
		} finally {
			facade.getMissionEditor().enableAutoAssign(false);
		}
	}

	private void onUnassignPerformed() {

		MissionService missionService = new MissionService();
		try {
			missionService.checkMissionSQMExists();

			if (radioButtonUnit.isSelected()) {
				missionService.saveUnitEditorName(facade.getId(),"not assigned");
				missionService.saveEditorDescription(facade.getId(), "Empty");
				missionService.setUnitEditable(true, facade.getId());
				facade.getLoadoutPanel().init();
				facade.getLoadoutPanel().initVisibilityPrimaryMagazinePanels();
				facade.getLoadoutPanel().initVisibilitySecondaryMagazinePanels();
				facade.getRuckandModsPanel().init();
				facade.getMissionEditor().getCheckBoxEditable().setSelected(false);
				facade.getMissionEditor().getCheckBoxEditable().setForeground(Color.black);
				missionService.saveUnitProfileName("none", facade.getId());
				facade.getMissionEditor().saveUnitLoadout(facade.getId());
			} else if (radioButtonGroup.isSelected()) {
				UnitDTO uDTO = missionService.loadUnit(facade.getId());
				int groupNumber = uDTO.getGroupNumber();
				Collection<UnitDTO> unitsDTO = missionService
						.loadUnits(groupNumber);
				for (UnitDTO unitDTO : unitsDTO) {
					missionService.saveUnitEditorName(unitDTO.getId(),"not assigned");
					missionService.saveEditorDescription(unitDTO.getId(), "Empty");
					missionService.setUnitEditable(true, unitDTO.getId());
					facade.getLoadoutPanel().init();
					facade.getLoadoutPanel().initVisibilityPrimaryMagazinePanels();
					facade.getLoadoutPanel().initVisibilitySecondaryMagazinePanels();
					facade.getRuckandModsPanel().init();
					facade.getMissionEditor().getCheckBoxEditable().setSelected(false);
					facade.getMissionEditor().getCheckBoxEditable().setForeground(Color.black);
					facade.getMissionEditor().saveUnitLoadout(unitDTO.getId());
					missionService.saveUnitProfileName("none", unitDTO.getId());
				}
			} else if (radioButtonSide.isSelected()) {
				UnitDTO uDTO = missionService.loadUnit(facade.getId());
				String side = uDTO.getSide();
				Collection<UnitDTO> unitsDTO = missionService.loadUnits(side);
				for (UnitDTO unitDTO : unitsDTO) {
					missionService.saveUnitEditorName(unitDTO.getId(),"not assigned");
					missionService.saveEditorDescription(unitDTO.getId(), "Empty");
					missionService.setUnitEditable(true,unitDTO.getId());
					facade.getLoadoutPanel().init();
					facade.getLoadoutPanel().initVisibilityPrimaryMagazinePanels();
					facade.getLoadoutPanel().initVisibilitySecondaryMagazinePanels();
					facade.getRuckandModsPanel().init();
					facade.getMissionEditor().getCheckBoxEditable().setSelected(false);
					facade.getMissionEditor().getCheckBoxEditable().setForeground(Color.black);
					facade.getMissionEditor().saveUnitLoadout(unitDTO.getId());
					missionService.saveUnitProfileName("none", unitDTO.getId());
				}
			}
			facade.getMissionEditor().updateMissionSQM();
			missionService.saveMission();
			facade.getUnitsPanel().init();
			final String type = facade.getMissionEditor().getComboBoxTypeSelectedItem();
			final String name = facade.getMissionEditor()
					.getComboBoxDisplayOptionsSelectedItem();
			facade.getUnitsPanel().update(type, name);
			this.dispose();
		} catch (FinderException e) {
			e.printStackTrace();
			JOptionPane.showMessageDialog(this,
					"Fail to reassign name of unit(s).", "Error",
					JOptionPane.ERROR_MESSAGE);
		} catch (WritingException e) {
			e.printStackTrace();
			JOptionPane.showMessageDialog(this, e.getMessage(), "Error",
					JOptionPane.ERROR_MESSAGE);
		} catch (CheckException e) {
			e.printStackTrace();
			JOptionPane.showMessageDialog(this, e.getMessage(), "Error",
					JOptionPane.WARNING_MESSAGE);
		} finally {
			facade.getMissionEditor().enableAutoAssign(false);
		}
	}
}
