package com.lea.ui;

import java.awt.Image;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.File;
import java.util.Locale;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JProgressBar;
import javax.swing.JTextField;
import javax.swing.UnsupportedLookAndFeelException;
import javax.swing.filechooser.FileFilter;

import com.lea.ui.mission.ExtensionFilter;
import com.lea.ui.mission.PboLoader;


/**
 * This code was edited or generated using CloudGarden's Jigloo SWT/Swing GUI
 * Builder, which is free for non-commercial use. If Jigloo is being used
 * commercially (ie, by a corporation, company or business for any purpose
 * whatever) then you should purchase a license for each developer using Jigloo.
 * Please visit www.cloudgarden.com for details. Use of Jigloo implies
 * acceptance of these licensing terms. A COMMERCIAL LICENSE HAS NOT BEEN
 * PURCHASED FOR THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED LEGALLY FOR
 * ANY CORPORATE OR COMMERCIAL PURPOSE.
 */
public class ExtractPBOPanel extends JDialog {

	private Facade facade;
	private JCheckBox checkBoxImportMissionSQM;
	private JButton buttonSource;
	private JButton buttonCancel;
	private JButton buttonExtract;
	private JButton buttonDestination;
	private JTextField textFieldDestination;
	private JLabel labelDestination;
	private JTextField textFieldSource;
	private JLabel labelSource;
	private File sourceFile, destinationFile;

	public ExtractPBOPanel(Facade facade) {
		super(facade.getMissionEditor(), "Extract mission from .pbo", true);

		this.facade = facade;
		getContentPane().setLayout(null);
		setResizable(false);
		this.setSize(320, 240);

		this.setLocation((int) facade.getMissionEditor().getLocation().getX()
				+ facade.getMissionEditor().getWidth() / 2 - this.getWidth()
				/ 2, (int) facade.getMissionEditor().getLocation().getY()
				+ facade.getMissionEditor().getHeight() / 2 - this.getHeight()
				/ 2);

		Image icone = Toolkit
				.getDefaultToolkit()
				.getImage(
						java.lang.ClassLoader
								.getSystemResource("resources/pictures/system/lea.png"));
		setIconImage(icone);

		{
			labelSource = new JLabel();
			getContentPane().add(labelSource);
			labelSource.setText("Source file (.pbo)");
			labelSource.setBounds(24, 18, 180, 19);
		}
		{
			textFieldSource = new JTextField();
			getContentPane().add(textFieldSource);
			textFieldSource.setBounds(24, 37, 180, 22);
		}
		{
			labelDestination = new JLabel();
			getContentPane().add(labelDestination);
			labelDestination.setText("Destination folder");
			labelDestination.setBounds(24, 73, 180, 22);
		}
		{
			textFieldDestination = new JTextField();
			getContentPane().add(textFieldDestination);
			textFieldDestination.setBounds(24, 94, 180, 22);
		}
		{
			checkBoxImportMissionSQM = new JCheckBox();
			getContentPane().add(checkBoxImportMissionSQM);
			checkBoxImportMissionSQM.setText("Import mission.sqm into editor");
			checkBoxImportMissionSQM.setBounds(24, 133, 190, 23);
		}
		{
			buttonSource = new JButton();
			getContentPane().add(buttonSource);
			buttonSource.setText("select");
			buttonSource.setBounds(224, 34, 67, 27);
		}
		{
			buttonDestination = new JButton();
			getContentPane().add(buttonDestination);
			buttonDestination.setText("select");
			buttonDestination.setBounds(224, 92, 67, 27);
		}
		{
			buttonExtract = new JButton();
			getContentPane().add(buttonExtract);
			buttonExtract.setText("Extract");
			buttonExtract.setBounds(224, 168, 67, 27);
		}
		{
			buttonCancel = new JButton();
			getContentPane().add(buttonCancel);
			buttonCancel.setText("Cancel");
			buttonCancel.setBounds(137, 168, 67, 27);
		}
		// Add Listeners
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				menuExitPerformed();
			}
		});
		buttonSource.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				onbuttonSourceSelected();
			}
		});
		buttonDestination.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				onbuttonDestinationSelected();
			}
		});
		buttonExtract.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				onbuttonExtractSelected();
			}
		});
		buttonCancel.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				menuExitPerformed();
			}
		});
	}

	private void onbuttonExtractSelected() {
		if (sourceFile == null) {
			JOptionPane.showMessageDialog(this, "Source field is empty.",
					"Error", JOptionPane.WARNING_MESSAGE);
		} else if (destinationFile == null) {
			JOptionPane.showMessageDialog(this, "Destination field is empty.",
					"Error", JOptionPane.WARNING_MESSAGE);
		} else if (sourceFile != null && destinationFile != null) {
			JProgressBar progressBar = facade.getMissionEditor().getJProgressBarEditor();
			PboLoader pboLoader = new PboLoader(facade, "extract", progressBar,checkBoxImportMissionSQM,sourceFile,destinationFile);
			pboLoader.start();
			this.dispose();
			facade.getMissionEditor().getStatus().setText("Ready");
		}
	}

	private void onbuttonSourceSelected() {
		JFileChooser fc = new JFileChooser();
		FileFilter currentFileFilter = fc.getFileFilter();
		if (currentFileFilter != null) {
			fc.removeChoosableFileFilter(currentFileFilter);
		}
		FileFilter typeSQMMission = new ExtensionFilter(
				"ArmA 2 archive (.pbo)", ".pbo");
		fc.addChoosableFileFilter(typeSQMMission);

		fc.setLocale(Locale.ENGLISH);
		int returnVal = fc.showOpenDialog(ExtractPBOPanel.this);

		if (returnVal == JFileChooser.APPROVE_OPTION) {
			sourceFile = fc.getSelectedFile();
			System.out.println(sourceFile.getAbsolutePath());
			textFieldSource.setText(sourceFile.getAbsolutePath());
		}
	}

	private void onbuttonDestinationSelected() {
		JFileChooser fc = new JFileChooser();
		fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		fc.setLocale(Locale.ENGLISH);
		int returnVal = fc.showOpenDialog(ExtractPBOPanel.this);

		if (returnVal == JFileChooser.APPROVE_OPTION) {
			destinationFile = fc.getSelectedFile();
			System.out.println(destinationFile.getAbsolutePath());
			textFieldDestination.setText(destinationFile.getAbsolutePath());
		}
	}

	private void menuExitPerformed() {
		this.dispose();
		facade.getMissionEditor().getStatus().setText("Ready");
	}
}
