package com.lea.ui;


import com.lea.ui.mission.AmmoPanel;
import com.lea.ui.mission.LoadoutACEPanel;
import com.lea.ui.mission.MissionEditor;
import com.lea.ui.mission.RuckandModsPanel;
import com.lea.ui.mission.UnitsPanel;
import com.lea.ui.profile.ProfilesEditor;
import com.lea.ui.profile.ProfilesPanel;


/**
 * This class is the common link between all views.
 *
 */

public class Facade {

	private MissionEditor missionEditor;
	private UnitsPanel unitsPanel;
	private AmmoPanel ammoPanel;
	private LoadoutACEPanel loadoutPanel;
	private RuckandModsPanel ruckandModsPanel;
	private ProfilesPanel profilesPanel;
	private ProfilesEditor profilesEditor;
	
	/*  true if ACE mod is not selected in addon manager */
	private boolean noACE;
	
	/*  true if ACRE mod is not selected in addon manager */
	private boolean noACRE;
	
	/* save state */
	private boolean toBeSaved;
	
	/* a faction is selected in combobox faction filter*/
	private boolean factionSelected;

	/* a ruck is open or unit is vehicle kind of */
	private boolean ruckOpened;
	
	/* updating of loadout is enable  */
	private boolean enableUpdate;
	
	/* the button unit/vehicle is pushed */
	private boolean bottonVehiclePushed;
	
	/* the id of a current unit */
	private int id;
	
	/* the unit is vehicle kind of */
	private boolean vehicle;
	
	/* the profile editor is open */
	private boolean profileEditMode;
	
	/* the profile name of a profile*/
	private String profileName;
	
	/* non assigned units are hidden */
	private boolean hideNonAssignedUnits;
	
	public Facade(){
	}
	
	/*  Set views */
	public void setMissionEditor(MissionEditor missionEditor){
		this.missionEditor=missionEditor;
	}
	
	public void setUnitsPanel(UnitsPanel unitsPanel){
		this.unitsPanel=unitsPanel;
	}
	
	public void setAmmoPanel(AmmoPanel ammoPanel){
		this.ammoPanel=ammoPanel;
	}
	
	public void setLoadoutPanel(LoadoutACEPanel loadoutPanel){
		this.loadoutPanel=loadoutPanel;
	}
	
	public void setRuckandModsPanel(RuckandModsPanel ruckandModsPanel){
		this.ruckandModsPanel=ruckandModsPanel;
	}

	public void setProfilesPanel(ProfilesPanel profilesPanel) {
		 this.profilesPanel= profilesPanel;	
	}
	
	public void setProfilesEditor(ProfilesEditor profilesEditor) {
		this.profilesEditor=profilesEditor;
	}
	
	/*  Get views  */
	public MissionEditor getMissionEditor() {
		return missionEditor;
	}
	
	public UnitsPanel getUnitsPanel() {
		return unitsPanel;
	}

	public AmmoPanel getAmmoPanel() {
		return ammoPanel;
	}

	public LoadoutACEPanel getLoadoutPanel() {
		return loadoutPanel;
	}

	public RuckandModsPanel getRuckandModsPanel() {
		return ruckandModsPanel;
	}
	
	public ProfilesPanel getProfilesPanel() {
		return profilesPanel;
	}
	
	public ProfilesEditor getProfilesEditor() {
		return profilesEditor;
	}
	
	/* Working variables */
	public String getProfileName() {
		return profileName;
	}
	public void setProfileName(String profileName) {
		this.profileName = profileName;
	}

	public boolean isToBeSaved() {
		return toBeSaved;
	}

	public void setToBeSaved(boolean toBeSaved) {
		this.toBeSaved = toBeSaved;
	}

	public void setFactionSelected(boolean value) {
		this.factionSelected=value;
	}

	public boolean isFactionSelected() {
		return factionSelected;
	}

	public boolean isRuckOpened() {
		return ruckOpened;
	}

	public void setRuckOpened(boolean ruckOpened) {
		this.ruckOpened = ruckOpened;
	}

	public void setEnableUpdate(boolean value) {
		this.enableUpdate=value;
	}
	public boolean isEnableUpdate() {
		return enableUpdate;
	}

	public boolean isbuttonVehiclePushed() {
		return bottonVehiclePushed;
	}

	public void setBottonVehiclePusched(boolean bottonVehiclePusched) {
		this.bottonVehiclePushed = bottonVehiclePusched;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public boolean isVehicle() {
		return vehicle;
	}

	public void setVehicle(boolean vehicle) {
		this.vehicle = vehicle;
	}

	public boolean isProfileEditMode() {
		return profileEditMode;
	}

	public void setProfileEditMode(boolean profileEditMode) {
		this.profileEditMode = profileEditMode;
	}

	public void setHideNonAssignedUnits(boolean value) {
		this.hideNonAssignedUnits= value;
	}

	public boolean isHideNonAssignedUnits() {
		return this.hideNonAssignedUnits;
	}

	public boolean isBottonVehiclePushed() {
		return bottonVehiclePushed;
	}

	public void setBottonVehiclePushed(boolean bottonVehiclePushed) {
		this.bottonVehiclePushed = bottonVehiclePushed;
	}

	public boolean isNoACE() {
		return noACE;
	}

	public void setNoACE(boolean noACE) {
		this.noACE = noACE;
	}

	public boolean isNoACRE() {
		return noACRE;
	}

	public void setNoACRE(boolean noACRE) {
		this.noACRE = noACRE;
	}
}
