package com.lea.ui;

import java.awt.Color;
import java.awt.Image;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Hashtable;
import java.util.Set;
import javax.swing.BorderFactory;

import javax.swing.DefaultComboBoxModel;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ListModel;
import javax.swing.UIManager;

import com.lea.service.MissionService;

/**
 * This code was edited or generated using CloudGarden's Jigloo SWT/Swing GUI
 * Builder, which is free for non-commercial use. If Jigloo is being used
 * commercially (ie, by a corporation, company or business for any purpose
 * whatever) then you should purchase a license for each developer using Jigloo.
 * Please visit www.cloudgarden.com for details. Use of Jigloo implies
 * acceptance of these licensing terms. A COMMERCIAL LICENSE HAS NOT BEEN
 * PURCHASED FOR THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED LEGALLY FOR
 * ANY CORPORATE OR COMMERCIAL PURPOSE.
 */
public class RequiredAddonsPanel extends JDialog {

	private Facade facade;
	private JLabel labelRequiredAddons;
	private JScrollPane jScrollPane1;
	private JButton buttonOK;
	private JList modsList;

	public RequiredAddonsPanel(Facade facade) {
		super(facade.getMissionEditor(), "Required Addons", true);
		this.facade = facade;
		setResizable(false);
		this.setLayout(null);
		this.setResizable(false);
		this.setSize(200, 220);
		Image icone = Toolkit
				.getDefaultToolkit()
				.getImage(
						java.lang.ClassLoader
								.getSystemResource("resources/pictures/system/lea.png"));
		setIconImage(icone);

		this.setLocation((int) facade.getMissionEditor().getLocation().getX()
				+ facade.getMissionEditor().getWidth() / 2 - this.getWidth()
				/ 2, (int) facade.getMissionEditor().getLocation().getY()
				+ facade.getMissionEditor().getHeight() / 2 - this.getHeight()
				/ 2);

		getContentPane().setLayout(null);
		{
			labelRequiredAddons = new JLabel();
			getContentPane().add(labelRequiredAddons);
			labelRequiredAddons.setText("Required addons for the mission");
			labelRequiredAddons.setBounds(12, 12, 182, 18);
		}
		{
			jScrollPane1 = new JScrollPane();
			getContentPane().add(jScrollPane1);
			jScrollPane1.setBounds(31, 38, 133, 102);
			jScrollPane1.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			{
				modsList = new JList();
				jScrollPane1.setViewportView(modsList);
				Hashtable properties = UIManager.getDefaults();
				Object value = properties.get("Panel.background");
				modsList.setBackground((Color) value);
			}
		}
		{
			buttonOK = new JButton();
			getContentPane().add(buttonOK);
			buttonOK.setText("OK");
			buttonOK.setBounds(67, 152, 60, 27);
		}
		buttonOK.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				menuExitPerformed();
			}
		});
		// Add Listeners
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				menuExitPerformed();
			}
		});
		init();
	}

	private void init() {
		
		MissionService missionService = new MissionService();
		missionService.saveMissionListMods(facade.isNoACE());
		Set<String> listMods = missionService.getListMods();
		String[] panels = new String[listMods.size()];
		int i = 0;
		for (String stg : listMods) {
			if (!stg.equals("")) {
				panels[i] = "+" + stg;
			}
			i++;
		}
		modsList.clearSelection();
		int numberLigneShown = i;
		if (numberLigneShown==0){
			panels = new String[1];
			panels[0] = "+ no one required";
			modsList.setListData(panels);
		}else {
			modsList.setListData(panels);
			modsList.setVisibleRowCount(numberLigneShown);
			modsList.setPreferredSize(modsList.getPreferredScrollableViewportSize());
			jScrollPane1.updateUI();
		}
	}

	private void menuExitPerformed() {
		this.dispose();
	}

}
