package com.lea.ui.ftp;

import java.awt.BorderLayout;
import java.awt.Image;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.File;
import java.util.Arrays;
import java.util.List;

import javax.swing.ComboBoxModel;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPasswordField;
import javax.swing.JTextField;
import javax.swing.UnsupportedLookAndFeelException;

import com.lea.dto.FtpDTO;
import com.lea.exception.CheckException;
import com.lea.exception.FtpException;
import com.lea.exception.LoadingException;
import com.lea.service.CommonService;
import com.lea.service.FtpService;
import com.lea.ui.Facade;
import com.lea.ui.ftp.filemanager.JFileManager;



/**
 * This code was edited or generated using CloudGarden's Jigloo
 * SWT/Swing GUI Builder, which is free for non-commercial
 * use. If Jigloo is being used commercially (ie, by a corporation,
 * company or business for any purpose whatever) then you
 * should purchase a license for each developer using Jigloo.
 * Please visit www.cloudgarden.com for details.
 * Use of Jigloo implies acceptance of these licensing terms.
 * A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
 * THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
 * LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
 */
/**
 * FTP logger dialog.
 * 
 */

public class FtpLoggerPanel extends JDialog {

	private JLabel labelAutoConfigURL;
	private JLabel labelHost;
	private JLabel laberServer;
	private JLabel jLabel2;
	private JTextField textFieldRemotePbosPath;
	private JLabel jLabel1;
	private JTextField textFieldRemoteProfilesPath;
	private JLabel labelMissionsPath;
	private JLabel labelPort;
	private JTextField textFieldRemoteMissionsPath;
	private JCheckBox checkBoxAnonymous;
	private JTextField textFieldLogin;
	private JTextField textFieldPort;
	private JButton buttonDelete;
	private JLabel labelLogin;
	private JComboBox comboxHistory;
	private JLabel labelHistory;
	private JButton buttonClose;
	private JButton buttonConnect;
	private JButton buttonImport;
	private JTextField textFieldHost;
	private JTextField textFieldAutoConfig;
	private JLabel labelPassword;
	private JPasswordField passwordField;
	private Facade facade;
	private char[] password;
	private String[] tabFtpIdentifiers;
	private String mode;
	private List<FtpDTO> ftpDTOs;

	public FtpLoggerPanel(Facade facade, String mode) {

		this.facade = facade;
		this.mode = mode;
		this.setSize(415, 395);
		this.setLayout(null);
		this.setTitle("Transfert");
		setResizable(false);

		this.setLocation((int) facade.getMissionEditor().getLocation().getX()
				+ facade.getMissionEditor().getWidth() / 2 - this.getWidth()
				/ 2, (int) facade.getMissionEditor().getLocation().getY()
				+ facade.getMissionEditor().getHeight() / 2 - this.getHeight()
				/ 2);

		Image icone = Toolkit
				.getDefaultToolkit()
				.getImage(
						java.lang.ClassLoader
								.getSystemResource("resources/pictures/system/lea.png"));
		setIconImage(icone);

		{
			labelAutoConfigURL = new JLabel();
			getContentPane().add(labelAutoConfigURL, BorderLayout.CENTER);
			labelAutoConfigURL.setBounds(17, 40, 65, 24);
		}
		{
			labelHost = new JLabel();
			getContentPane().add(labelHost);
			labelHost.setBounds(19, 108, 59, 25);
			labelHost.setText("Host or url");
		}
		{
			labelPassword = new JLabel("Password");
			getContentPane().add(labelPassword);
			labelPassword.setText("Password");
			labelPassword.setBounds(19, 177, 57, 24);
			passwordField = new JPasswordField();
			getContentPane().add(passwordField);
			passwordField.setBounds(86, 177, 207, 24);

		}
		{
			textFieldAutoConfig = new JTextField();
			getContentPane().add(textFieldAutoConfig);
			textFieldAutoConfig.setBounds(86, 41, 207, 23);
		}
		{
			textFieldHost = new JTextField();
			getContentPane().add(textFieldHost);
			textFieldHost.setBounds(88, 108, 205, 24);
			textFieldHost.setText("ftp://");
		}
		{
			buttonImport = new JButton();
			getContentPane().add(buttonImport);
			buttonImport.setText("Import");
			buttonImport.setBounds(309, 40, 80, 25);
		}
		{
			buttonConnect = new JButton();
			getContentPane().add(buttonConnect);
			buttonConnect.setText("Connect");
			buttonConnect.setBounds(217, 320, 76, 28);
		}
		{
			buttonClose = new JButton();
			getContentPane().add(buttonClose);
			buttonClose.setText("Close");
			buttonClose.setBounds(309, 320, 80, 28);
		}
		{
			laberServer = new JLabel();
			getContentPane().add(laberServer);
			laberServer.setText("Connect to FTP Server");
			laberServer.setBounds(133, 11, 118, 18);
		}
		{
			labelLogin = new JLabel("Login");
			getContentPane().add(labelLogin);
			labelLogin.setBounds(19, 142, 63, 24);
		}
		{
			labelHistory = new JLabel();
			getContentPane().add(labelHistory);
			labelHistory.setText("History");
			labelHistory.setBounds(19, 76, 63, 22);
		}
		{
			ComboBoxModel comboxHistoryModel = new DefaultComboBoxModel(
					new String[] {});
			comboxHistory = new JComboBox();
			getContentPane().add(comboxHistory);
			comboxHistory.setModel(comboxHistoryModel);
			comboxHistory.setBounds(86, 75, 207, 24);
		}
		{
			buttonDelete = new JButton();
			getContentPane().add(buttonDelete);
			buttonDelete.setText("remove");
			buttonDelete.setBounds(309, 73, 80, 27);
		}
		{
			labelPort = new JLabel();
			getContentPane().add(labelPort);
			labelPort.setText("Port");
			labelPort.setBounds(319, 110, 40, 20);
		}
		{
			textFieldPort = new JTextField();
			getContentPane().add(textFieldPort);
			textFieldPort.setText("21");
			textFieldPort.setBounds(346, 110, 37, 22);
		}
		{
			textFieldLogin = new JTextField();
			getContentPane().add(textFieldLogin);
			textFieldLogin.setBounds(86, 143, 207, 23);
		}
		{
			checkBoxAnonymous = new JCheckBox();
			getContentPane().add(checkBoxAnonymous);
			checkBoxAnonymous.setText("Anonymous");
			checkBoxAnonymous.setBounds(309, 143, 87, 20);
		}
		{
			textFieldRemoteMissionsPath = new JTextField();
			getContentPane().add(textFieldRemoteMissionsPath);
			textFieldRemoteMissionsPath.setBounds(86, 212, 207, 24);
		}
		{
			labelMissionsPath = new JLabel();
			getContentPane().add(labelMissionsPath);
			labelMissionsPath.setText("/../missions");
			labelMissionsPath.setBounds(19, 215, 57, 19);
		}
		{
			textFieldRemoteProfilesPath = new JTextField();
			getContentPane().add(textFieldRemoteProfilesPath);
			textFieldRemoteProfilesPath.setBounds(86, 247, 207, 24);
		}
		{
			jLabel1 = new JLabel();
			getContentPane().add(jLabel1);
			jLabel1.setText("/../profiles");
			jLabel1.setBounds(19, 251, 63, 17);
		}
		{
			textFieldRemotePbosPath = new JTextField();
			getContentPane().add(textFieldRemotePbosPath);
			textFieldRemotePbosPath.setBounds(86, 282, 207, 24);
		}
		{
			jLabel2 = new JLabel();
			getContentPane().add(jLabel2);
			jLabel2.setText("/../pbos");
			jLabel2.setBounds(19, 283, 57, 23);
		}
		buttonConnect.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				connectButtonPerformed();
			}
		});
		buttonClose.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				closeButtonPerformed();
			}
		});
		checkBoxAnonymous.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				checkBoxAnonymousPerformed();
			}
		});
		// Add Listeners
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				menuExitPerformed();
			}
		});
		buttonImport.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				buttonImportPerformed();
			}
		});
		buttonDelete.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				buttonDeletePerformed();
			}
		});
		comboxHistory.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				comboboxHistorySelectionPerformed();
			}
		});
		init();
	}

	public void init() {
		FtpService ftpService = new FtpService();
		ftpDTOs = (List<FtpDTO>) ftpService.getFtpHistory();
		if (ftpDTOs != null) {
			tabFtpIdentifiers = new String[ftpDTOs.size() + 1];
			tabFtpIdentifiers[0] = "";
			int i = 1;
			for (FtpDTO ftpdto : ftpDTOs) {
				String identifier = "ftp://" + ftpdto.getLogin() + "@"
						+ ftpdto.getUrl() + ":" + ftpdto.getPort();
				tabFtpIdentifiers[i] = identifier;
				i++;
			}
			ComboBoxModel model = new DefaultComboBoxModel(tabFtpIdentifiers);
			comboxHistory.setModel(model);
			comboxHistory.setSelectedIndex(0);
			comboxHistory.updateUI();
		}
	}

	private void comboboxHistorySelectionPerformed() {
		int index = comboxHistory.getSelectedIndex();
		if (index == 0) {
			textFieldHost.setText("");
			textFieldPort.setText("");
			textFieldLogin.setText("");
			passwordField.setText("");
			textFieldRemoteMissionsPath.setText("");
			textFieldRemoteProfilesPath.setText("");
			textFieldAutoConfig.setText("");
			textFieldRemotePbosPath.setText("");
		} else {
			textFieldHost.setText(ftpDTOs.get(index - 1).getUrl());
			textFieldPort.setText(ftpDTOs.get(index - 1).getPort());
			textFieldLogin.setText(ftpDTOs.get(index - 1).getLogin());
			passwordField.setText(ftpDTOs.get(index - 1).getPassword());
			textFieldRemoteMissionsPath.setText(ftpDTOs.get(index - 1)
					.getRemoteMissionsFolderPath());
			textFieldRemoteProfilesPath.setText(ftpDTOs.get(index - 1)
					.getRemoteProfilesFolderPath());
			textFieldRemotePbosPath.setText(ftpDTOs.get(index - 1)
					.getRemotePbosFolderPath());
			textFieldAutoConfig.setText("");
		}
	}

	private void connectButtonPerformed() {

		String url = textFieldHost.getText().replace("ftp://", "").trim();
		String port = textFieldPort.getText().trim();
		String login = textFieldLogin.getText().trim();
		password = passwordField.getPassword();
		String pass = "";
		for (int i = 0; i < password.length; i++) {
			pass = pass + password[i];
		}
		String remoteMissionsPath = textFieldRemoteMissionsPath.getText()
				.trim();
		String remoteProfilesPath = textFieldRemoteProfilesPath.getText()
				.trim();
		String remotePbosPath = textFieldRemotePbosPath.getText().trim();

		try {
			FtpService ftpService = new FtpService();
			ftpService.checkData(url, port, login, pass);
			ftpService.connect(url, port, login, pass);
			ftpService.updateFtpHistory(url, port, login, pass,
					remoteMissionsPath, remoteProfilesPath, remotePbosPath);

			String localPath = "";
			String remotePath = "";
			CommonService commonService = new CommonService();
			if (mode.equals("mission")) {
				localPath = commonService.getMissionsFolderPath();
				remotePath = remoteMissionsPath;
			} 
			else if (mode.equals("profile")){
				localPath = commonService.getProfilesFolderPath();
				remotePath = remoteProfilesPath;
			}
			else if (mode.equals("pbo")){
				localPath = commonService.getPbosFolderPath();
				remotePath = remotePbosPath;
			}
			JFileManager jFileManager = new JFileManager(localPath, remotePath);
			this.dispose();
		} catch (CheckException e) {
			JOptionPane.showMessageDialog(this, e.getMessage(), "Error",
					JOptionPane.WARNING_MESSAGE);
		} catch (FtpException e) {
			JOptionPane.showMessageDialog(this, e.getMessage(), "Error",
					JOptionPane.ERROR_MESSAGE);
		}
	}

	private void closeButtonPerformed() {
		passwordField.setText("");
		if (password != null) {
			Arrays.fill(password, '0');
		}
		dispose();
		facade.getMissionEditor().setEnabled(true);
		facade.getMissionEditor().toFront();
	}

	private void menuExitPerformed() {
		passwordField.setText("");
		if (password != null) {
			Arrays.fill(password, '0');
		}
		this.dispose();
	}

	private void checkBoxAnonymousPerformed() {
		if (checkBoxAnonymous.isSelected()) {
			textFieldLogin.setText("anonymous");
			textFieldLogin.setEnabled(false);
			passwordField.setText("");
			passwordField.setEnabled(false);
		} else {
			textFieldLogin.setText("");
			textFieldLogin.setEnabled(true);
			passwordField.setEnabled(true);
		}
	}

	private void buttonImportPerformed() {
		JFileChooser fc = new JFileChooser();
		fc.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
		int returnVal = fc.showOpenDialog(FtpLoggerPanel.this);
		if (returnVal == JFileChooser.APPROVE_OPTION) {
			File file = fc.getSelectedFile();
			FtpService ftpService = new FtpService();
			try {
				FtpDTO ftpDTO = ftpService.importAutoConfig(file
						.getAbsolutePath());
				textFieldHost.setText(ftpDTO.getUrl());
				textFieldPort.setText(ftpDTO.getPort());
				textFieldLogin.setText(ftpDTO.getLogin());
				passwordField.setText(ftpDTO.getPassword());
				textFieldAutoConfig.setText(file.getAbsolutePath());
				textFieldRemoteMissionsPath.setText(ftpDTO
						.getRemoteMissionsFolderPath());
				textFieldRemoteProfilesPath.setText(ftpDTO
						.getRemoteProfilesFolderPath());
				textFieldRemotePbosPath.setText(ftpDTO
						.getRemotePbosFolderPath());
			} catch (LoadingException e) {
				JOptionPane.showMessageDialog(this, e.getMessage(), "Error",
						JOptionPane.ERROR_MESSAGE);
			}
		}
	}

	private void buttonDeletePerformed() {
		int index = comboxHistory.getSelectedIndex();
		if (index != 0) {
			FtpService ftpService = new FtpService();
			FtpDTO ftpDTO = ftpDTOs.get(index - 1);
			boolean isRemoved = ftpService.removeFtpHistory(ftpDTO);
			if (isRemoved) {
				init();
			}
		}
	}
}
