package com.lea.ui.ftp.filemanager;

/**
 * Title:        JFileManager
 * Description:
 * Copyright:    Copyright (c) Thorsten Jens, Kai Benjamins
 * Company:
 * @author Thorsten Jens, Kai Benjamins
 * @version 1.0
 */

import java.awt.event.ActionEvent;
import java.io.IOException;
import java.util.Vector;

import javax.swing.JOptionPane;

import org.apache.commons.net.ftp.FTPClient;
import org.apache.commons.net.ftp.FTPFile;

import com.lea.exception.FtpException;
import com.lea.service.FtpService;



/**
 * @author Major_Shepard for the =GiFr= team
 */

public class DeleteFileWindowFtp extends FileOperationsWindow {
	private Vector ftpFiles;
	private FileTableFtp sourceFileTable;
	private LanguageData ld;
	private int fileCount = 0;

	public DeleteFileWindowFtp(Vector selectedFiles,
			FileTableFtp rightFileTable, LanguageData ld, MainWindow mainWindow) {
		super(ld.get(ld.L_DELETE_DIALOG));
		this.ld = ld;

		this.setLocation((int) mainWindow.getLocation().getX()
				+ mainWindow.getWidth() / 2 - this.getWidth() / 2,
				(int) mainWindow.getLocation().getY() + mainWindow.getHeight()
						/ 2 - this.getHeight() / 2);

		if (OK) {
			ftpFiles = new Vector();
			ftpFiles = selectedFiles;
			this.sourceFileTable = rightFileTable;

			copy.setText(" " + ld.get(ld.L_DELETE));

			contentFieldPanel.removeAll();
			contentLabelPanel.remove(copyTo);
			contentPanel.remove(contentFieldPanel);

			for (int i = 0; i < ftpFiles.size(); i++) {
				progressList.append(((FTPFile) ftpFiles.elementAt(i)).getName()
						+ "\n");
			}
			int numberRowShown = ftpFiles.size();
			progressList.setRows(numberRowShown);
			progressList.setPreferredSize(progressList
					.getPreferredScrollableViewportSize());
			scrollpane.updateUI();

			cancelButton.setText(ld.get(ld.L_CANCEL));
			okButton.addActionListener(new java.awt.event.ActionListener() {

				public void actionPerformed(ActionEvent e) {
					deleteFile();
				}
			});
		}
	}


	public void deleteFile() {
		try {
			FtpService ftpService = new FtpService();
			FTPClient ftpClient = ftpService.getFtpClient();
			try {
				ftpClient.logout();
			} catch (Exception e) {
				//e.printStackTrace();
			}
			ftpClient = ftpService.reconnect();
			ftpClient.changeWorkingDirectory(sourceFileTable.getRemotePath());
			for (int i = 0; i < ftpFiles.size(); i++) {
				FTPFile ftpFile = (FTPFile) ftpFiles.elementAt(i);
				String filePath = sourceFileTable.getRemotePath() + "/"
						+ ftpFile.getName();
				ftpService.delete(ftpFile, filePath);
			}
			FTPFile[] ftpFiles = ftpClient.listFiles();
			sourceFileTable.Model.changeFileTable(ftpFiles);

		} catch (FtpException e) {
			JOptionPane.showMessageDialog(this, e.getMessage(), "Error",
					JOptionPane.ERROR_MESSAGE);
		} catch (IOException e) {
			e.printStackTrace();
		}
		super.closeWin();
		this.dispose();
	}

	public void changeLanguage(LanguageData l) {
		copy.setText(" " + ld.get(ld.L_DELETE));
		cancelButton.setText(ld.get(ld.L_CANCEL));
	}

}
