package com.lea.ui.ftp.filemanager;

import java.io.File;
import java.io.IOException;

import javax.swing.JOptionPane;
import javax.swing.JProgressBar;

import org.apache.commons.net.ftp.FTPClient;
import org.apache.commons.net.ftp.FTPFile;

import com.lea.controler.Observateur;
import com.lea.exception.FtpException;
import com.lea.service.FtpService;



public class DownloadFile extends Thread {

	private MainWindow mainWindow;
	private FileTable leftFileTable;
	private FileTableFtp rightFileTable;
	private JProgressBar rightProgressBar;

	public DownloadFile(MainWindow mainWindow, FileTable leftFileTable,
			FileTableFtp rightFileTable, JProgressBar rightProgressBar) {

		this.mainWindow = mainWindow;
		this.leftFileTable = leftFileTable;
		this.rightFileTable = rightFileTable;
		this.rightProgressBar = rightProgressBar;
	}

	public void run() {

		if (rightFileTable.getSelectedFiles().size() > 0) {
			final FtpService ftpService = new FtpService();
			FTPClient ftpClient = ftpService.getFtpClient();
			try {
				try {
					ftpClient.disconnect();
				} catch (Exception e3) {
					// e3.printStackTrace();
				}
				ftpClient = ftpService.reconnect();
				ftpClient
						.changeWorkingDirectory(rightFileTable.getRemotePath());

				rightProgressBar.setMinimum(0);
				int size = (int) ftpService.getFtpFilesSize(rightFileTable
						.getSelectedFiles());
				rightProgressBar.setMaximum(size);
				System.out.println("Size: " + size);
				rightProgressBar.setVisible(true);
				int count = 0;

				for (int i = 0; i < rightFileTable.getSelectedFiles().size(); i++) {
					FTPFile ftpFile = (FTPFile) rightFileTable.getSelectedFiles().elementAt(i);

					int response = 0;
					File file = new File(leftFileTable.getActualPath() + "/" + ftpFile.getName());
					if (file.exists()) {
						response = JOptionPane.showConfirmDialog(mainWindow,
								file.getName() + " already exists. Overwrite?",
								"Transfert", JOptionPane.YES_NO_OPTION);
					}
					if (response == 0) {
						count++;
						ftpService.setDownload(ftpFile.getName(), leftFileTable.getActualPath());

						ftpService.getFtpDAO().getDos().addObservateur(
								new Observateur() {
									public void update(final double value) {
										System.out.println("value: " + value);
										rightProgressBar.setValue((int)value);
									}
								});
						ftpService.download(ftpFile.getName());
						ftpService.getFtpDAO().getDos().delObservateur();
					}
				}

				File file = new File(leftFileTable.getActualPath());
				leftFileTable.Model.changeFileTable(file);
				if (!mainWindow.isAbort()&& count>0) {
					JOptionPane.showMessageDialog(mainWindow,
							"File(s) downloaded.", "Transfert",
							JOptionPane.INFORMATION_MESSAGE);
				}

			} catch (FtpException e1) {
				e1.printStackTrace();
				if (!mainWindow.isAbort()) {
					JOptionPane.showMessageDialog(mainWindow, e1.getMessage(),
							"Error", JOptionPane.ERROR_MESSAGE);
				}
			} catch (IOException e2) {
				e2.printStackTrace();
				if (!mainWindow.isAbort()) {
					JOptionPane.showMessageDialog(mainWindow,
							"Can't access to disk.", "Error",
							JOptionPane.ERROR_MESSAGE);
				}
			} finally {
				rightProgressBar.setVisible(false);
				rightProgressBar.setValue(0);
			}
		}
	}
}
