/**
 * Title:        JFileManager<p>
 * Description:  <p>
 * Copyright:    Copyright (c) Thorsten Jens, Kai Benjamins<p>
 * Company:      <p>
 * @author Thorsten Jens, Kai Benjamins
 * @version 1.0
 */
package com.lea.ui.ftp.filemanager;

import javax.swing.ImageIcon;
import javax.swing.table.AbstractTableModel;
import org.apache.commons.net.ftp.FTPFile;

/**
 * @author Major_Shepard for the =GiFr= team
 */

public class FileTableModelFtp extends AbstractTableModel implements
		LanguageAware {

	protected String[] filenames;
	protected String[] columnNames;
	protected Class[] columnClasses = new Class[] { ImageIcon.class,
			String.class, Long.class };
	protected FTPFile[] ftpFiles;

	DetailViewFtp dv;

	public FileTableModelFtp(FTPFile[] ftpFiles, DetailViewFtp detailViewFtp,
			LanguageData ld) {
		this.ftpFiles = ftpFiles;
		this.columnNames = new String[] { "", "Name", "Size" };
		filenames = new String[ftpFiles.length];
		if (ftpFiles != null) {
			for (int i = 0; i < ftpFiles.length; i++) {
				filenames[i] = ftpFiles[i].getName();
			}
		}
		this.dv = detailViewFtp;
		this.fireTableDataChanged();
	}

	public void changeFileTable(FTPFile[] ftpFiles) {
		this.ftpFiles = ftpFiles;
		if (ftpFiles != null) {
			filenames = new String[ftpFiles.length];
			for (int i = 0; i < ftpFiles.length; i++) {
				filenames[i] = ftpFiles[i].getName();
			}
		}
		this.fireTableDataChanged();
	}

	public FTPFile getSelectedFile(int row) {
		return ftpFiles[row];
	}

	public void showFileOrDirectoryInfo(int row) {
		dv.showInfo(ftpFiles[row]);
	}

	public void changeDirectoryFileTable(FTPFile[] ftpFiles) {
		this.ftpFiles = ftpFiles;
		if (ftpFiles!=null){
			filenames = new String [ftpFiles.length];
			for (int i = 0; i < ftpFiles.length; i++) {
				filenames[i] = ftpFiles[i].getName();
			}
			this.fireTableDataChanged();
		}
	}


	public int getColumnCount() {
		return 3;
	}

	public int getRowCount() {
		return filenames.length;
	}


	public String getColumnName(int col) {
		return columnNames[col];
	}

	public Class getColumnClass(int col) {
		return columnClasses[col];
	}

	public Object getValueAt(int row, int col) {
		FTPFile ftpFile = ftpFiles[row];
		switch (col) {
		case 0:
			return ExtendedFileFtp.getIcon(ftpFile);
		case 1:
			return filenames[row];
		case 2:
			return ftpFile.getSize();
		default:
			return null;
		}
	}

	public void changeLanguage(LanguageData l) {
		columnNames[1] = "Name";
		columnNames[2] = "Size";
		this.fireTableStructureChanged();
	}

}
