package com.lea.ui.ftp.filemanager;

import java.awt.Dimension;
import java.awt.Toolkit;


/**
 * JFileManager by Kai Benjamins and Thorsten Jens http://sourceforge.net/projects/jfilemanager/
 * Extended by Major_Shepard for the [S.o.E] team has a FTP client for LEA.
 * 
 */

public class JFileManager {
    boolean packFrame = false;

    //Construct the application
    public JFileManager(String localPath, String remotePath) {
        MainWindow frame = new MainWindow(localPath, remotePath);
        //Validate frames that have preset sizes
        //Pack frames that have useful preferred size info, e.g. from their layout
        
        if (packFrame) {
            frame.pack();
        } else {
            frame.validate();
        }
        //Center the window
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = frame.getSize();
        if (frameSize.height > screenSize.height) {
            frameSize.height = screenSize.height;
        }
        if (frameSize.width > screenSize.width) {
            frameSize.width = screenSize.width;
        }
        frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
        frame.setVisible(true);
        frame.toFront();
    }
}
