
/**
 * Title:        JFileManager<p>
 * Description:  <p>
 * Copyright:    Copyright (c) Thorsten Jens, Kai Benjamins<p>
 * Company:      <p>
 * @author Thorsten Jens, Kai Benjamins
 * @version 1.0
 */
package com.lea.ui.ftp.filemanager;

import javax.swing.*;
import java.io.*;
import java.awt.Font;
import java.awt.event.WindowEvent;

/**
 * Diese Klasse stellt ein Fenster mit einem unformatierten Text dar.
 * Der Text wird in einem ScrollPane angezeigt.
 *
 * @author Kai Benjamins
 * @author Thorsten Jens
 * @see FileContentWindow
 * @version $Id: PlainTextWindow.java,v 1.2 2001/02/22 22:02:58 thodi Exp $ 
 */
public class PlainTextWindow extends FileContentWindow implements LanguageAware {

    private JTextArea jta;
    private JScrollPane scroller;
    private int i;
    private File file;

    public PlainTextWindow(File f) {
        super("TextViewer: " + f);
        if (OK) {
            file = f;
            jta = new JTextArea();
            jta.setFont(new Font("monospaced", Font.PLAIN, 12));
            jta.setLineWrap(true);
            jta.setWrapStyleWord(true);
            jta.setEditable(false);

            // TextArea fllen, zeilenweise
            i = 0;
            try {
                BufferedReader in = new BufferedReader(new FileReader(f));
                String line;
                String CRLF = System.getProperty("line.separator");
                while ((line = in.readLine()) != null) {
                    i++;
                    jta.append(line + CRLF);
                }
                in.close();
            } catch (Exception e) {}

            // Position -> Zum Anfang des Fensters



            jta.setCaretPosition(1);
            statusBar.setText(f.length() + " Bytes, " + i + " " + ld.get(LanguageData.L_LINES));
            scroller = new JScrollPane(jta);
            mainPanel.add(scroller);
            this.setSize(800, 600);
            this.setVisible(true);
        }
    }

    protected void processWindowEvent(WindowEvent e) {
        super.processWindowEvent(e);
        if (e.getID() == WindowEvent.WINDOW_CLOSING) {
            scroller = null;
            jta = null;
        }
    }

    /** Update bei Sprachnderung */
    public void changeLanguage(LanguageData l) {
        statusBar.setText(file.length() + " Bytes, " + i + " " + l.get(l.L_LINES));
    }

}
