package com.lea.ui.ftp.filemanager;

import java.awt.Image;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.File;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JTextField;
import javax.swing.UnsupportedLookAndFeelException;

public class RenameFileWindow extends JDialog {
	
	private JTextField textFieldFileName;
	private JButton buttonCancel;
	private JButton buttonRename;
	private Vector selectedFiles;
	private String actualPath;
	private FileTable leftFileTable;

	public RenameFileWindow(Vector selectedFiles, String actualPath,
			FileTable leftFileTable, MainWindow mainWindow) {

		this.selectedFiles = selectedFiles;
		this.actualPath = actualPath;
		this.leftFileTable = leftFileTable;
		
		try {
			javax.swing.UIManager
					.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
		} catch (ClassNotFoundException e) {
		} catch (InstantiationException e) {
		} catch (IllegalAccessException e) {
		} catch (UnsupportedLookAndFeelException e) {
		}
		this.setSize(240, 110);
		this.setLayout(null);
		this.setVisible(true);
		this.setTitle("Rename file");
		this.setResizable(false);

		this.setLocation((int) mainWindow.getLocation().getX()
				+ mainWindow.getWidth() / 2 - this.getWidth() / 2,
				(int) mainWindow.getLocation().getY() + mainWindow.getHeight()
						/ 2 - this.getHeight() / 2);

		Image icone = Toolkit
				.getDefaultToolkit()
				.getImage(
						java.lang.ClassLoader
								.getSystemResource("resources/pictures/system/lea.png"));
		setIconImage(icone);
		
		textFieldFileName = new JTextField();
		this.add(textFieldFileName);
		textFieldFileName.setBounds(15, 11, 203, 23);
		textFieldFileName.setText(((java.io.File)selectedFiles.elementAt(0)).getName());
		
		{
			buttonRename = new JButton();
			getContentPane().add(buttonRename);
			buttonRename.setText("Rename");
			buttonRename.setBounds(24, 40, 72, 25);
		}
		{
			buttonCancel = new JButton();
			getContentPane().add(buttonCancel);
			buttonCancel.setText("Cancel");
			buttonCancel.setBounds(106, 40, 68, 25);
		}
		
		// Add Listeners
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				menuExitPerformed();
			}
		});
		buttonRename.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				String fileName = textFieldFileName.getText();
				if (fileName != null) {
					if (!fileName.equals(""))
						renameButtonPerformed(fileName);
				}
			}
		});
		buttonCancel.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				cancelButtonPerformed();
			}
		});

	}
	
	private void menuExitPerformed() {
		this.dispose();
	}
	
	private void renameButtonPerformed(String fileName) {
		if (fileName != null) {
			((java.io.File) selectedFiles.elementAt(0)).renameTo(new File(actualPath + "/" + fileName));
		}
		leftFileTable.Model.changeFileTable(((java.io.File) selectedFiles
				.elementAt(0)).getParentFile());
		this.dispose();
	}
	
	private void cancelButtonPerformed() {
		this.dispose();
	}

}
