package com.lea.ui.ftp.filemanager;

import java.io.File;
import java.io.IOException;

import javax.swing.JOptionPane;
import javax.swing.JProgressBar;

import org.apache.commons.net.ftp.FTPClient;
import org.apache.commons.net.ftp.FTPFile;

import com.lea.controler.Observateur;
import com.lea.exception.FtpException;
import com.lea.service.FtpService;



public class UploadFile extends Thread {
	
	private MainWindow mainWindow;
	private FileTable leftFileTable;
	private FileTableFtp rightFileTable;
	private JProgressBar leftProgressBar;

	public UploadFile(MainWindow mainWindow, FileTable leftFileTable,
			FileTableFtp rightFileTable, JProgressBar leftProgressBar) {

		this.mainWindow = mainWindow;
		this.leftFileTable = leftFileTable;
		this.rightFileTable = rightFileTable;
		this.leftProgressBar = leftProgressBar;
	}

	public void run(){
		if (leftFileTable.getSelectedFiles().size() > 0) {
			FtpService ftpService = new FtpService();
			FTPClient ftpClient = ftpService.getFtpClient();
			try {
				try {
					ftpClient.disconnect();
				} catch (Exception e3) {
					// e3.printStackTrace();
				}
				ftpClient = ftpService.reconnect();
				ftpClient.changeWorkingDirectory(rightFileTable.getRemotePath());
				leftProgressBar.setMinimum(0);

				int size = 0;
				for (int i = 0; i < leftFileTable.getSelectedFiles().size(); i++) {
					size = size
							+ (int) ((File) leftFileTable.getSelectedFiles()
									.elementAt(i)).length();
				}
				leftProgressBar.setMaximum(size);
				leftProgressBar.setVisible(true);
				int count=0;
				for (int i = 0; i < leftFileTable.getSelectedFiles().size(); i++) {

					File file = (File) leftFileTable.getSelectedFiles().elementAt(i);
					
					FTPFile[] ftpFiles = ftpClient.listFiles();
					int response=0;
					for (int j =0;j<ftpFiles.length;j++){
						if (ftpFiles[j].getName().equals(file.getName())){
							response = JOptionPane.showConfirmDialog(mainWindow, file.getName() + " already exists. Overwrite?",
									"Transfert", JOptionPane.YES_NO_OPTION);
						}
					}
					if (response==0){
						count++;
						ftpService.setUpload(file);
						ftpService.getFtpDAO().getUis().addObservateur(
								new Observateur() {
									public void update(final double value) {
										System.out.println("value: " + value);
										leftProgressBar.setValue((int)value);
									}
								});
						ftpService.upload(file.getName());
						ftpService.getFtpDAO().getUis().delObservateur();
					}
				}

				FTPFile[] ftpFiles = ftpClient.listFiles();
				rightFileTable.Model.changeFileTable(ftpFiles);
				if (!mainWindow.isAbort()&&count>0) {
					JOptionPane.showMessageDialog(mainWindow, "File(s) uploaded.",
							"Transfert", JOptionPane.INFORMATION_MESSAGE);
				}

			} catch (FtpException e1) {
				e1.printStackTrace();
				if (!mainWindow.isAbort()) {
					JOptionPane.showMessageDialog(mainWindow, e1.getMessage(), "Error",
							JOptionPane.ERROR_MESSAGE);
				}
			} catch (IOException e2) {
				e2.printStackTrace();
				if (!mainWindow.isAbort()) {
					JOptionPane.showMessageDialog(mainWindow, "Can't access to disk.",
							"Error", JOptionPane.ERROR_MESSAGE);
				}
			} finally {
				leftProgressBar.setVisible(false);
				leftProgressBar.setValue(0);
			}
		}
	}
}
