package com.lea.ui.mission;

import com.lea.ui.Facade;

/**
 * Load data in AmmoPanel lists by creating a distinguished thread for each of these lists.
 *
 */

public class AmmoLoader extends Thread {

	private String type;
	private String faction;
	private Facade facade;
	private boolean sdSelected;

	public AmmoLoader(Facade facade, String type, String faction,boolean sdSelected) {
		this.facade = facade;
		this.type = type;
		this.faction = faction;
		this.sdSelected = sdSelected;
	}
	
	public AmmoLoader(Facade facade, String type, String faction) {
		this.facade = facade;
		this.type = type;
		this.faction = faction;
	}

	public void run() {
		if (type.equals("Rifle")) {
			facade.getAmmoPanel().updateRifleList(faction,sdSelected);
		} else if (type.equals("Sniper")) {
			facade.getAmmoPanel().updateSniperList(faction,sdSelected);
		} else if (type.equals("MGAR")) {
			facade.getAmmoPanel().updateMGARList(faction);
		} else if (type.equals("Launcher")) {
			facade.getAmmoPanel().updateLauncherList(faction);
		} else if (type.equals("Pistol")) {
			facade.getAmmoPanel().updatePistolList(faction,sdSelected);
		} else if (type.equals("Equip")) {
			facade.getAmmoPanel().updateEquipList(faction);
		} else if (type.equals("Ruck")) {
			facade.getAmmoPanel().updateRuckList(faction);
		} else if (type.equals("Explosives")) {
			facade.getAmmoPanel().updateExplosivesList(faction);
		} else if (type.equals("CrewServed")) {
			facade.getAmmoPanel().updateCrewServedList(faction);
		} else if (type.equals("Optical")) {
			facade.getAmmoPanel().updateOpticalList(faction);
		} else if (type.equals("Item")) {
			facade.getAmmoPanel().updateItemList(faction);
		}
	}
}
