package com.lea.ui.mission;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.Image;
import java.awt.Toolkit;
import java.awt.datatransfer.StringSelection;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.lang.ref.WeakReference;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Hashtable;
import java.util.List;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.ComboBoxModel;
import javax.swing.DefaultComboBoxModel;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.ListSelectionModel;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.border.BevelBorder;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import com.lea.dto.MagazineDTO;
import com.lea.dto.WeaponDTO;
import com.lea.exception.FinderException;
import com.lea.service.CommonService;
import com.lea.service.MagazineService;
import com.lea.service.WeaponService;
import com.lea.ui.Facade;

/**
 * This code was edited or generated using CloudGarden's Jigloo
 * SWT/Swing GUI Builder, which is free for non-commercial
 * use. If Jigloo is being used commercially (ie, by a corporation,
 * company or business for any purpose whatever) then you
 * should purchase a license for each developer using Jigloo.
 * Please visit www.cloudgarden.com for details.
 * Use of Jigloo implies acceptance of these licensing terms.
 * A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
 * THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
 * LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
 */
/**
 * AmmoPanel view, component of MissionEdiror frame.
 * 
 */

public class AmmoPanel extends JPanel {

	private JList magazinesList;
	private JPanel factionPanel;
	private JComboBox factionComboBox;
	private JTextArea jTextAreaMagazines;
	private JTextArea jTextAreaWeapons;
	private JPanel jPanelTextAreas;
	private JPanel descriptionPanel;
	private JList rifleList, sniperList, arList, launcherList, pistolList,
			equipList, ruckList, explosivesList, crewServedList, itemList,
			opticalList;
	private JScrollPane rifleListScrollPane, sniperListScrollPane,
			arListScrollPane, launcherListScrollPane, pistolListScrollPane,
			equipListScrollPane, ruckListScrollPane, explosiveListScrollPane,
			crewServedListScrollPane, magazineListScrollPane,
			opticalListScrollPane, itemListScrollPane;
	private List<WeaponDTO> rifleBufferList;
	private List<WeaponDTO> sniperBufferList, arBufferList, launcherBufferList,
			pistolBufferList, ruckBufferList, opticalBufferList,
			itemBufferList;
	private List<MagazineDTO> explosivesBufferList, magazineBufferList,
			equipBufferList, crewServedBufferList;
	private JButton buttonCopyClassnameMagazine;
	private JTextField textFieldMagazineClassname;
	private JButton buttonCopyClassnameWeapon;
	private JTextField textFieldWeaponClassname;
	private JCheckBox sdCheckBox;
	private LoadoutDefaultPanel previewPanel, previewPistolPanel,
			previewItemPanel;
	private boolean weaponSelected;
	private String faction = "USMC";
	private boolean sdSelected = false;
	private JPanel jPanel1;
	private Facade facade;
	private JTabbedPane tabbedPane;
	private JPanel riflePanel, sniperPanel, arPanel, launcherPanel,
			pistolPanel, opticalPanel, itemPanel, equipPanel, ruckPanel,
			crewServedPanel, explosivePanel;

	public AmmoPanel(final Facade facade) {

		this.facade = facade;
		this.facade.setAmmoPanel(this);
		this.setPreferredSize(new java.awt.Dimension(482, 635));
		this.setLayout(null);

		{
			tabbedPane = new JTabbedPane();
			this.add(tabbedPane);
			tabbedPane.setBorder(BorderFactory.createTitledBorder(BorderFactory
					.createEmptyBorder(), "Weapons"));
			tabbedPane.setBounds(10, 0, 241, 445);

			{
				riflePanel = new JPanel();
				tabbedPane.addTab("   Rifle   ", riflePanel);
				BoxLayout riflePanelLayout = new BoxLayout(riflePanel,
						javax.swing.BoxLayout.Y_AXIS);
				riflePanel.setLayout(riflePanelLayout);
				rifleList = new JList();
				BoxLayout rifleListLayout = new BoxLayout(rifleList,
						javax.swing.BoxLayout.Y_AXIS);
				rifleList.setLayout(rifleListLayout);

				rifleList.setPreferredSize(new java.awt.Dimension(147, 154));
				rifleList.setBackground(new java.awt.Color(245, 245, 245));

				rifleListScrollPane = new JScrollPane(rifleList);
				riflePanel.add(rifleListScrollPane);
				rifleListScrollPane.setBorder(BorderFactory.createEmptyBorder(
						0, 0, 0, 0));
				rifleList.setCellRenderer(new ImageListCellRenderer());
			}
			{
				sniperPanel = new JPanel();
				tabbedPane.addTab("  Sniper  ", sniperPanel);
				BoxLayout sniperPanelLayout = new BoxLayout(sniperPanel,
						javax.swing.BoxLayout.Y_AXIS);
				sniperPanel.setLayout(sniperPanelLayout);
				sniperPanel.setBorder(BorderFactory.createEmptyBorder(0, 0, 0,
						0));
				sniperList = new JList();
				BoxLayout sniperListLayout = new BoxLayout(sniperList,
						javax.swing.BoxLayout.Y_AXIS);
				sniperList.setLayout(sniperListLayout);
				sniperList.setPreferredSize(new java.awt.Dimension(147, 154));
				sniperList.setBorder(BorderFactory
						.createEmptyBorder(0, 0, 0, 0));
				sniperList.setBackground(new java.awt.Color(245, 245, 245));
				sniperListScrollPane = new JScrollPane(sniperList);
				sniperPanel.add(sniperListScrollPane);
				sniperListScrollPane.setBorder(BorderFactory.createEmptyBorder(
						0, 0, 0, 0));
				sniperList.setCellRenderer(new ImageListCellRenderer());
			}
			{
				arPanel = new JPanel();
				tabbedPane.addTab("   MG/AR   ", arPanel);
				BoxLayout machinegunPanelLayout = new BoxLayout(arPanel,
						javax.swing.BoxLayout.Y_AXIS);
				arPanel.setLayout(machinegunPanelLayout);
				arPanel.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
				arList = new JList();
				BoxLayout arListLayout = new BoxLayout(arList,
						javax.swing.BoxLayout.Y_AXIS);
				arList.setLayout(arListLayout);
				arList.setPreferredSize(new java.awt.Dimension(147, 154));
				arList.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
				arList.setBackground(new java.awt.Color(245, 245, 245));
				arListScrollPane = new JScrollPane(arList);
				arPanel.add(arListScrollPane);
				arListScrollPane.setBorder(BorderFactory.createEmptyBorder(0,
						0, 0, 0));
				arList.setCellRenderer(new ImageListCellRenderer());
			}
			{
				launcherPanel = new JPanel();
				BoxLayout launcherPanelLayout = new BoxLayout(launcherPanel,
						javax.swing.BoxLayout.Y_AXIS);
				launcherPanel.setLayout(launcherPanelLayout);
				tabbedPane.addTab(" Launcher ", launcherPanel);
				launcherList = new JList();
				BoxLayout launcherListLayout = new BoxLayout(launcherList,
						javax.swing.BoxLayout.Y_AXIS);
				launcherList.setLayout(launcherListLayout);
				launcherList.setPreferredSize(new java.awt.Dimension(147, 154));
				launcherList.setBorder(BorderFactory.createEmptyBorder(0, 0, 0,
						0));
				launcherList.setBackground(new java.awt.Color(245, 245, 245));
				launcherListScrollPane = new JScrollPane(launcherList);
				launcherPanel.add(launcherListScrollPane);
				launcherListScrollPane.setBorder(BorderFactory
						.createEmptyBorder(0, 0, 0, 0));
				launcherList.setCellRenderer(new ImageListCellRenderer());
			}
			{
				pistolPanel = new JPanel();
				tabbedPane.add(pistolPanel);
				BoxLayout itemPanelLayout = new BoxLayout(pistolPanel,
						javax.swing.BoxLayout.Y_AXIS);
				pistolPanel.setLayout(itemPanelLayout);
				tabbedPane.addTab("   Pistol   ", pistolPanel);
				pistolList = new JList();
				BoxLayout pistolListLayout = new BoxLayout(pistolList,
						javax.swing.BoxLayout.Y_AXIS);
				pistolList.setLayout(pistolListLayout);
				pistolList.setPreferredSize(new java.awt.Dimension(147, 154));
				pistolList.setBorder(BorderFactory
						.createEmptyBorder(0, 0, 0, 0));
				pistolList.setBackground(new java.awt.Color(245, 245, 245));
				pistolListScrollPane = new JScrollPane(pistolList);
				pistolPanel.add(pistolListScrollPane);
				pistolListScrollPane.setBorder(BorderFactory.createEmptyBorder(
						0, 0, 0, 0));
				pistolList.setCellRenderer(new ImageListCellRenderer());
			}
			{
				explosivePanel = new JPanel();
				tabbedPane.add(explosivePanel);
				tabbedPane.addTab("Explosives", explosivePanel);
				BoxLayout machinegunPanelLayout = new BoxLayout(explosivePanel,
						javax.swing.BoxLayout.Y_AXIS);
				explosivePanel.setLayout(machinegunPanelLayout);
				explosivesList = new JList();
				BoxLayout machinegunListLayout = new BoxLayout(explosivesList,
						javax.swing.BoxLayout.Y_AXIS);
				explosivesList.setLayout(machinegunListLayout);
				explosivesList
						.setPreferredSize(new java.awt.Dimension(147, 154));
				explosivesList.setBorder(BorderFactory.createEmptyBorder(0, 0,
						0, 0));
				explosivesList.setBackground(new java.awt.Color(245, 245, 245));
				explosiveListScrollPane = new JScrollPane(explosivesList);
				explosivePanel.add(explosiveListScrollPane);
				explosiveListScrollPane.setBorder(BorderFactory
						.createEmptyBorder(0, 0, 0, 0));
				explosivesList.setCellRenderer(new ImageListCellRenderer());
			}
			{
				opticalPanel = new JPanel();
				BoxLayout opticalPanelLayout = new BoxLayout(opticalPanel,
						javax.swing.BoxLayout.Y_AXIS);
				opticalPanel.setLayout(opticalPanelLayout);
				tabbedPane.addTab("  Optical  ", opticalPanel);
				// opticalPanel.setPreferredSize(new java.awt.Dimension(228,
				// 229));
				opticalList = new JList();
				BoxLayout equipListLayout = new BoxLayout(opticalList,
						javax.swing.BoxLayout.Y_AXIS);
				opticalList.setLayout(equipListLayout);
				opticalList.setPreferredSize(new java.awt.Dimension(147, 154));
				opticalList.setBorder(BorderFactory.createEmptyBorder(0, 0, 0,
						0));
				opticalList.setBackground(new java.awt.Color(245, 245, 245));
				opticalListScrollPane = new JScrollPane(opticalList);
				opticalPanel.add(opticalListScrollPane);
				opticalListScrollPane.setBorder(BorderFactory
						.createEmptyBorder(0, 0, 0, 0));
				opticalList.setCellRenderer(new ImageListCellRenderer());
			}
			{
				equipPanel = new JPanel();
				BoxLayout itemPanelLayout = new BoxLayout(equipPanel,
						javax.swing.BoxLayout.Y_AXIS);
				equipPanel.setLayout(itemPanelLayout);
				tabbedPane.addTab("   Equip   ", equipPanel);
				equipList = new JList();
				BoxLayout equipListLayout = new BoxLayout(equipList,
						javax.swing.BoxLayout.Y_AXIS);
				equipList.setLayout(equipListLayout);
				equipList.setPreferredSize(new java.awt.Dimension(147, 154));
				equipList
						.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
				equipList.setBackground(new java.awt.Color(245, 245, 245));
				equipListScrollPane = new JScrollPane(equipList);
				equipPanel.add(equipListScrollPane);
				equipListScrollPane.setBorder(BorderFactory.createEmptyBorder(
						0, 0, 0, 0));
				equipList.setCellRenderer(new ImageListCellRenderer());
			}
			itemPanel = new JPanel();
			BoxLayout itemPanelLayout = new BoxLayout(itemPanel,
					javax.swing.BoxLayout.Y_AXIS);
			itemPanel.setLayout(itemPanelLayout);
			tabbedPane.addTab("   Item   ", itemPanel);
			itemList = new JList();
			BoxLayout equipListLayout = new BoxLayout(itemList,
					javax.swing.BoxLayout.Y_AXIS);
			itemList.setLayout(equipListLayout);
			itemList.setPreferredSize(new java.awt.Dimension(147, 154));
			itemList.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			itemList.setBackground(new java.awt.Color(245, 245, 245));
			itemListScrollPane = new JScrollPane(itemList);
			itemPanel.add(itemListScrollPane);
			itemListScrollPane.setBorder(BorderFactory.createEmptyBorder(0, 0,
					0, 0));
			itemList.setCellRenderer(new ImageListCellRenderer());

			{
				ruckPanel = new JPanel();
				BoxLayout ruckPanelLayout = new BoxLayout(ruckPanel,
						javax.swing.BoxLayout.Y_AXIS);
				ruckPanel.setLayout(ruckPanelLayout);
				tabbedPane.addTab("   Ruck   ", ruckPanel);
				ruckList = new JList();
				BoxLayout ruckListLayout = new BoxLayout(ruckList,
						javax.swing.BoxLayout.Y_AXIS);
				ruckList.setLayout(ruckListLayout);
				ruckList.setPreferredSize(new java.awt.Dimension(147, 154));
				ruckList.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
				ruckList.setBackground(new java.awt.Color(245, 245, 245));
				ruckListScrollPane = new JScrollPane(ruckList);
				ruckPanel.add(ruckListScrollPane);
				ruckListScrollPane.setBorder(BorderFactory.createEmptyBorder(0,
						0, 0, 0));
				ruckList.setCellRenderer(new ImageListCellRenderer());
			}
			{
				crewServedPanel = new JPanel();
				BoxLayout crewServedPanelLayout = new BoxLayout(
						crewServedPanel, javax.swing.BoxLayout.Y_AXIS);
				crewServedPanel.setLayout(crewServedPanelLayout);
				tabbedPane.addTab("Crew Served", crewServedPanel);
				crewServedList = new JList();
				BoxLayout itemListLayout = new BoxLayout(crewServedList,
						javax.swing.BoxLayout.Y_AXIS);
				crewServedList.setLayout(itemListLayout);
				crewServedList
						.setPreferredSize(new java.awt.Dimension(147, 154));
				crewServedList.setBorder(BorderFactory.createEmptyBorder(0, 0,
						0, 0));
				crewServedList.setBackground(new java.awt.Color(245, 245, 245));
				crewServedListScrollPane = new JScrollPane(crewServedList);
				crewServedPanel.add(crewServedListScrollPane);
				crewServedListScrollPane.setBorder(BorderFactory
						.createEmptyBorder(0, 0, 0, 0));
				crewServedList.setCellRenderer(new ImageListCellRenderer());
			}
		}
		{
			descriptionPanel = new JPanel();
			descriptionPanel.setLayout(null);
			this.add(descriptionPanel);
			descriptionPanel.setBounds(0, 461, 482, 174);
			descriptionPanel.setBorder(BorderFactory.createTitledBorder(
					BorderFactory.createEmptyBorder(), "W/ M Description"));
			{
				jPanelTextAreas = new JPanel();
				descriptionPanel.add(jPanelTextAreas);
				jPanelTextAreas.setBounds(14, 23, 464, 141);
				jPanelTextAreas.setBorder(BorderFactory
						.createEtchedBorder(BevelBorder.LOWERED));
				jPanelTextAreas.setLayout(null);
				Hashtable properties = UIManager.getDefaults();
				Color backgroundColor = (Color) properties
						.get("Panel.background");
				{
					jTextAreaWeapons = new JTextArea();
					jTextAreaWeapons.setBackground(backgroundColor);
					jPanelTextAreas.add(jTextAreaWeapons);
					jTextAreaWeapons.setBounds(226, 1, 236, 50);
					jTextAreaWeapons
							.setFont(new Font("Tohama", Font.PLAIN, 11));
					jTextAreaWeapons.setEditable(false);
				}
				{
					jTextAreaMagazines = new JTextArea();
					jTextAreaMagazines.setBackground(backgroundColor);
					jTextAreaMagazines.setFont(new Font("Tohama", Font.PLAIN,
							11));
					jPanelTextAreas.add(jTextAreaMagazines);
					jTextAreaMagazines.setBounds(226, 68, 236, 50);
					jTextAreaMagazines.setEditable(false);
				}
				{
					previewPanel = new LoadoutDefaultPanel();
					jPanelTextAreas.add(previewPanel);
					previewPanel.setBounds(20, 32, 171, 76);
					previewPanel.setLayout(null);
					{
						previewPistolPanel = new LoadoutDefaultPanel();
						previewPanel.add(previewPistolPanel);
						previewPistolPanel.setBounds(50, 0, 68, 76);
						previewPistolPanel.setLayout(null);
						{
							previewItemPanel = new LoadoutDefaultPanel();
							previewPistolPanel.add(previewItemPanel);
							previewItemPanel.setBounds(24, 21, 36, 39);
							previewItemPanel.setLayout(null);
						}
					}
				}
				{
					textFieldWeaponClassname = new JTextField();
					jPanelTextAreas.add(textFieldWeaponClassname);
					textFieldWeaponClassname.setBounds(228, 51, 175, 15);
					textFieldWeaponClassname.setBorder(BorderFactory
							.createEmptyBorder(0, 0, 0, 0));
					textFieldWeaponClassname.setBackground(backgroundColor);
				}
				{
					buttonCopyClassnameWeapon = new JButton();
					jPanelTextAreas.add(buttonCopyClassnameWeapon);
					buttonCopyClassnameWeapon.setText("Copy");
					buttonCopyClassnameWeapon.setBounds(403, 51, 59, 15);
					buttonCopyClassnameWeapon.setVisible(false);
				}
				{
					textFieldMagazineClassname = new JTextField();
					jPanelTextAreas.add(textFieldMagazineClassname);
					textFieldMagazineClassname.setBackground(backgroundColor);
					textFieldMagazineClassname.setBorder(BorderFactory
							.createEmptyBorder(0, 0, 0, 0));
					textFieldMagazineClassname.setBounds(228, 119, 175, 15);
				}
				{
					buttonCopyClassnameMagazine = new JButton();
					jPanelTextAreas.add(buttonCopyClassnameMagazine);
					buttonCopyClassnameMagazine.setText("Copy");
					buttonCopyClassnameMagazine.setBounds(403, 118, 59, 15);
					buttonCopyClassnameMagazine.setVisible(false);
				}
			}
		}
		{
			jPanel1 = new JPanel();
			this.add(jPanel1, "Center");
			jPanel1.setBounds(251, 53, 231, 397);
			jPanel1.setLayout(null);
			jPanel1.setBorder(BorderFactory.createTitledBorder(BorderFactory
					.createEmptyBorder(), "Magazines"));

			{
				magazinesList = new JList();
				jPanel1.add(magazinesList);
				BorderLayout magazinesListLayout = new BorderLayout();
				magazinesList.setLayout(magazinesListLayout);
				magazinesList.setBackground(new java.awt.Color(245, 245, 245));
				magazinesList.setCellRenderer(new ImageListCellRenderer());
				magazinesList.setBounds(23, 19, 156, 230);
				magazinesList
						.setPreferredSize(new java.awt.Dimension(201, 365));
				{
					magazineListScrollPane = new JScrollPane(magazinesList);
					jPanel1.add(magazineListScrollPane);
					magazineListScrollPane.setBorder(BorderFactory
							.createEtchedBorder(BevelBorder.LOWERED));
					magazineListScrollPane.setBounds(5, 18, 222, 370);
					jPanel1.add(magazineListScrollPane);
					magazineListScrollPane.getHorizontalScrollBar()
							.removeNotify();
				}
				magazinesList
						.addListSelectionListener(new ListSelectionListener() {
							public void valueChanged(ListSelectionEvent evt) {
								magazineListSelectionPerformed(evt);
							}
						});
				magazinesList.addMouseListener(new MouseAdapter() {
					public void mouseClicked(MouseEvent evt) {
						if (evt.getClickCount() >= 2 && !facade.isRuckOpened())
							magazineItemSelectionPerformed(evt);
						if (evt.getClickCount() >= 2 && facade.isRuckOpened())
							magazinesItemLoadedPerformed(evt);
					}
				});
			}
		}
		{
			factionPanel = new JPanel();
			this.add(factionPanel);
			factionPanel.setBounds(251, 0, 231, 42);
			factionPanel.setBorder(BorderFactory.createTitledBorder(
					BorderFactory.createEmptyBorder(), "Faction Filter"));
			factionPanel.setLayout(null);
			{
				ComboBoxModel factionComboBoxModel = new DefaultComboBoxModel(
						new String[] { "USMC" });
				factionComboBox = new JComboBox();
				factionComboBox.setEnabled(false);
				factionPanel.add(factionComboBox);
				{
					sdCheckBox = new JCheckBox();
					factionPanel.add(sdCheckBox);
					sdCheckBox.setText("SD weapons only");
					sdCheckBox.setBounds(117, 18, 110, 21);
				}
				factionComboBox.setModel(factionComboBoxModel);
				factionComboBox.setBounds(5, 18, 106, 20);
			}
		}

		rifleList.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent evt) {
				rifleListSelectionPerformed(evt);
			}
		});
		rifleList.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent evt) {
				if (evt.getClickCount() >= 2 && !facade.isRuckOpened())
					rifleItemSelectionPerformed(evt);
				if (evt.getClickCount() >= 2 && facade.isRuckOpened())
					rifleItemLoadedPerformed(evt);
			}
		});
		sniperList.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent evt) {
				sniperListSelectionPerformed(evt);
			}
		});
		sniperList.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent evt) {
				if (evt.getClickCount() >= 2 && !facade.isRuckOpened())
					sniperItemSelectionPerformed(evt);
				if (evt.getClickCount() >= 2 && facade.isRuckOpened())
					sniperItemLoadedPerformed(evt);
			}
		});
		arList.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent evt) {
				arListSelectionPerformed(evt);
			}
		});
		arList.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent evt) {
				if (evt.getClickCount() >= 2 && !facade.isRuckOpened())
					arItemSelectionPerformed(evt);
				if (evt.getClickCount() >= 2 && facade.isRuckOpened())
					arItemLoadedPerformed(evt);
			}
		});
		launcherList.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent evt) {
				launcherListSelectionPerformed(evt);
			}
		});
		launcherList.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent evt) {
				if (evt.getClickCount() >= 2 && !facade.isRuckOpened())
					launcherItemSelectionPerformed(evt);
				if (evt.getClickCount() >= 2 && facade.isRuckOpened())
					launcherItemLoadedPerformed(evt);
			}
		});
		pistolList.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent evt) {
				pistolListSelectionPerformed(evt);
			}
		});
		pistolList.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent evt) {
				if (evt.getClickCount() >= 2 && !facade.isRuckOpened())
					pistolItemSelectionPerformed(evt);
				if (evt.getClickCount() >= 2 && facade.isRuckOpened())
					pistolItemLoadedPerformed(evt);
			}
		});

		explosivesList.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent evt) {
				explosivesListSelectionPerformed(evt);
			}
		});
		explosivesList.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent evt) {
				if (evt.getClickCount() >= 2 && !facade.isRuckOpened())
					explosivesItemSelectionPerformed(evt);
				if (evt.getClickCount() >= 2 && facade.isRuckOpened())
					explosivesItemLoadedPerformed(evt);
			}
		});
		opticalList.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent evt) {
				opticalListSelectionPerformed(evt);
			}
		});
		opticalList.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent evt) {
				if (evt.getClickCount() >= 2 && !facade.isRuckOpened())
					opticalItemSelectionPerformed(evt);
				if (evt.getClickCount() >= 2 && facade.isRuckOpened())
					opticalItemLoadedPerformed(evt);
			}
		});
		itemList.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent evt) {
				itemListSelectionPerformed(evt);
			}
		});
		itemList.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent evt) {
				if (evt.getClickCount() >= 2 && !facade.isRuckOpened())
					itemsItemSelectionPerformed(evt);
				if (evt.getClickCount() >= 2 && facade.isRuckOpened())
					itemsItemLoadedPerformed(evt);
			}
		});
		ruckList.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent evt) {
				ruckListSelectionPerformed(evt);
			}
		});
		ruckList.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent evt) {
				if (evt.getClickCount() >= 2 && !facade.isRuckOpened())
					ruckItemSelectionPerformed(evt);
				if (evt.getClickCount() >= 2 && facade.isRuckOpened())
					ruckItemLoadedPerformed(evt);
			}
		});
		equipList.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent evt) {
				equipListSelectionPerformed(evt);
			}
		});
		equipList.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent evt) {
				if (evt.getClickCount() >= 2 && !facade.isRuckOpened())
					equipItemSelectionPerformed(evt);
				if (evt.getClickCount() >= 2 && facade.isRuckOpened())
					equipItemLoadedPerformed(evt);
			}
		});
		crewServedList.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent evt) {
				crewServedListSelectionPerformed(evt);
			}
		});
		crewServedList.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent evt) {
				if (evt.getClickCount() >= 2 && !facade.isRuckOpened())
					crewServedItemSelectionPerformed(evt);
				if (evt.getClickCount() >= 2 && facade.isRuckOpened())
					crewServedItemLoadedPerformed(evt);
			}
		});

		factionComboBox.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				if (!faction.equals((String) factionComboBox.getSelectedItem())) {
					facade.setFactionSelected(true);
					factionPerformed();
					facade.setFactionSelected(false);
				}
			}
		});
		sdCheckBox.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				sdSelected = sdCheckBox.isSelected();
				facade.setFactionSelected(true);
				factionPerformed();
				facade.setFactionSelected(false);
			}
		});
		buttonCopyClassnameMagazine.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				copyToClipboard(textFieldMagazineClassname.getText());
			}
		});
		buttonCopyClassnameWeapon.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				copyToClipboard(textFieldWeaponClassname.getText());
			}
		});
	}

	public void init() {

		rifleList.removeSelectionInterval(rifleList.getSelectedIndex(),
				rifleList.getSelectedIndex());
		sniperList.removeSelectionInterval(sniperList.getSelectedIndex(),
				sniperList.getSelectedIndex());
		launcherList.removeSelectionInterval(launcherList.getSelectedIndex(),
				launcherList.getSelectedIndex());
		arList.removeSelectionInterval(arList.getSelectedIndex(), arList
				.getSelectedIndex());
		pistolList.removeSelectionInterval(pistolList.getSelectedIndex(),
				pistolList.getSelectedIndex());
		explosivesList.removeSelectionInterval(explosivesList
				.getSelectedIndex(), explosivesList.getSelectedIndex());
		opticalList.removeSelectionInterval(opticalList.getSelectedIndex(),
				opticalList.getSelectedIndex());
		equipList.removeSelectionInterval(equipList.getSelectedIndex(),
				equipList.getSelectedIndex());
		itemList.removeSelectionInterval(itemList.getSelectedIndex(), itemList
				.getSelectedIndex());
		ruckList.removeSelectionInterval(ruckList.getSelectedIndex(), ruckList
				.getSelectedIndex());
		crewServedList.removeSelectionInterval(crewServedList
				.getSelectedIndex(), crewServedList.getSelectedIndex());

		jTextAreaWeapons.setText("");
		jTextAreaMagazines.setText("");
		textFieldWeaponClassname.setText("");
		textFieldMagazineClassname.setText("");
		buttonCopyClassnameMagazine.setVisible(false);
		buttonCopyClassnameWeapon.setVisible(false);
		sdCheckBox.setSelected(false);
		ImageIcon imageIconPreview = new ImageIcon(
				"resources/pictures/system/systemdefaultButtonIcon.png");
		Image image = imageIconPreview.getImage();
		previewPanel.setImage(image);
		previewPanel.repaint();
		previewPistolPanel.setImage(image);
		previewPistolPanel.repaint();
		previewItemPanel.setImage(image);
		previewItemPanel.repaint();

		try {
			// Desable ACE back weapon feature if ACE mod is not selected
			CommonService commonService = new CommonService();
			facade.setNoACE(commonService.isACESelected());
			if (facade.isNoACE()) {
				facade.getLoadoutPanel().setBackhandButton(false);
			} else {
				facade.getLoadoutPanel().setBackhandButton(true);
			}

			// Determine if ACRE mod is selected
			facade.setNoACRE(commonService.isACRESelected());

			WeaponService weaponService = new WeaponService();
			Collection<String> factions = weaponService.FindFactions();
			String[] tabFactions = new String[factions.size()];
			int i = 0;
			for (String faction : factions) {
				tabFactions[i] = faction;
				i++;
			}
			ComboBoxModel model = new DefaultComboBoxModel(tabFactions);
			facade.getAmmoPanel().setListFactions(model);
			factionComboBox.setSelectedIndex(factionComboBox.getModel()
					.getSize() - 1);
			facade.setFactionSelected(true);
			sdSelected = false;
			facade.getMissionEditor().getStatus().setText("Loading...");

			AmmoLoader ammoPanelLoader1 = new AmmoLoader(facade, "Rifle",
					"USMC", sdSelected);
			AmmoLoader ammoPanelLoader2 = new AmmoLoader(facade, "Sniper",
					"USMC", sdSelected);
			AmmoLoader ammoPanelLoader3 = new AmmoLoader(facade, "MGAR", "USMC");
			AmmoLoader ammoPanelLoader4 = new AmmoLoader(facade, "Launcher",
					"USMC");
			AmmoLoader ammoPanelLoader5 = new AmmoLoader(facade, "Pistol",
					"USMC", sdSelected);
			AmmoLoader ammoPanelLoader6 = new AmmoLoader(facade, "Equip",
					"USMC");
			AmmoLoader ammoPanelLoader7 = new AmmoLoader(facade, "Ruck", "USMC");
			AmmoLoader ammoPanelLoader8 = new AmmoLoader(facade, "Explosives",
					"USMC");
			AmmoLoader ammoPanelLoader9 = new AmmoLoader(facade, "CrewServed",
					"USMC");
			AmmoLoader ammoPanelLoader10 = new AmmoLoader(facade, "Optical",
					"USMC");
			AmmoLoader ammoPanelLoader11 = new AmmoLoader(facade, "Item",
					"USMC");

			ammoPanelLoader1.start();
			ammoPanelLoader2.start();
			ammoPanelLoader3.start();
			ammoPanelLoader4.start();
			ammoPanelLoader5.start();
			ammoPanelLoader6.start();
			ammoPanelLoader7.start();
			ammoPanelLoader8.start();
			ammoPanelLoader9.start();
			ammoPanelLoader10.start();
			ammoPanelLoader11.start();
			ammoPanelLoader1.join();
			ammoPanelLoader2.join();
			ammoPanelLoader3.join();
			ammoPanelLoader4.join();
			ammoPanelLoader5.join();
			ammoPanelLoader6.join();
			ammoPanelLoader7.join();
			ammoPanelLoader8.join();
			ammoPanelLoader9.join();
			ammoPanelLoader10.join();
			ammoPanelLoader11.join();

			Object[] panels = new Object[1];
			panels[0] = new JPanel().add(new JLabel(""));
			magazineBufferList = new ArrayList<MagazineDTO>();
			magazinesList.setListData(panels);
			magazinesList.clearSelection();
			magazinesList.setVisibleRowCount(0);
			magazinesList.setPreferredSize(magazinesList
					.getPreferredScrollableViewportSize());
			magazineListScrollPane.updateUI();

		} catch (FinderException e) {
			JOptionPane.showMessageDialog(this, e.getMessage(), "Error",
					JOptionPane.ERROR_MESSAGE);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}

		finally {
			factionComboBox.setEnabled(true);
			facade.setFactionSelected(false);
			facade.getMissionEditor().getStatus().setText("Ready");
		}
	}

	public void updateRifleList(String factionName, boolean sdSelected) {

		Object[] panels = new Object[1];
		panels[0] = new JPanel().add(new JLabel(""));
		rifleList.setListData(panels);
		rifleBufferList = null;
		rifleBufferList = new ArrayList<WeaponDTO>();
		int i = 0;
		try {
			WeaponService weaponService = new WeaponService();
			Collection<WeaponDTO> riflesDTO = null;

			if (factionName.equals("ALL")) {
				riflesDTO = weaponService.FindRifles();
			} else {
				riflesDTO = weaponService.FindRifles(factionName);
			}
			List<WeaponDTO> removeWeapons = new ArrayList<WeaponDTO>();
			for (WeaponDTO weaponDTO : riflesDTO) {
				if (sdSelected) {
					String name = weaponDTO.getName();
					if (!name.toUpperCase().contains("SD")) {
						removeWeapons.add(weaponDTO);
					}
				}
			}

			riflesDTO.removeAll(removeWeapons);
			panels = new Object[riflesDTO.size()];

			for (WeaponDTO weaponDTO : riflesDTO) {
				rifleBufferList.add(weaponDTO);
				ImageIcon imageIcon = weaponService
						.FindWeaponImageIconInIconesFolder(
								weaponDTO.getClassname()).get();
				JLabel weaponLabel = new JLabel(weaponDTO.getName(), imageIcon,
						JLabel.LEFT);
				WeakReference<JLabel> ref = new WeakReference<JLabel>(
						weaponLabel);
				JPanel weaponPanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
				weaponPanel.add(ref.get());
				panels[i] = weaponPanel;
				i++;
			}
			rifleList.clearSelection();
			rifleList.setListData(panels);
		} catch (FinderException e) {
			// error if icone for weapon is null
			if (e.getMessage().contains("Can't find icone for weapon")) {
				e.printStackTrace();
			}
		} finally {
			rifleList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			int numberLigneShown = i;
			rifleList.setVisibleRowCount(numberLigneShown);
			rifleList.setPreferredSize(rifleList
					.getPreferredScrollableViewportSize());
			rifleListScrollPane.updateUI();
		}
	}

	public void updateSniperList(String factionName, boolean sdSelected) {

		Object[] panels = new Object[1];
		panels[0] = new JPanel().add(new JLabel(""));
		sniperList.setListData(panels);
		sniperBufferList = null;
		sniperBufferList = new ArrayList<WeaponDTO>();
		int i = 0;
		try {
			WeaponService weaponService = new WeaponService();
			Collection<WeaponDTO> snipersDTO = null;

			if (factionName.equals("ALL")) {
				snipersDTO = weaponService.FindSnipers();
			} else {
				snipersDTO = weaponService.FindSnipers(factionName);
			}
			List<WeaponDTO> removeWeapons = new ArrayList<WeaponDTO>();
			for (WeaponDTO weaponDTO : snipersDTO) {
				if (sdSelected) {
					String name = weaponDTO.getName();
					if (!name.toUpperCase().contains("SD")) {
						removeWeapons.add(weaponDTO);
					}
				}
			}
			snipersDTO.removeAll(removeWeapons);
			panels = new Object[snipersDTO.size()];

			for (WeaponDTO weaponDTO : snipersDTO) {
				sniperBufferList.add(weaponDTO);

				ImageIcon imageIcon = weaponService
						.FindWeaponImageIconInIconesFolder(
								weaponDTO.getClassname()).get();
				JLabel weaponLabel = new JLabel(weaponDTO.getName(), imageIcon,
						JLabel.LEFT);
				WeakReference<JLabel> ref = new WeakReference<JLabel>(
						weaponLabel);
				JPanel weaponPanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
				weaponPanel.add(ref.get());
				panels[i] = weaponPanel;
				i++;
			}
			sniperList.clearSelection();
			sniperList.setListData(panels);

		} catch (FinderException e) {
			// error if icone for weapon is null
			if (e.getMessage().contains("Can't find icone for weapon")) {
				e.printStackTrace();
			}
		} finally {
			sniperList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			int numberLigneShown = i;
			sniperList.setVisibleRowCount(numberLigneShown);
			sniperList.setPreferredSize(sniperList
					.getPreferredScrollableViewportSize());
			sniperListScrollPane.updateUI();
		}
	}

	public void updateMGARList(String factionName) {

		Object[] panels = new Object[1];
		panels[0] = new JPanel().add(new JLabel(""));
		arList.setListData(panels);
		arBufferList = null;
		arBufferList = new ArrayList<WeaponDTO>();
		int i = 0;
		try {
			WeaponService weaponService = new WeaponService();
			Collection<WeaponDTO> mgsDTO = null;

			if (factionName.equals("ALL")) {
				mgsDTO = weaponService.FindMGs();
			} else {
				mgsDTO = weaponService.FindMGs(factionName);
			}
			panels = new Object[mgsDTO.size()];
			for (WeaponDTO weaponDTO : mgsDTO) {
				arBufferList.add(weaponDTO);

				ImageIcon imageIcon = weaponService
						.FindWeaponImageIconInIconesFolder(
								weaponDTO.getClassname()).get();
				JLabel weaponLabel = new JLabel(weaponDTO.getName(), imageIcon,
						JLabel.LEFT);
				WeakReference<JLabel> ref = new WeakReference<JLabel>(
						weaponLabel);
				JPanel weaponPanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
				weaponPanel.add(ref.get());
				panels[i] = weaponPanel;
				i++;
			}
			arList.clearSelection();
			arList.setListData(panels);

		} catch (FinderException e1) {
			// error if icone for weapon is null
			if (e1.getMessage().contains("Can't find icone for weapon")) {
				e1.printStackTrace();
			}
		}

		try {
			WeaponService weaponService = new WeaponService();
			Collection<WeaponDTO> arsDTO = null;

			if (factionName.equals("ALL")) {
				arsDTO = weaponService.FindARs();
			} else {
				arsDTO = weaponService.FindARs(factionName);
			}
			
			if (i != 0) {
				Object[] panels2 = new Object[panels.length];
				for (int j = 0; j < panels.length; j++) {
					panels2[j] = panels[j];
				}
				panels = new Object[panels2.length + arsDTO.size()];
				for (int j = 0; j < panels2.length; j++) {
					panels[j] = panels2[j];
				}
			}else {
				panels = new Object[arsDTO.size()];
			}

			for (WeaponDTO weaponDTO : arsDTO) {
				arBufferList.add(weaponDTO);

				ImageIcon imageIcon = weaponService
						.FindWeaponImageIconInIconesFolder(
								weaponDTO.getClassname()).get();
				Image myNewImage = imageIcon.getImage();
				JLabel weaponLabel = new JLabel(weaponDTO.getName(),
						new ImageIcon(myNewImage), JLabel.LEFT);
				WeakReference<JLabel> ref = new WeakReference<JLabel>(
						weaponLabel);
				JPanel weaponPanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
				weaponPanel.add(ref.get());
				panels[i] = weaponPanel;
				i++;
			}
			arList.clearSelection();
			arList.setListData(panels);

		} catch (FinderException e2) {
			// error if icone for weapon is null
			if (e2.getMessage().contains("Can't find icone for weapon")) {
				e2.printStackTrace();
			}
		} finally {
			arList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			int numberLigneShown = i;
			arList.setVisibleRowCount(numberLigneShown);
			arList
					.setPreferredSize(arList
							.getPreferredScrollableViewportSize());
			arListScrollPane.updateUI();
		}
	}

	public void updateLauncherList(String factionName) {

		Object[] panels = new Object[1];
		panels[0] = new JPanel().add(new JLabel(""));
		launcherList.setListData(panels);
		launcherBufferList = null;
		launcherBufferList = new ArrayList<WeaponDTO>();
		int i = 0;
		try {
			WeaponService weaponService = new WeaponService();
			Collection<WeaponDTO> launchersDTO = null;

			if (factionName.equals("ALL")) {
				launchersDTO = weaponService.FindLaunchers();
			} else {
				launchersDTO = weaponService.FindLaunchers(factionName);
			}
			panels = new Object[launchersDTO.size()];
			for (WeaponDTO weaponDTO : launchersDTO) {
				launcherBufferList.add(weaponDTO);

				ImageIcon imageIcon = weaponService
						.FindWeaponImageIconInIconesFolder(
								weaponDTO.getClassname()).get();
				JLabel weaponLabel = new JLabel(weaponDTO.getName(), imageIcon,
						JLabel.LEFT);
				WeakReference<JLabel> ref = new WeakReference<JLabel>(
						weaponLabel);
				JPanel weaponPanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
				weaponPanel.add(ref.get());
				panels[i] = weaponPanel;
				i++;
			}
			launcherList.clearSelection();
			launcherList.setListData(panels);

		} catch (FinderException e) {
			// error if icone for weapon is null
			if (e.getMessage().contains("Can't find icone for weapon")) {
				e.printStackTrace();
			}
		} finally {
			launcherList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			int numberLigneShown = i;
			launcherList.setVisibleRowCount(numberLigneShown);
			launcherList.setPreferredSize(launcherList
					.getPreferredScrollableViewportSize());
			launcherListScrollPane.updateUI();
		}
	}

	public void updatePistolList(String factionName, boolean sdSelected) {

		Object[] panels = new Object[1];
		panels[0] = new JPanel().add(new JLabel(""));
		pistolList.setListData(panels);
		pistolBufferList = null;
		pistolBufferList = new ArrayList<WeaponDTO>();
		int i = 0;
		try {
			WeaponService weaponService = new WeaponService();
			Collection<WeaponDTO> pistolsDTO = null;
			if (factionName.equals("ALL")) {
				pistolsDTO = weaponService.FindPistols();
			} else {
				pistolsDTO = weaponService.FindPistols(factionName);
			}
			List<WeaponDTO> removeWeapons = new ArrayList<WeaponDTO>();
			for (WeaponDTO weaponDTO : pistolsDTO) {
				if (sdSelected) {
					String name = weaponDTO.getName();
					if (!name.toUpperCase().contains("SD")) {
						removeWeapons.add(weaponDTO);
					}
				}
			}

			pistolsDTO.removeAll(removeWeapons);

			panels = new Object[pistolsDTO.size()];
			for (WeaponDTO weaponDTO : pistolsDTO) {
				pistolBufferList.add(weaponDTO);

				ImageIcon imageIcon = weaponService
						.FindWeaponImageIconInIconesFolder(
								weaponDTO.getClassname()).get();
				JLabel weaponLabel = new JLabel(weaponDTO.getName(), imageIcon,
						JLabel.LEFT);
				WeakReference<JLabel> ref = new WeakReference<JLabel>(
						weaponLabel);
				JPanel weaponPanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
				weaponPanel.add(ref.get());
				panels[i] = weaponPanel;
				i++;
			}
			pistolList.clearSelection();
			pistolList.setListData(panels);

		} catch (Exception e) {
			// error if icone for weapon is null
			if (e.getMessage().contains("Can't find icone for weapon")) {
				e.printStackTrace();
			}
		} finally {
			pistolList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			int numberLigneShown = i;
			pistolList.setVisibleRowCount(numberLigneShown);
			pistolList.setPreferredSize(pistolList
					.getPreferredScrollableViewportSize());
			pistolListScrollPane.updateUI();
		}
	}

	public void updateOpticalList(String factionName) {

		Object[] panels = new Object[1];
		panels[0] = new JPanel().add(new JLabel(""));
		opticalList.setListData(panels);
		opticalBufferList = null;
		opticalBufferList = new ArrayList<WeaponDTO>();
		int i = 0;
		try {
			WeaponService weaponService = new WeaponService();
			Collection<WeaponDTO> equipsDTO = null;

			if (factionName.equals("ALL")) {
				equipsDTO = weaponService.FindEquips();
			} else {
				equipsDTO = weaponService.FindEquips(factionName);
			}
			panels = new Object[equipsDTO.size()];
			for (WeaponDTO weaponDTO : equipsDTO) {

				opticalBufferList.add(weaponDTO);

				ImageIcon imageIcon = weaponService
						.FindWeaponImageIconInIconesFolder(
								weaponDTO.getClassname()).get();
				JLabel weaponLabel = new JLabel(weaponDTO.getName(), imageIcon,
						JLabel.LEFT);

				JPanel weaponPanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
				weaponPanel.add(weaponLabel);
				panels[i] = weaponPanel;
				i++;
			}
			opticalList.clearSelection();
			opticalList.setListData(panels);

		} catch (FinderException e) {
			// error if icone for weapon is null
			if (e.getMessage().contains("Can't find icone for weapon")) {
				e.printStackTrace();
			}
		} finally {
			opticalList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			int numberLigneShown = i;
			opticalList.setVisibleRowCount(numberLigneShown);
			opticalList.setPreferredSize(opticalList
					.getPreferredScrollableViewportSize());
			opticalListScrollPane.updateUI();
		}

	}

	public void updateItemList(String factionName) {

		Object[] panels = new Object[1];
		panels[0] = new JPanel().add(new JLabel(""));
		itemList.setListData(panels);
		itemBufferList = null;
		itemBufferList = new ArrayList<WeaponDTO>();
		int i = 0;
		try {
			WeaponService weaponService = new WeaponService();
			Collection<WeaponDTO> itemsDTO = null;

			if (factionName.equals("ALL")) {
				itemsDTO = weaponService.FindItems();
			} else {
				itemsDTO = weaponService.FindItems(factionName);
			}
			panels = new Object[itemsDTO.size()];
			for (WeaponDTO weaponDTO : itemsDTO) {
				itemBufferList.add(weaponDTO);
				ImageIcon imageIcon = weaponService
						.FindWeaponImageIconInIconesFolder(
								weaponDTO.getClassname()).get();
				JLabel weaponLabel = new JLabel(weaponDTO.getName(), imageIcon,
						JLabel.LEFT);
				JPanel weaponPanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
				weaponPanel.add(weaponLabel);
				panels[i] = weaponPanel;
				i++;
			}
			itemList.clearSelection();
			itemList.setListData(panels);

		} catch (FinderException e) {
			// error if icone for weapon is null
			if (e.getMessage().contains("Can't find icone for weapon")) {
				e.printStackTrace();
			}
		} finally {
			itemList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			int numberLigneShown = i;
			itemList.setVisibleRowCount(numberLigneShown);
			itemList.setPreferredSize(itemList
					.getPreferredScrollableViewportSize());
			itemListScrollPane.updateUI();
		}
	}

	public void updateEquipList(String factionName) {

		Object[] panels = new Object[1];
		panels[0] = new JPanel().add(new JLabel(""));
		equipList.setListData(panels);
		equipBufferList = null;
		equipBufferList = new ArrayList<MagazineDTO>();
		int i = 0;
		try {
			MagazineService magazineService = new MagazineService();
			Collection<MagazineDTO> equipsMagDTO = null;

			if (factionName.equals("ALL")) {
				equipsMagDTO = magazineService.FindEquipMags(facade.isNoACE());
			} else {
				equipsMagDTO = magazineService.FindEquipMags(factionName,
						facade.isNoACE());
			}
			panels = new Object[equipsMagDTO.size()];
			for (MagazineDTO magazineDTO : equipsMagDTO) {
				equipBufferList.add(magazineDTO);

				ImageIcon imageIcon = magazineService
						.FindMagazinesImageIconInIconesFolder(
								magazineDTO.getClassname()).get();
				JLabel weaponLabel = new JLabel(magazineDTO.getName(),
						imageIcon, JLabel.LEFT);
				JPanel weaponPanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
				weaponPanel.add(weaponLabel);
				panels[i] = weaponPanel;
				i++;
			}
			equipList.setListData(panels);
			equipList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

		} catch (FinderException e) {
			// error if icone for magazine is null
			if (e.getMessage().contains("Can't find icone for magazine")) {
				e.printStackTrace();
			}
		} finally {
			int numberLigneShown = i;
			equipList.setVisibleRowCount(numberLigneShown);
			equipList.setPreferredSize(equipList
					.getPreferredScrollableViewportSize());
			equipListScrollPane.updateUI();
		}
	}

	public void updateRuckList(String factionName) {

		Object[] panels = new Object[1];
		panels[0] = new JPanel().add(new JLabel(""));
		ruckList.setListData(panels);
		ruckBufferList = null;
		ruckBufferList = new ArrayList<WeaponDTO>();
		int i = 0;
		try {
			WeaponService weaponService = new WeaponService();
			Collection<WeaponDTO> rucksDTO = null;

			if (factionName.equals("ALL")) {
				rucksDTO = weaponService.FindRucks();
			} else {
				rucksDTO = weaponService.FindRucks(factionName);
			}
			panels = new Object[rucksDTO.size()];
			for (WeaponDTO weaponDTO : rucksDTO) {
				ruckBufferList.add(weaponDTO);

				ImageIcon imageIcon = weaponService
						.FindWeaponImageIconInIconesFolder(
								weaponDTO.getClassname()).get();
				JLabel weaponLabel = new JLabel(weaponDTO.getName(), imageIcon,
						JLabel.LEFT);
				JPanel weaponPanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
				weaponPanel.add(weaponLabel);
				panels[i] = weaponPanel;
				i++;
			}
			ruckList.clearSelection();
			ruckList.setListData(panels);

		} catch (FinderException e) {
			// error if icone for weapon is null
			if (e.getMessage().contains("Can't find icone for weapon")) {
				e.printStackTrace();
			}
		} finally {
			ruckList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			int numberLigneShown = i;
			ruckList.setVisibleRowCount(numberLigneShown);
			ruckList.setPreferredSize(ruckList
					.getPreferredScrollableViewportSize());
			ruckListScrollPane.updateUI();
		}
	}

	public void updateExplosivesList(String factionName) {

		Object[] panels = new Object[1];
		panels[0] = new JPanel().add(new JLabel(""));
		explosivesList.setListData(panels);
		explosivesBufferList = null;
		explosivesBufferList = new ArrayList<MagazineDTO>();
		int i = 0;
		try {
			MagazineService magazineService = new MagazineService();
			Collection<MagazineDTO> explosivesDTO = null;

			if (factionName.equals("ALL")) {
				explosivesDTO = magazineService
						.FindExplosives(facade.isNoACE());
			} else {
				explosivesDTO = magazineService.FindExplosives(factionName,
						facade.isNoACE());
			}
			panels = new Object[explosivesDTO.size()];
			for (MagazineDTO magazineDTO : explosivesDTO) {
				explosivesBufferList.add(magazineDTO);
				ImageIcon imageIcon = magazineService
						.FindMagazinesImageIconInIconesFolder(
								magazineDTO.getClassname()).get();
				JLabel weaponLabel = new JLabel(magazineDTO.getName(),
						imageIcon, JLabel.LEFT);
				JPanel weaponPanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
				weaponPanel.add(weaponLabel);
				panels[i] = weaponPanel;
				i++;
			}
			explosivesList.clearSelection();
			explosivesList.setListData(panels);

		} catch (FinderException e) {
			// error if icone for magazine is null
			if (e.getMessage().contains("Can't find icone for magazine")) {
				e.printStackTrace();
			}
		} finally {
			explosivesList
					.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			int numberLigneShown = i;
			explosivesList.setVisibleRowCount(numberLigneShown);
			explosivesList.setPreferredSize(explosivesList
					.getPreferredScrollableViewportSize());
			explosiveListScrollPane.updateUI();
		}
	}

	public void updateCrewServedList(String factionName) {

		Object[] panels = new Object[1];
		panels[0] = new JPanel().add(new JLabel(""));
		crewServedList.setListData(panels);
		crewServedBufferList = null;
		crewServedBufferList = new ArrayList<MagazineDTO>();
		int i = 0;
		try {
			MagazineService magazineService = new MagazineService();
			Collection<MagazineDTO> crewServedsDTO = null;

			if (factionName.equals("ALL")) {
				crewServedsDTO = magazineService.FindCrewServeds(facade
						.isNoACE());
			} else {
				crewServedsDTO = magazineService.FindCrewServeds(factionName,
						facade.isNoACE());
			}
			panels = new Object[crewServedsDTO.size()];
			for (MagazineDTO magazineDTO : crewServedsDTO) {
				crewServedBufferList.add(magazineDTO);
				ImageIcon imageIcon = magazineService
						.FindMagazinesImageIconInIconesFolder(
								magazineDTO.getClassname()).get();
				JLabel weaponLabel = new JLabel(magazineDTO.getName(),
						imageIcon, JLabel.LEFT);
				JPanel weaponPanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
				weaponPanel.add(weaponLabel);
				panels[i] = weaponPanel;
				i++;
			}
			crewServedList.clearSelection();
			crewServedList.setListData(panels);

		} catch (FinderException e) {
			// error if icone for magazine is null
			if (e.getMessage().contains("Can't find icone for magazine")) {
				e.printStackTrace();
			}
		} finally {
			crewServedList
					.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			int numberLigneShown = i;
			crewServedList.setVisibleRowCount(numberLigneShown);
			crewServedList.setPreferredSize(crewServedList
					.getPreferredScrollableViewportSize());
			crewServedListScrollPane.updateUI();
		}
	}

	public void factionPerformed() {

		rifleList.removeSelectionInterval(rifleList.getSelectedIndex(),
				rifleList.getSelectedIndex());
		sniperList.removeSelectionInterval(sniperList.getSelectedIndex(),
				sniperList.getSelectedIndex());
		launcherList.removeSelectionInterval(launcherList.getSelectedIndex(),
				launcherList.getSelectedIndex());
		arList.removeSelectionInterval(arList.getSelectedIndex(), arList
				.getSelectedIndex());
		pistolList.removeSelectionInterval(pistolList.getSelectedIndex(),
				pistolList.getSelectedIndex());
		explosivesList.removeSelectionInterval(explosivesList
				.getSelectedIndex(), explosivesList.getSelectedIndex());
		opticalList.removeSelectionInterval(opticalList.getSelectedIndex(),
				opticalList.getSelectedIndex());
		equipList.removeSelectionInterval(equipList.getSelectedIndex(),
				equipList.getSelectedIndex());
		itemList.removeSelectionInterval(itemList.getSelectedIndex(), itemList
				.getSelectedIndex());
		ruckList.removeSelectionInterval(ruckList.getSelectedIndex(), ruckList
				.getSelectedIndex());
		crewServedList.removeSelectionInterval(crewServedList
				.getSelectedIndex(), crewServedList.getSelectedIndex());

		Object[] panels = new Object[1];
		panels[0] = new JPanel().add(new JLabel(""));
		magazinesList.setListData(panels);

		jTextAreaWeapons.setText("");
		jTextAreaMagazines.setText("");
		textFieldWeaponClassname.setText("");
		textFieldMagazineClassname.setText("");
		buttonCopyClassnameMagazine.setVisible(false);
		buttonCopyClassnameWeapon.setVisible(false);
		ImageIcon imageIcon = new ImageIcon(
				"resources/pictures/system/systemdefaultButtonIcon.png");
		Image image = imageIcon.getImage();
		previewPanel.setImage(image);
		previewPistolPanel.setImage(image);
		previewItemPanel.setImage(image);

		faction = (String) factionComboBox.getSelectedItem();
		factionComboBox.setEnabled(false);
		sdSelected = sdCheckBox.isSelected();
		facade.getMissionEditor().getStatus().setText("Loading...");

		SwingUtilities.invokeLater(new Runnable() {
			public void run() {

				try {
					AmmoLoader ammoPanelLoader1 = new AmmoLoader(facade,
							"Rifle", faction, sdSelected);
					AmmoLoader ammoPanelLoader2 = new AmmoLoader(facade,
							"Sniper", faction, sdSelected);
					AmmoLoader ammoPanelLoader3 = new AmmoLoader(facade,
							"MGAR", faction);
					AmmoLoader ammoPanelLoader4 = new AmmoLoader(facade,
							"Launcher", faction);
					AmmoLoader ammoPanelLoader5 = new AmmoLoader(facade,
							"Pistol", faction, sdSelected);
					AmmoLoader ammoPanelLoader6 = new AmmoLoader(facade,
							"Equip", faction);
					AmmoLoader ammoPanelLoader7 = new AmmoLoader(facade,
							"Ruck", faction);
					AmmoLoader ammoPanelLoader8 = new AmmoLoader(facade,
							"Explosives", faction);
					AmmoLoader ammoPanelLoader9 = new AmmoLoader(facade,
							"CrewServed", faction);
					AmmoLoader ammoPanelLoader10 = new AmmoLoader(facade,
							"Optical", faction);
					AmmoLoader ammoPanelLoader11 = new AmmoLoader(facade,
							"Item", faction);

					ammoPanelLoader1.start();
					ammoPanelLoader2.start();
					ammoPanelLoader3.start();
					ammoPanelLoader4.start();
					ammoPanelLoader5.start();
					ammoPanelLoader6.start();
					ammoPanelLoader7.start();
					ammoPanelLoader8.start();
					ammoPanelLoader9.start();
					ammoPanelLoader10.start();
					ammoPanelLoader11.start();
					ammoPanelLoader1.join();
					ammoPanelLoader2.join();
					ammoPanelLoader3.join();
					ammoPanelLoader4.join();
					ammoPanelLoader5.join();
					ammoPanelLoader6.join();
					ammoPanelLoader7.join();
					ammoPanelLoader8.join();
					ammoPanelLoader9.join();
					ammoPanelLoader10.join();
					ammoPanelLoader11.join();

				} catch (InterruptedException e) {
					// e.printStackTrace();
				} finally {
					facade.getMissionEditor().getStatus().setText("Ready");
					factionComboBox.setEnabled(true);
				}
			}
		});
	}

	private void rifleListSelectionPerformed(ListSelectionEvent evt) {

		if (!evt.getValueIsAdjusting() && (!facade.isFactionSelected())) {
			weaponSelected = true;
			jTextAreaMagazines.setText("");
			textFieldMagazineClassname.setText("");
			buttonCopyClassnameMagazine.setVisible(false);
			magazineBufferList.clear();

			try {
				int index = rifleList.getSelectedIndex();

				String text = rifleBufferList.get(index).getName() + "\n"
						+ "Caliber: " + rifleBufferList.get(index).getCaliber()
						+ "\n" + "Weight : "
						+ rifleBufferList.get(index).getAceWeight() + " Kg";
				jTextAreaWeapons.setText(text);
				textFieldWeaponClassname.setText("Class: "
						+ rifleBufferList.get(index).getClassname());
				buttonCopyClassnameWeapon.setVisible(true);

				WeaponService weaponService = new WeaponService();
				WeaponDTO weaponDTO = rifleBufferList.get(index);
				ImageIcon imageIconPreview = weaponService.FindWeaponImageIcon(
						weaponDTO.getClassname()).get();
				Image myNewImage = imageIconPreview.getImage();
				previewPanel.setVisible(true);
				previewPanel.setImage(myNewImage);
				previewPanel.repaint();
				previewPanel.setToolTipText(weaponDTO.getName());
				previewPistolPanel.setVisible(false);
				previewItemPanel.setVisible(false);

				MagazineService magazineService = new MagazineService();

				Collection<MagazineDTO> riflesDTO = weaponService
						.FindRifleMagazines(rifleBufferList.get(index)
								.getClassname(), facade.isNoACE());
				Object[] panels = new Object[riflesDTO.size()];
				int i = 0;
				magazineBufferList = null;
				magazineBufferList = new ArrayList<MagazineDTO>();

				for (MagazineDTO magazineDTO : riflesDTO) {
					magazineBufferList.add(magazineDTO);
					ImageIcon imageIcon = magazineService
							.FindMagazinesImageIconInIconesFolder(
									magazineDTO.getClassname()).get();
					JLabel weaponLabel = new JLabel(magazineDTO.getName(),
							imageIcon, JLabel.LEFT);
					JPanel weaponPanel = new JPanel(new FlowLayout(
							FlowLayout.LEFT));
					weaponPanel.add(weaponLabel);
					panels[i] = weaponPanel;
					i++;
				}
				magazinesList.setListData(panels);
				magazinesList
						.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

				int numberLigneShown = i;
				magazinesList.setVisibleRowCount(numberLigneShown);
				magazinesList.setPreferredSize(magazinesList
						.getPreferredScrollableViewportSize());
				magazineListScrollPane.updateUI();

			} catch (FinderException e1) {
				// error if icone for magazine is null
				if (e1.getMessage().contains("Can't find icone for magazine")) {
					e1.printStackTrace();
				}

				Object[] panels = new Object[1];
				panels[0] = new JPanel().add(new JLabel(""));
				magazinesList.setListData(panels);
			} catch (IndexOutOfBoundsException e2) {
			} finally {
				weaponSelected = false;
			}
		}
	}

	private void launcherListSelectionPerformed(ListSelectionEvent evt) {

		if (!evt.getValueIsAdjusting() && (!facade.isFactionSelected())) {
			weaponSelected = true;
			jTextAreaMagazines.setText("");
			textFieldMagazineClassname.setText("");
			buttonCopyClassnameMagazine.setVisible(false);
			magazineBufferList.clear();

			try {
				int index = launcherList.getSelectedIndex();
				String text = launcherBufferList.get(index).getName() + "\n"
						+ "Weight : "
						+ launcherBufferList.get(index).getAceWeight() + " Kg";
				jTextAreaWeapons.setText(text);
				textFieldWeaponClassname.setText("Class: "
						+ launcherBufferList.get(index).getClassname());
				buttonCopyClassnameWeapon.setVisible(true);

				WeaponService weaponService = new WeaponService();
				WeaponDTO weaponDTO = launcherBufferList.get(index);
				ImageIcon imageIconPreview = weaponService.FindWeaponImageIcon(
						weaponDTO.getClassname()).get();
				Image myNewImage = imageIconPreview.getImage();
				previewPanel.setVisible(true);
				previewPanel.setImage(myNewImage);
				previewPanel.repaint();
				previewPanel.setToolTipText(weaponDTO.getName());
				previewPistolPanel.setVisible(false);
				previewItemPanel.setVisible(false);

				MagazineService magazineService = new MagazineService();

				Collection<MagazineDTO> launchersDTO = weaponService
						.FindLauncherMagazines(launcherBufferList.get(index)
								.getClassname(), facade.isNoACE());

				Object[] panels = new Object[launchersDTO.size()];
				int i = 0;
				magazineBufferList = null;
				magazineBufferList = new ArrayList<MagazineDTO>();
				for (MagazineDTO magazineDTO : launchersDTO) {
					magazineBufferList.add(magazineDTO);
					ImageIcon imageIcon = magazineService
							.FindMagazinesImageIconInIconesFolder(
									magazineDTO.getClassname()).get();
					JLabel weaponLabel = new JLabel(magazineDTO.getName(),
							imageIcon, JLabel.LEFT);
					JPanel weaponPanel = new JPanel(new FlowLayout(
							FlowLayout.LEFT));
					weaponPanel.add(weaponLabel);
					panels[i] = weaponPanel;
					i++;
				}
				magazinesList.setListData(panels);
				magazinesList
						.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

				int numberLigneShown = i;
				magazinesList.setVisibleRowCount(numberLigneShown);
				magazinesList.setPreferredSize(magazinesList
						.getPreferredScrollableViewportSize());
				magazineListScrollPane.updateUI();

			} catch (FinderException e) {
				// error if icone for magazine is null
				if (e.getMessage().contains("Can't find icone for magazine")) {
					e.printStackTrace();
				}

				Object[] panels = new Object[1];
				panels[0] = new JPanel().add(new JLabel(""));
				magazinesList.setListData(panels);
			} catch (IndexOutOfBoundsException e2) {
			} finally {
				weaponSelected = false;
			}
		}
	}

	private void sniperListSelectionPerformed(ListSelectionEvent evt) {

		if (!evt.getValueIsAdjusting() && (!facade.isFactionSelected())) {
			weaponSelected = true;
			jTextAreaMagazines.setText("");
			textFieldMagazineClassname.setText("");
			buttonCopyClassnameMagazine.setVisible(false);
			magazineBufferList.clear();

			try {
				int index = sniperList.getSelectedIndex();
				String text = sniperBufferList.get(index).getName() + "\n"
						+ "Caliber: "
						+ sniperBufferList.get(index).getCaliber() + "\n"
						+ "Weight : "
						+ sniperBufferList.get(index).getAceWeight() + " Kg";
				jTextAreaWeapons.setText(text);
				textFieldWeaponClassname.setText("Class: "
						+ sniperBufferList.get(index).getClassname());
				buttonCopyClassnameWeapon.setVisible(true);

				WeaponService weaponService = new WeaponService();
				WeaponDTO weaponDTO = sniperBufferList.get(index);
				ImageIcon imageIconPreview = weaponService.FindWeaponImageIcon(
						weaponDTO.getClassname()).get();
				Image myNewImage = imageIconPreview.getImage();
				previewPanel.setVisible(true);
				previewPanel.setImage(myNewImage);
				previewPanel.repaint();
				previewPanel.setToolTipText(weaponDTO.getName());
				previewPistolPanel.setVisible(false);
				previewItemPanel.setVisible(false);

				MagazineService magazineService = new MagazineService();

				Collection<MagazineDTO> snipersDTO = weaponService
						.FindSniperMagazines(sniperBufferList.get(index)
								.getClassname(), facade.isNoACE());
				Object[] panels = new Object[snipersDTO.size()];
				int i = 0;
				magazineBufferList = null;
				magazineBufferList = new ArrayList<MagazineDTO>();
				for (MagazineDTO magazineDTO : snipersDTO) {
					magazineBufferList.add(magazineDTO);
					ImageIcon imageIcon = magazineService
							.FindMagazinesImageIconInIconesFolder(
									magazineDTO.getClassname()).get();
					JLabel weaponLabel = new JLabel(magazineDTO.getName(),
							imageIcon, JLabel.LEFT);
					JPanel weaponPanel = new JPanel(new FlowLayout(
							FlowLayout.LEFT));
					weaponPanel.add(weaponLabel);
					panels[i] = weaponPanel;
					i++;
				}
				magazinesList.setListData(panels);
				magazinesList
						.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

				int numberLigneShown = i;
				magazinesList.setVisibleRowCount(numberLigneShown);
				magazinesList.setPreferredSize(magazinesList
						.getPreferredScrollableViewportSize());
				magazineListScrollPane.updateUI();

			} catch (FinderException e1) {

				// error if icone for magazine is null
				if (e1.getMessage().contains("Can't find icone for magazine")) {
					e1.printStackTrace();
				}

				Object[] panels = new Object[1];
				panels[0] = new JPanel().add(new JLabel(""));
				magazinesList.setListData(panels);
			} catch (IndexOutOfBoundsException e2) {
			} finally {
				weaponSelected = false;
			}
		}
	}

	private void arListSelectionPerformed(ListSelectionEvent evt) {

		if (!evt.getValueIsAdjusting() && (!facade.isFactionSelected())) {

			weaponSelected = true;
			jTextAreaMagazines.setText("");
			textFieldMagazineClassname.setText("");
			buttonCopyClassnameMagazine.setVisible(false);
			magazineBufferList.clear();
			boolean arflag = true;

			try {
				int index = arList.getSelectedIndex();
				String text = arBufferList.get(index).getName() + "\n"
						+ "Caliber: " + arBufferList.get(index).getCaliber()
						+ "\n" + "Weight : "
						+ arBufferList.get(index).getAceWeight() + " Kg";
				jTextAreaWeapons.setText(text);
				textFieldWeaponClassname.setText("Class: "
						+ arBufferList.get(index).getClassname());
				buttonCopyClassnameWeapon.setVisible(true);

				WeaponService weaponService = new WeaponService();
				WeaponDTO weaponDTO = arBufferList.get(index);
				ImageIcon imageIconPreview = weaponService.FindWeaponImageIcon(
						weaponDTO.getClassname()).get();
				Image myNewImage = imageIconPreview.getImage();
				previewPanel.setVisible(true);
				previewPanel.setImage(myNewImage);
				previewPanel.repaint();
				previewPanel.setToolTipText(weaponDTO.getName());
				previewPistolPanel.setVisible(false);
				previewItemPanel.setVisible(false);

				MagazineService magazineService = new MagazineService();

				Collection<MagazineDTO> arsDTO = weaponService.FindARMagazines(
						arBufferList.get(index).getClassname(), facade
								.isNoACE());

				Object[] panels = new Object[arsDTO.size()];
				int i = 0;
				magazineBufferList = null;
				magazineBufferList = new ArrayList<MagazineDTO>();
				for (MagazineDTO magazineDTO : arsDTO) {
					magazineBufferList.add(magazineDTO);
					ImageIcon imageIcon = magazineService
							.FindMagazinesImageIconInIconesFolder(
									magazineDTO.getClassname()).get();
					JLabel weaponLabel = new JLabel(magazineDTO.getName(),
							imageIcon, JLabel.LEFT);
					JPanel weaponPanel = new JPanel(new FlowLayout(
							FlowLayout.LEFT));
					weaponPanel.add(weaponLabel);
					panels[i] = weaponPanel;
					i++;
				}
				magazinesList.setListData(panels);
				magazinesList
						.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

				int numberLigneShown = i;
				magazinesList.setVisibleRowCount(numberLigneShown);
				magazinesList.setPreferredSize(magazinesList
						.getPreferredScrollableViewportSize());
				magazineListScrollPane.updateUI();

			} catch (FinderException e1) {

				// error if icone for magazine is null
				if (e1.getMessage().contains("Can't find icone for magazine")) {
					e1.printStackTrace();
				}

				arflag = false;
				Object[] panels = new Object[1];
				panels[0] = new JPanel().add(new JLabel(""));
				magazinesList.setListData(panels);
			} catch (IndexOutOfBoundsException e2) {
			}

			if (!arflag) {

				try {
					int index = arList.getSelectedIndex();
					WeaponService weaponService = new WeaponService();
					Collection<MagazineDTO> mgsDTO = weaponService
							.FindMGMagazines(arBufferList.get(index)
									.getClassname());

					Object[] panels = new Object[mgsDTO.size()];
					int i = 0;
					magazineBufferList = null;
					magazineBufferList = new ArrayList<MagazineDTO>();
					for (MagazineDTO magazineDTO : mgsDTO) {
						magazineBufferList.add(magazineDTO);
						MagazineService magazineService = new MagazineService();
						ImageIcon imageIcon = magazineService
								.FindMagazinesImageIconInIconesFolder(
										magazineDTO.getClassname()).get();
						JLabel weaponLabel = new JLabel(magazineDTO.getName(),
								imageIcon, JLabel.LEFT);
						JPanel weaponPanel = new JPanel(new FlowLayout(
								FlowLayout.LEFT));
						weaponPanel.add(weaponLabel);
						panels[i] = weaponPanel;
						i++;
					}
					magazinesList.setListData(panels);
					magazinesList
							.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

					int numberLigneShown = i;
					magazinesList.setVisibleRowCount(numberLigneShown);
					magazinesList.setPreferredSize(magazinesList
							.getPreferredScrollableViewportSize());
					magazineListScrollPane.updateUI();

				} catch (FinderException e) {

					// error if icone for magazine is null
					if (e.getMessage()
							.contains("Can't find icone for magazine")) {
						e.printStackTrace();
					}

					Object[] panels = new Object[1];
					panels[0] = new JPanel().add(new JLabel(""));
					magazinesList.setListData(panels);
				} catch (IndexOutOfBoundsException e2) {
				} finally {
					weaponSelected = false;
				}
			}
		}
	}

	private void pistolListSelectionPerformed(ListSelectionEvent evt) {

		if (!evt.getValueIsAdjusting() && (!facade.isFactionSelected())) {
			weaponSelected = true;
			jTextAreaMagazines.setText("");
			textFieldMagazineClassname.setText("");
			buttonCopyClassnameMagazine.setVisible(false);
			magazineBufferList.clear();

			try {
				int index = pistolList.getSelectedIndex();
				String text = pistolBufferList.get(index).getName() + "\n"
						+ "Caliber: "
						+ pistolBufferList.get(index).getCaliber() + "\n"
						+ "Weight : "
						+ pistolBufferList.get(index).getAceWeight() + " Kg";
				jTextAreaWeapons.setText(text);
				textFieldWeaponClassname.setText("Class: "
						+ pistolBufferList.get(index).getClassname());
				buttonCopyClassnameWeapon.setVisible(true);

				ImageIcon imageIconPreview = new ImageIcon(
						"resources/pictures/system/systemdefaultButtonIcon.png");
				Image image = imageIconPreview.getImage();
				previewPanel.setImage(image);
				previewPanel.repaint();

				WeaponService weaponService = new WeaponService();
				WeaponDTO weaponDTO = pistolBufferList.get(index);
				ImageIcon imageIconPreviewPistol = weaponService
						.FindWeaponImageIcon(weaponDTO.getClassname()).get();
				Image myNewImage = imageIconPreviewPistol.getImage();
				previewPistolPanel.setImage(myNewImage);
				previewPistolPanel.repaint();
				previewPistolPanel.setToolTipText(weaponDTO.getName());
				previewPistolPanel.setVisible(true);
				previewItemPanel.setVisible(false);

				jTextAreaWeapons.setText(text);

				MagazineService magazineService = new MagazineService();

				Collection<MagazineDTO> pistolsDTO = weaponService
						.FindPistolMagazines(pistolBufferList.get(index)
								.getClassname(), facade.isNoACE());
				Object[] panels = new Object[pistolsDTO.size()];
				int i = 0;
				magazineBufferList = null;
				magazineBufferList = new ArrayList<MagazineDTO>();
				for (MagazineDTO magazineDTO : pistolsDTO) {
					magazineBufferList.add(magazineDTO);
					ImageIcon imageIcon = magazineService
							.FindMagazinesImageIconInIconesFolder(
									magazineDTO.getClassname()).get();
					JLabel weaponLabel = new JLabel(magazineDTO.getName(),
							imageIcon, JLabel.LEFT);
					JPanel weaponPanel = new JPanel(new FlowLayout(
							FlowLayout.LEFT));
					weaponPanel.add(weaponLabel);
					panels[i] = weaponPanel;
					i++;
				}
				magazinesList.setListData(panels);
				magazinesList
						.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

				int numberLigneShown = i;
				magazinesList.setVisibleRowCount(numberLigneShown);
				magazinesList.setPreferredSize(magazinesList
						.getPreferredScrollableViewportSize());
				magazineListScrollPane.updateUI();

			} catch (FinderException e1) {

				// error if icone for magazine is null
				if (e1.getMessage().contains("Can't find icone for magazine")) {
					e1.printStackTrace();
				}

				Object[] panels = new Object[1];
				panels[0] = new JPanel().add(new JLabel(""));
				magazinesList.setListData(panels);
			} catch (IndexOutOfBoundsException e2) {
			} finally {
				weaponSelected = false;
			}
		}
	}

	private void explosivesListSelectionPerformed(ListSelectionEvent evt) {

		if (!evt.getValueIsAdjusting() && (!facade.isFactionSelected())) {
			jTextAreaWeapons.setText("");
			textFieldWeaponClassname.setText("");
			buttonCopyClassnameWeapon.setVisible(false);
			magazineBufferList.clear();

			try {
				int index = explosivesList.getSelectedIndex();
				String text = explosivesBufferList.get(index).getName() + "\n"
						+ "Type   : "
						+ explosivesBufferList.get(index).getCaliber() + "\n"
						+ "Weight : "
						+ explosivesBufferList.get(index).getAceWeight()
						+ " Kg";
				jTextAreaMagazines.setText(text);
				textFieldMagazineClassname.setText("Class: "
						+ explosivesBufferList.get(index).getClassname());
				buttonCopyClassnameMagazine.setVisible(true);

				ImageIcon imageIconPreview = new ImageIcon(
						"resources/pictures/system/systemdefaultButtonIcon.png");
				Image image = imageIconPreview.getImage();
				previewPanel.setImage(image);
				previewPanel.repaint();

				previewPistolPanel.setImage(image);
				previewPistolPanel.repaint();

				MagazineService magazineService = new MagazineService();
				MagazineDTO magazineDTO = explosivesBufferList.get(index);
				ImageIcon imageIconPreviewPistol = magazineService
						.FindMagazineImageIcon(magazineDTO.getClassname())
						.get();

				previewItemPanel.setImage(imageIconPreviewPistol.getImage());
				previewItemPanel.repaint();
				previewItemPanel.setToolTipText(magazineDTO.getName());
				previewItemPanel.setVisible(true);
				previewPanel.setVisible(true);
				previewPistolPanel.setVisible(true);

				magazineBufferList.clear();
				Object[] panels = new Object[1];
				panels[0] = new JPanel().add(new JLabel(""));
				magazinesList.setListData(panels);
				magazinesList
						.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

				int numberLigneShown = 0;
				magazinesList.setVisibleRowCount(numberLigneShown);
				magazinesList.setPreferredSize(magazinesList
						.getPreferredScrollableViewportSize());
				magazineListScrollPane.updateUI();
			} catch (IndexOutOfBoundsException e) {
			}
		}
	}

	private void opticalListSelectionPerformed(ListSelectionEvent evt) {

		if (!evt.getValueIsAdjusting() && (!facade.isFactionSelected())) {
			weaponSelected = true;
			jTextAreaMagazines.setText("");
			textFieldMagazineClassname.setText("");
			buttonCopyClassnameMagazine.setVisible(false);
			magazineBufferList.clear();

			try {
				int index = opticalList.getSelectedIndex();
				String text = opticalBufferList.get(index).getName() + "\n"
						+ "Type   : "
						+ opticalBufferList.get(index).getCaliber() + "\n"
						+ "Weight : "
						+ opticalBufferList.get(index).getAceWeight() + " Kg";
				jTextAreaWeapons.setText(text);
				textFieldWeaponClassname.setText("Class: "
						+ opticalBufferList.get(index).getClassname());
				buttonCopyClassnameWeapon.setVisible(true);

				ImageIcon imageIconPreview = new ImageIcon(
						"resources/pictures/system/systemdefaultButtonIcon.png");
				Image image = imageIconPreview.getImage();
				previewPanel.setImage(image);
				previewPanel.repaint();

				WeaponService weaponService = new WeaponService();
				WeaponDTO weaponDTO = opticalBufferList.get(index);
				ImageIcon imageIconPreviewOptical = weaponService
						.FindWeaponImageIcon(weaponDTO.getClassname()).get();
				Image myNewImage = imageIconPreviewOptical.getImage();
				previewPistolPanel.setImage(myNewImage);
				previewPistolPanel.repaint();
				previewPistolPanel.setToolTipText(weaponDTO.getName());
				previewPistolPanel.setVisible(true);
				previewItemPanel.setVisible(false);
				jTextAreaWeapons.setText(text);

				MagazineService magazineService = new MagazineService();

				Collection<MagazineDTO> pistolsDTO = weaponService
						.FindEquipMagazines(opticalBufferList.get(index)
								.getClassname(), facade.isNoACE());
				Object[] panels = new Object[pistolsDTO.size()];
				int i = 0;
				magazineBufferList = null;
				magazineBufferList = new ArrayList<MagazineDTO>();
				for (MagazineDTO magazineDTO : pistolsDTO) {
					magazineBufferList.add(magazineDTO);
					ImageIcon imageIcon = magazineService
							.FindMagazinesImageIconInIconesFolder(
									magazineDTO.getClassname()).get();
					JLabel weaponLabel = new JLabel(magazineDTO.getName(),
							imageIcon, JLabel.LEFT);
					JPanel weaponPanel = new JPanel(new FlowLayout(
							FlowLayout.LEFT));
					weaponPanel.add(weaponLabel);
					panels[i] = weaponPanel;
					i++;
				}
				magazinesList.clearSelection();
				magazinesList.setListData(panels);
				magazinesList
						.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

				int numberLigneShown = i;
				magazinesList.setVisibleRowCount(numberLigneShown);
				magazinesList.setPreferredSize(magazinesList
						.getPreferredScrollableViewportSize());
				opticalListScrollPane.updateUI();

			} catch (FinderException e1) {

				// error if icone for magazine is null
				if (e1.getMessage().contains("Can't find icone for magazine")) {
					e1.printStackTrace();
				}

				Object[] panels = new Object[1];
				panels[0] = new JPanel().add(new JLabel(""));
				magazinesList.setListData(panels);
			} catch (IndexOutOfBoundsException e2) {
			} finally {
				weaponSelected = false;
			}
		}
	}

	private void itemListSelectionPerformed(ListSelectionEvent evt) {

		if (!evt.getValueIsAdjusting() && (!facade.isFactionSelected())) {
			jTextAreaMagazines.setText("");
			buttonCopyClassnameMagazine.setVisible(false);
			textFieldMagazineClassname.setText("");
			magazineBufferList.clear();

			try {
				int index = itemList.getSelectedIndex();
				String text = itemBufferList.get(index).getName() + "\n"
						+ "Type   : " + itemBufferList.get(index).getCaliber()
						+ "\n" + "Weight : "
						+ itemBufferList.get(index).getAceWeight() + " Kg";

				jTextAreaWeapons.setText(text);
				textFieldWeaponClassname.setText("Class: "
						+ itemBufferList.get(index).getClassname());
				buttonCopyClassnameWeapon.setVisible(true);

				ImageIcon imageIconPreview = new ImageIcon(
						"resources/pictures/system/systemdefaultButtonIcon.png");
				Image image = imageIconPreview.getImage();
				previewPanel.setImage(image);
				previewPanel.repaint();
				previewPistolPanel.setImage(image);
				previewPistolPanel.repaint();

				WeaponService weaponService = new WeaponService();
				WeaponDTO weaponDTO = itemBufferList.get(index);
				ImageIcon imageIconPreviewEquip = weaponService
						.FindWeaponImageIcon(weaponDTO.getClassname()).get();
				previewItemPanel.setImage(imageIconPreviewEquip.getImage());
				previewItemPanel.repaint();
				previewItemPanel.setToolTipText(weaponDTO.getName());
				previewItemPanel.setVisible(true);
				previewPanel.setVisible(true);
				previewPistolPanel.setVisible(true);

				jTextAreaWeapons.setText(text);
				Object[] panels = new Object[1];
				panels[0] = new JPanel().add(new JLabel(""));
				magazinesList.setListData(panels);
			} catch (IndexOutOfBoundsException e) {
			}
		}
	}

	private void ruckListSelectionPerformed(ListSelectionEvent evt) {

		if (!evt.getValueIsAdjusting() && (!facade.isFactionSelected())) {
			jTextAreaMagazines.setText("");
			buttonCopyClassnameMagazine.setVisible(false);
			textFieldMagazineClassname.setText("");
			magazineBufferList.clear();

			try {
				int index = ruckList.getSelectedIndex();
				String text = ruckBufferList.get(index).getName() + "\n"
						+ "Weight : "
						+ ruckBufferList.get(index).getAceWeight() + " Kg";
				jTextAreaWeapons.setText(text);
				textFieldWeaponClassname.setText("Class: "
						+ ruckBufferList.get(index).getClassname());
				buttonCopyClassnameWeapon.setVisible(true);

				WeaponService weaponService = new WeaponService();
				WeaponDTO weaponDTO = ruckBufferList.get(index);
				ImageIcon imageIconPreview = weaponService.FindWeaponImageIcon(
						weaponDTO.getClassname()).get();
				Image myNewImage = imageIconPreview.getImage();
				previewPanel.setImage(myNewImage);
				previewPanel.repaint();
				previewPanel.setToolTipText(weaponDTO.getName());
				previewPistolPanel.setVisible(false);
				previewItemPanel.setVisible(false);

				jTextAreaWeapons.setText(text);
				Object[] panels = new Object[1];
				panels[0] = new JPanel().add(new JLabel(""));
				magazinesList.setListData(panels);
				magazinesList
						.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

				int numberLigneShown = 0;
				magazinesList.setVisibleRowCount(numberLigneShown);
				magazinesList.setPreferredSize(magazinesList
						.getPreferredScrollableViewportSize());
				magazineListScrollPane.updateUI();
			} catch (IndexOutOfBoundsException e) {
			}
		}
	}

	private void magazineListSelectionPerformed(ListSelectionEvent evt) {

		if (!evt.getValueIsAdjusting() && (!facade.isFactionSelected())
				&& (!weaponSelected)) {

			int index = magazinesList.getSelectedIndex();

			if (magazineBufferList != null) {
				if (magazineBufferList.size() != 0 && index != -1) {
					String text = magazineBufferList.get(index).getName()
							+ "\n" + "Caliber : "
							+ magazineBufferList.get(index).getCaliber() + "\n"
							+ "Weight : "
							+ magazineBufferList.get(index).getAceWeight()
							+ " Kg";
					jTextAreaMagazines.setText(text);
					textFieldMagazineClassname.setText("Class: "
							+ magazineBufferList.get(index).getClassname());
					buttonCopyClassnameMagazine.setVisible(true);
				}
			}
		}
	}

	private void equipListSelectionPerformed(ListSelectionEvent evt) {

		if (!evt.getValueIsAdjusting() && (!facade.isFactionSelected())) {
			jTextAreaMagazines.setText("");
			buttonCopyClassnameMagazine.setVisible(false);
			textFieldMagazineClassname.setText("");
			magazineBufferList.clear();

			try {
				int index = equipList.getSelectedIndex();
				String text = equipBufferList.get(index).getName() + "\n"
						+ "Weight : "
						+ equipBufferList.get(index).getAceWeight() + " Kg";
				jTextAreaWeapons.setText(text);
				textFieldWeaponClassname.setText("Class: "
						+ equipBufferList.get(index).getClassname());
				buttonCopyClassnameWeapon.setVisible(true);

				ImageIcon imageIconPreview = new ImageIcon(
						"resources/pictures/system/systemdefaultButtonIcon.png");
				Image image = imageIconPreview.getImage();
				previewPanel.setImage(image);
				previewPanel.repaint();

				previewPistolPanel.setImage(image);
				previewPistolPanel.repaint();

				MagazineService magazineService = new MagazineService();
				MagazineDTO magazineDTO = equipBufferList.get(index);
				ImageIcon imageIconPreviewEquip = magazineService
						.FindMagazineImageIcon(magazineDTO.getClassname())
						.get();

				previewItemPanel.setImage(imageIconPreviewEquip.getImage());
				previewItemPanel.repaint();
				previewItemPanel.setToolTipText(magazineDTO.getName());
				previewItemPanel.setVisible(true);
				previewPanel.setVisible(true);
				previewPistolPanel.setVisible(true);

				jTextAreaWeapons.setText(text);
				magazineBufferList.clear();
				Object[] panels = new Object[1];
				panels[0] = new JPanel().add(new JLabel(""));
				magazinesList.setListData(panels);
			} catch (IndexOutOfBoundsException e) {
			}
		}
	}

	private void crewServedListSelectionPerformed(ListSelectionEvent evt) {

		if (!evt.getValueIsAdjusting() && (!facade.isFactionSelected())) {
			jTextAreaWeapons.setText("");
			textFieldWeaponClassname.setText("");
			buttonCopyClassnameWeapon.setVisible(false);
			magazineBufferList.clear();

			try {
				int index = crewServedList.getSelectedIndex();
				String text = crewServedBufferList.get(index).getName() + "\n"
						+ "Type   : "
						+ crewServedBufferList.get(index).getCaliber() + "\n"
						+ "Weight : "
						+ crewServedBufferList.get(index).getAceWeight()
						+ " Kg";
				jTextAreaMagazines.setText(text);
				textFieldMagazineClassname.setText("Class:"
						+ crewServedBufferList.get(index).getClassname());
				buttonCopyClassnameMagazine.setVisible(true);

				ImageIcon imageIconPreview = new ImageIcon(
						"resources/pictures/system/systemdefaultButtonIcon.png");
				Image image = imageIconPreview.getImage();
				previewPanel.setImage(image);
				previewPanel.repaint();

				previewPistolPanel.setImage(image);
				previewPistolPanel.repaint();

				MagazineService magazineService = new MagazineService();
				MagazineDTO magazineDTO = crewServedBufferList.get(index);
				ImageIcon imageIconPreviewCrewServed = magazineService
						.FindMagazineImageIcon(magazineDTO.getClassname())
						.get();

				previewItemPanel
						.setImage(imageIconPreviewCrewServed.getImage());
				previewItemPanel.repaint();
				previewItemPanel.setToolTipText(magazineDTO.getName());
				previewItemPanel.setVisible(true);
				previewPanel.setVisible(true);
				previewPistolPanel.setVisible(true);

				Object[] panels = new Object[1];
				panels[0] = new JPanel().add(new JLabel(""));
				magazinesList.setListData(panels);
				magazinesList
						.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

				int numberLigneShown = 0;
				magazinesList.setVisibleRowCount(numberLigneShown);
				magazinesList.setPreferredSize(magazinesList
						.getPreferredScrollableViewportSize());
				magazineListScrollPane.updateUI();
			} catch (IndexOutOfBoundsException e) {
			}
		}
	}

	private void rifleItemSelectionPerformed(MouseEvent evt) {
		if (facade.isEnableUpdate()) {
			int index = rifleList.getSelectedIndex();
			WeaponDTO weaponDTO = rifleBufferList.get(index);
			facade.getLoadoutPanel().updatePrimaryWeaponPanel(weaponDTO);
		}
	}

	private void rifleItemLoadedPerformed(MouseEvent evt) {
		if (facade.isEnableUpdate()) {
			int index = rifleList.getSelectedIndex();
			WeaponDTO weaponDTO = rifleBufferList.get(index);
			facade.getRuckandModsPanel().updateRuck(weaponDTO);
		}
	}

	private void sniperItemSelectionPerformed(MouseEvent evt) {
		if (facade.isEnableUpdate()) {
			int index = sniperList.getSelectedIndex();
			WeaponDTO weaponDTO = sniperBufferList.get(index);
			facade.getLoadoutPanel().updatePrimaryWeaponPanel(weaponDTO);
		}
	}

	private void sniperItemLoadedPerformed(MouseEvent evt) {
		if (facade.isEnableUpdate()) {
			int index = sniperList.getSelectedIndex();
			WeaponDTO weaponDTO = sniperBufferList.get(index);
			facade.getRuckandModsPanel().updateRuck(weaponDTO);
		}
	}

	private void arItemSelectionPerformed(MouseEvent evt) {
		if (facade.isEnableUpdate()) {
			int index = arList.getSelectedIndex();
			WeaponDTO weaponDTO = arBufferList.get(index);
			facade.getLoadoutPanel().updatePrimaryWeaponPanel(weaponDTO);
		}
	}

	private void arItemLoadedPerformed(MouseEvent evt) {
		if (facade.isEnableUpdate()) {
			int index = arList.getSelectedIndex();
			WeaponDTO weaponDTO = arBufferList.get(index);
			facade.getRuckandModsPanel().updateRuck(weaponDTO);
		}
	}

	private void launcherItemSelectionPerformed(MouseEvent evt) {
		if (facade.isEnableUpdate()) {
			int index = launcherList.getSelectedIndex();
			WeaponDTO weaponDTO = launcherBufferList.get(index);
			facade.getLoadoutPanel().updateSecondaryWeaponPanel(weaponDTO);
		}
	}

	private void launcherItemLoadedPerformed(MouseEvent evt) {
		if (facade.isEnableUpdate()) {
			int index = launcherList.getSelectedIndex();
			WeaponDTO weaponDTO = launcherBufferList.get(index);
			facade.getRuckandModsPanel().updateRuck(weaponDTO);
		}
	}

	private void pistolItemSelectionPerformed(MouseEvent evt) {
		if (facade.isEnableUpdate()) {
			int index = pistolList.getSelectedIndex();
			WeaponDTO weaponDTO = pistolBufferList.get(index);
			facade.getLoadoutPanel().updatePistolPanel(weaponDTO);
		}
	}

	private void pistolItemLoadedPerformed(MouseEvent evt) {
		if (facade.isEnableUpdate()) {
			int index = pistolList.getSelectedIndex();
			WeaponDTO weaponDTO = pistolBufferList.get(index);
			facade.getRuckandModsPanel().updateRuck(weaponDTO);
		}
	}

	private void explosivesItemSelectionPerformed(MouseEvent evt) {
		if (facade.isEnableUpdate()) {
			int index = explosivesList.getSelectedIndex();
			MagazineDTO magazineDTO = explosivesBufferList.get(index);
			facade.getLoadoutPanel().updatePrimaryMagazinePanel(magazineDTO);
		}
	}

	private void explosivesItemLoadedPerformed(MouseEvent evt) {
		if (facade.isEnableUpdate()) {
			int index = explosivesList.getSelectedIndex();
			MagazineDTO magazineDTO = explosivesBufferList.get(index);
			facade.getRuckandModsPanel().updateRuck(magazineDTO);
		}
	}

	private void opticalItemSelectionPerformed(MouseEvent evt) {
		if (facade.isEnableUpdate()) {
			int index = opticalList.getSelectedIndex();
			WeaponDTO weaponDTO = opticalBufferList.get(index);
			facade.getLoadoutPanel().updateOpticalPanel(weaponDTO);
		}
	}

	private void opticalItemLoadedPerformed(MouseEvent evt) {
		if (facade.isEnableUpdate()) {
			int index = opticalList.getSelectedIndex();
			WeaponDTO weaponDTO = opticalBufferList.get(index);
			facade.getRuckandModsPanel().updateRuck(weaponDTO);
		}
	}

	private void itemsItemSelectionPerformed(MouseEvent evt) {
		if (facade.isEnableUpdate()) {
			int index = itemList.getSelectedIndex();
			WeaponDTO weaponDTO = itemBufferList.get(index);
			facade.getLoadoutPanel().updateItemPanel(weaponDTO);
		}
	}

	private void itemsItemLoadedPerformed(MouseEvent evt) {
		if (facade.isEnableUpdate()) {
			int index = itemList.getSelectedIndex();
			WeaponDTO weaponDTO = itemBufferList.get(index);
			facade.getRuckandModsPanel().updateRuck(weaponDTO);
		}
	}

	private void ruckItemSelectionPerformed(MouseEvent evt) {
		if (facade.isEnableUpdate()) {
			int index = ruckList.getSelectedIndex();
			WeaponDTO weaponDTO = ruckBufferList.get(index);
			facade.getLoadoutPanel().updateSecondaryWeaponPanel(weaponDTO);
		}
	}

	private void ruckItemLoadedPerformed(MouseEvent evt) {
		if (facade.isEnableUpdate()) {
			int index = ruckList.getSelectedIndex();
			WeaponDTO weaponDTO = ruckBufferList.get(index);
			facade.getRuckandModsPanel().updateRuck(weaponDTO);
		}
	}

	private void equipItemSelectionPerformed(MouseEvent evt) {
		if (facade.isEnableUpdate()) {
			int index = equipList.getSelectedIndex();
			MagazineDTO magazineDTO = equipBufferList.get(index);
			String category = magazineDTO.getCategory();
			if (category.equals("primary"))
				facade.getLoadoutPanel()
						.updatePrimaryMagazinePanel(magazineDTO);
			if (category.equals("secondary"))
				facade.getLoadoutPanel().updateSecondaryMagazinePanel(
						magazineDTO);
		}
	}

	private void equipItemLoadedPerformed(MouseEvent evt) {
		if (facade.isEnableUpdate()) {
			int index = equipList.getSelectedIndex();
			MagazineDTO magazineDTO = equipBufferList.get(index);
			facade.getRuckandModsPanel().updateRuck(magazineDTO);
		}
	}

	private void magazineItemSelectionPerformed(MouseEvent evt) {
		if (facade.isEnableUpdate()) {
			if (magazineBufferList.size() != 0) {
				int index = magazinesList.getSelectedIndex();
				MagazineDTO magazineDTO = magazineBufferList.get(index);
				String category = magazineDTO.getCategory();
				int slot = magazineDTO.getSlot();
				if (category.equals("primary"))
					facade.getLoadoutPanel().updatePrimaryMagazinePanel(
							magazineDTO);
				if (category.equals("secondary"))
					facade.getLoadoutPanel().updateSecondaryMagazinePanel(
							magazineDTO);
			}
		}
	}

	private void magazinesItemLoadedPerformed(MouseEvent evt) {
		if (facade.isEnableUpdate()) {
			int index = magazinesList.getSelectedIndex();
			MagazineDTO magazineDTO = magazineBufferList.get(index);
			facade.getRuckandModsPanel().updateRuck(magazineDTO);
		}

	}

	private void crewServedItemSelectionPerformed(MouseEvent evt) {
		if (facade.isEnableUpdate()) {
			int index = crewServedList.getSelectedIndex();
			MagazineDTO magazineDTO = crewServedBufferList.get(index);
			facade.getLoadoutPanel().updatePrimaryMagazinePanel(magazineDTO);
		}
	}

	private void crewServedItemLoadedPerformed(MouseEvent evt) {
		if (facade.isEnableUpdate()) {
			int index = crewServedList.getSelectedIndex();
			MagazineDTO magazineDTO = crewServedBufferList.get(index);
			facade.getRuckandModsPanel().updateRuck(magazineDTO);
		}
	}

	public void setListFactions(ComboBoxModel model) {
		factionComboBox.setModel(model);
	}

	public void SetFactionComboBox(boolean value) {
		factionComboBox.setEnabled(value);

	}

	public void findWeapon(WeaponDTO weapon) {
		String type = weapon.getType();
		int index = 0;
		if (type.equals("Rifle")) {
			for (WeaponDTO weaponDTO : rifleBufferList) {
				if (weaponDTO.getClassname().equals(weapon.getClassname())) {
					tabbedPane.setSelectedComponent(riflePanel);
					rifleList.setSelectedIndex(index);
					rifleListScrollPane.getVerticalScrollBar().setValue(
							rifleListScrollPane.getVerticalScrollBar()
									.getMaximum()
									* index / rifleBufferList.size());
					rifleListScrollPane.updateUI();
					jTextAreaMagazines.setText("");
					String text = rifleBufferList.get(index).getName() + "\n"
							+ "Caliber: "
							+ rifleBufferList.get(index).getCaliber() + "\n"
							+ "Weight : "
							+ rifleBufferList.get(index).getAceWeight() + " Kg";
					jTextAreaWeapons.setText(text);
					MagazineService magazineService = new MagazineService();
					WeaponService weaponService = new WeaponService();
					try {
						Collection<MagazineDTO> riflesDTO = weaponService
								.FindRifleMagazines(rifleBufferList.get(index)
										.getClassname(), facade.isNoACE());
						Object[] panels = new Object[riflesDTO.size()];
						int i = 0;
						magazineBufferList = null;
						magazineBufferList = new ArrayList<MagazineDTO>();
						for (MagazineDTO magazineDTO : riflesDTO) {
							magazineBufferList.add(magazineDTO);
							ImageIcon imageIcon = magazineService
									.FindMagazinesImageIconInIconesFolder(
											magazineDTO.getClassname()).get();
							JLabel weaponLabel = new JLabel(magazineDTO
									.getName(), imageIcon, JLabel.LEFT);
							JPanel weaponPanel = new JPanel(new FlowLayout(
									FlowLayout.LEFT));
							weaponPanel.add(weaponLabel);
							panels[i] = weaponPanel;
							i++;
						}
						magazinesList.setListData(panels);
						magazinesList
								.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

						int numberLigneShown = i;
						magazinesList.setVisibleRowCount(numberLigneShown);
						magazinesList.setPreferredSize(magazinesList
								.getPreferredScrollableViewportSize());
						magazineListScrollPane.updateUI();

					} catch (FinderException e) {

						// error if icone for magazine is null
						if (e.getMessage().contains(
								"Can't find icone for magazine")) {
							e.printStackTrace();
						}

						Object[] panels = new Object[1];
						panels[0] = new JPanel().add(new JLabel(""));
						magazinesList.setListData(panels);
					}
					break;
				}
				index++;
			}
		} else if (type.equals("Sniper")) {
			for (WeaponDTO weaponDTO : sniperBufferList) {
				if (weaponDTO.getClassname().equals(weapon.getClassname())) {
					tabbedPane.setSelectedComponent(sniperPanel);
					sniperList.setSelectedIndex(index);
					sniperListScrollPane.getVerticalScrollBar().setValue(
							sniperListScrollPane.getVerticalScrollBar()
									.getMaximum()
									* index / sniperBufferList.size());
					sniperListScrollPane.updateUI();

					String text = sniperBufferList.get(index).getName() + "\n"
							+ "Caliber: "
							+ sniperBufferList.get(index).getCaliber() + "\n"
							+ "Weight : "
							+ sniperBufferList.get(index).getAceWeight()
							+ " Kg";
					jTextAreaWeapons.setText(text);
					MagazineService magazineService = new MagazineService();
					WeaponService weaponService = new WeaponService();
					try {
						Collection<MagazineDTO> snipersDTO = weaponService
								.FindSniperMagazines(sniperBufferList
										.get(index).getClassname(), facade
										.isNoACE());
						Object[] panels = new Object[snipersDTO.size()];
						int i = 0;
						magazineBufferList = null;
						magazineBufferList = new ArrayList<MagazineDTO>();
						for (MagazineDTO magazineDTO : snipersDTO) {
							magazineBufferList.add(magazineDTO);
							ImageIcon imageIcon = magazineService
									.FindMagazinesImageIconInIconesFolder(
											magazineDTO.getClassname()).get();
							JLabel weaponLabel = new JLabel(magazineDTO
									.getName(), imageIcon, JLabel.LEFT);
							JPanel weaponPanel = new JPanel(new FlowLayout(
									FlowLayout.LEFT));
							weaponPanel.add(weaponLabel);
							panels[i] = weaponPanel;
							i++;
						}
						magazinesList.setListData(panels);
						magazinesList
								.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

						int numberLigneShown = i;
						magazinesList.setVisibleRowCount(numberLigneShown);
						magazinesList.setPreferredSize(magazinesList
								.getPreferredScrollableViewportSize());
						magazineListScrollPane.updateUI();

					} catch (FinderException e) {

						// error if icone for magazine is null
						if (e.getMessage().contains(
								"Can't find icone for magazine")) {
							e.printStackTrace();
						}

						Object[] panels = new Object[1];
						panels[0] = new JPanel().add(new JLabel(""));
						magazinesList.setListData(panels);
					}
					break;
				}
				index++;
			}
		}

		else if (type.equals("MG") || type.equals("AR")) {
			for (WeaponDTO weaponDTO : arBufferList) {
				if (weaponDTO.getClassname().equals(weapon.getClassname())) {
					tabbedPane.setSelectedComponent(arPanel);
					arList.setSelectedIndex(index);
					arListScrollPane.getVerticalScrollBar().setValue(
							arListScrollPane.getVerticalScrollBar()
									.getMaximum()
									* index / arBufferList.size());
					arListScrollPane.updateUI();

					jTextAreaMagazines.setText("");
					String text = arBufferList.get(index).getName() + "\n"
							+ "Caliber: "
							+ arBufferList.get(index).getCaliber() + "\n"
							+ "Weight : "
							+ arBufferList.get(index).getAceWeight() + " Kg";
					jTextAreaWeapons.setText(text);
					MagazineService magazineService = new MagazineService();
					WeaponService weaponService = new WeaponService();
					try {
						Collection<MagazineDTO> arsDTO = weaponService
								.FindARMagazines(arBufferList.get(index)
										.getClassname(), facade.isNoACE());
						Object[] panels = new Object[arsDTO.size()];
						int i = 0;
						magazineBufferList = null;
						magazineBufferList = new ArrayList<MagazineDTO>();
						for (MagazineDTO magazineDTO : arsDTO) {
							magazineBufferList.add(magazineDTO);
							ImageIcon imageIcon = magazineService
									.FindMagazinesImageIconInIconesFolder(
											magazineDTO.getClassname()).get();
							JLabel weaponLabel = new JLabel(magazineDTO
									.getName(), imageIcon, JLabel.LEFT);
							JPanel weaponPanel = new JPanel(new FlowLayout(
									FlowLayout.LEFT));
							weaponPanel.add(weaponLabel);
							panels[i] = weaponPanel;
							i++;
						}
						// magazinesList.clearSelection();
						magazinesList.setListData(panels);
						magazinesList
								.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

						int numberLigneShown = i;
						magazinesList.setVisibleRowCount(numberLigneShown);
						magazinesList.setPreferredSize(magazinesList
								.getPreferredScrollableViewportSize());
						magazineListScrollPane.updateUI();

					} catch (FinderException e) {

						// error if icone for magazine is null
						if (e.getMessage().contains(
								"Can't find icone for magazine")) {
							e.printStackTrace();
						}

						Object[] panels = new Object[1];
						panels[0] = new JPanel().add(new JLabel(""));
						magazinesList.setListData(panels);
					}
					break;
				}
				index++;
			}
		} else if (type.equals("Launcher")) {
			for (WeaponDTO weaponDTO : launcherBufferList) {
				if (weaponDTO.getClassname().equals(weapon.getClassname())) {
					tabbedPane.setSelectedComponent(launcherPanel);
					launcherList.setSelectedIndex(index);
					launcherListScrollPane.getVerticalScrollBar().setValue(
							launcherListScrollPane.getVerticalScrollBar()
									.getMaximum()
									* index / launcherBufferList.size());
					launcherListScrollPane.updateUI();

					weaponSelected = true;
					jTextAreaMagazines.setText("");

					String text = launcherBufferList.get(index).getName()
							+ "\n" + "Weight : "
							+ launcherBufferList.get(index).getAceWeight()
							+ " Kg";
					jTextAreaWeapons.setText(text);
					MagazineService magazineService = new MagazineService();
					WeaponService weaponService = new WeaponService();
					try {
						Collection<MagazineDTO> launchersDTO = weaponService
								.FindLauncherMagazines(launcherBufferList.get(
										index).getClassname(), facade.isNoACE());

						Object[] panels = new Object[launchersDTO.size()];
						int i = 0;
						magazineBufferList = null;
						magazineBufferList = new ArrayList<MagazineDTO>();
						for (MagazineDTO magazineDTO : launchersDTO) {
							magazineBufferList.add(magazineDTO);
							ImageIcon imageIcon = magazineService
									.FindMagazinesImageIconInIconesFolder(
											magazineDTO.getClassname()).get();
							JLabel weaponLabel = new JLabel(magazineDTO
									.getName(), imageIcon, JLabel.LEFT);
							JPanel weaponPanel = new JPanel(new FlowLayout(
									FlowLayout.LEFT));
							weaponPanel.add(weaponLabel);
							panels[i] = weaponPanel;
							i++;
						}
						// magazinesList.clearSelection();
						magazinesList.setListData(panels);
						magazinesList
								.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

						int numberLigneShown = i;
						magazinesList.setVisibleRowCount(numberLigneShown);
						magazinesList.setPreferredSize(magazinesList
								.getPreferredScrollableViewportSize());
						magazineListScrollPane.updateUI();

					} catch (FinderException e) {

						// error if icone for magazine is null
						if (e.getMessage().contains(
								"Can't find icone for magazine")) {
							e.printStackTrace();
						}

						Object[] panels = new Object[1];
						panels[0] = new JPanel().add(new JLabel(""));
						magazinesList.setListData(panels);
					}
					// Sytem.out.println(index);
					break;
				}
				index++;
			}
		} else if (type.equals("Pistol")) {
			for (WeaponDTO weaponDTO : pistolBufferList) {
				if (weaponDTO.getClassname().equals(weapon.getClassname())) {
					tabbedPane.setSelectedComponent(pistolPanel);
					pistolList.setSelectedIndex(index);
					pistolListScrollPane.getVerticalScrollBar().setValue(
							pistolListScrollPane.getVerticalScrollBar()
									.getMaximum()
									* index / pistolBufferList.size());
					pistolListScrollPane.updateUI();

					weaponSelected = true;
					jTextAreaMagazines.setText("");

					String text = pistolBufferList.get(index).getName() + "\n"
							+ "Caliber: "
							+ pistolBufferList.get(index).getCaliber() + "\n"
							+ "Weight : "
							+ pistolBufferList.get(index).getAceWeight()
							+ " Kg";
					jTextAreaWeapons.setText(text);
					MagazineService magazineService = new MagazineService();
					WeaponService weaponService = new WeaponService();
					try {
						Collection<MagazineDTO> pistolsDTO = weaponService
								.FindPistolMagazines(pistolBufferList
										.get(index).getClassname(), facade
										.isNoACE());
						Object[] panels = new Object[pistolsDTO.size()];
						int i = 0;
						magazineBufferList = null;
						magazineBufferList = new ArrayList<MagazineDTO>();
						for (MagazineDTO magazineDTO : pistolsDTO) {
							magazineBufferList.add(magazineDTO);
							ImageIcon imageIcon = magazineService
									.FindMagazinesImageIconInIconesFolder(
											magazineDTO.getClassname()).get();
							JLabel weaponLabel = new JLabel(magazineDTO
									.getName(), imageIcon, JLabel.LEFT);
							JPanel weaponPanel = new JPanel(new FlowLayout(
									FlowLayout.LEFT));
							weaponPanel.add(weaponLabel);
							panels[i] = weaponPanel;
							i++;
						}
						// magazinesList.clearSelection();
						magazinesList.setListData(panels);
						magazinesList
								.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

						int numberLigneShown = i;
						magazinesList.setVisibleRowCount(numberLigneShown);
						magazinesList.setPreferredSize(magazinesList
								.getPreferredScrollableViewportSize());
						magazineListScrollPane.updateUI();

					} catch (FinderException e) {

						// error if icone for magazine is null
						if (e.getMessage().contains(
								"Can't find icone for magazine")) {
							e.printStackTrace();
						}

						Object[] panels = new Object[1];
						panels[0] = new JPanel().add(new JLabel(""));
						magazinesList.setListData(panels);
					}
					break;
				}
				index++;
			}
		} else if (type.equals("Equip")) {
			for (WeaponDTO weaponDTO : opticalBufferList) {
				if (weaponDTO.getClassname().equals(weapon.getClassname())) {
					tabbedPane.setSelectedComponent(opticalPanel);
					opticalList.setSelectedIndex(index);
					opticalListScrollPane.getVerticalScrollBar().setValue(
							opticalListScrollPane.getVerticalScrollBar()
									.getMaximum()
									* index / opticalBufferList.size());
					opticalListScrollPane.updateUI();

					jTextAreaMagazines.setText("");

					String text = opticalBufferList.get(index).getName() + "\n"
							+ "Type   : "
							+ opticalBufferList.get(index).getCaliber() + "\n"
							+ "Weight : "
							+ opticalBufferList.get(index).getAceWeight()
							+ " Kg";
					jTextAreaWeapons.setText(text);
					MagazineService magazineService = new MagazineService();
					WeaponService weaponService = new WeaponService();
					try {
						Collection<MagazineDTO> pistolsDTO = weaponService
								.FindEquipMagazines(opticalBufferList
										.get(index).getClassname(), facade
										.isNoACE());
						Object[] panels = new Object[pistolsDTO.size()];
						int i = 0;
						magazineBufferList = null;
						magazineBufferList = new ArrayList<MagazineDTO>();
						for (MagazineDTO magazineDTO : pistolsDTO) {
							ImageIcon imageIcon = magazineService
									.FindMagazinesImageIconInIconesFolder(
											magazineDTO.getClassname()).get();
							JLabel weaponLabel = new JLabel(magazineDTO
									.getName(), imageIcon, JLabel.LEFT);
							JPanel weaponPanel = new JPanel(new FlowLayout(
									FlowLayout.LEFT));
							weaponPanel.add(weaponLabel);
							panels[i] = weaponPanel;
							i++;
						}
						magazinesList.clearSelection();
						magazinesList.setListData(panels);
						magazinesList
								.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

						int numberLigneShown = i;
						magazinesList.setVisibleRowCount(numberLigneShown);
						magazinesList.setPreferredSize(magazinesList
								.getPreferredScrollableViewportSize());
						opticalListScrollPane.updateUI();

					} catch (FinderException e) {

						// error if icone for magazine is null
						if (e.getMessage().contains(
								"Can't find icone for magazine")) {
							e.printStackTrace();
						}

						Object[] panels = new Object[1];
						panels[0] = new JPanel().add(new JLabel(""));
						magazinesList.setListData(panels);
					}
					break;
				}
				index++;
			}
		} else if (type.equals("Item")) {
			for (WeaponDTO weaponDTO : itemBufferList) {
				if (weaponDTO.getClassname().equals(weapon.getClassname())) {
					tabbedPane.setSelectedComponent(itemPanel);
					itemList.setSelectedIndex(index);
					itemListScrollPane.getVerticalScrollBar().setValue(
							itemListScrollPane.getVerticalScrollBar()
									.getMaximum()
									* index / itemBufferList.size());
					itemListScrollPane.updateUI();

					jTextAreaMagazines.setText("");

					String text = itemBufferList.get(index).getName() + "\n"
							+ "Type   : "
							+ itemBufferList.get(index).getCaliber() + "\n"
							+ "Weight : "
							+ itemBufferList.get(index).getAceWeight() + " Kg";
					jTextAreaWeapons.setText(text);
					Object[] panels = new Object[1];
					panels[0] = new JPanel().add(new JLabel(""));
					magazinesList.setListData(panels);
					break;
				}
				index++;
			}
		} else if (type.equals("Ruck")) {

			for (WeaponDTO weaponDTO : ruckBufferList) {
				if (weaponDTO.getClassname().equals(weapon.getClassname())) {
					tabbedPane.setSelectedComponent(ruckPanel);
					ruckList.setSelectedIndex(index);
					ruckListScrollPane.getVerticalScrollBar().setValue(
							ruckListScrollPane.getVerticalScrollBar()
									.getMaximum()
									* index / ruckBufferList.size());
					ruckListScrollPane.updateUI();

					jTextAreaMagazines.setText("");

					String text = ruckBufferList.get(index).getName() + "\n"
							+ "Type   : "
							+ ruckBufferList.get(index).getCaliber() + "\n"
							+ "Weight : "
							+ ruckBufferList.get(index).getAceWeight() + " Kg";

					jTextAreaWeapons.setText(text);
					Object[] panels = new Object[1];
					panels[0] = new JPanel().add(new JLabel(""));
					magazinesList.setListData(panels);
					magazinesList
							.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

					int numberLigneShown = 0;
					magazinesList.setVisibleRowCount(numberLigneShown);
					magazinesList.setPreferredSize(magazinesList
							.getPreferredScrollableViewportSize());
					magazineListScrollPane.updateUI();
					break;
				}
				index++;
			}
		}
	}

	public void findMagazine(MagazineDTO magazine) {
		String type = magazine.getType();
		int index = 0;
		if (type.equals("MagExplosive")) {
			for (MagazineDTO magazineDTO : explosivesBufferList) {
				if (magazineDTO.getClassname().equals(magazine.getClassname())) {
					tabbedPane.setSelectedComponent(explosivePanel);
					explosivesList.setSelectedIndex(index);
					explosiveListScrollPane.getVerticalScrollBar().setValue(
							explosiveListScrollPane.getVerticalScrollBar()
									.getMaximum()
									* index / explosivesBufferList.size());
					explosiveListScrollPane.updateUI();

					if (magazineBufferList.size() != 0 && index != -1) {
						String text = explosivesBufferList.get(index).getName()
								+ "\n"
								+ "Caliber : "
								+ explosivesBufferList.get(index).getCaliber()
								+ "\n"
								+ "Weight : "
								+ explosivesBufferList.get(index)
										.getAceWeight() + " Kg";
						jTextAreaMagazines.setText(text);
					}
					break;
				}
				index++;
			}
		}
		if (type.equals("MagEquip")) {

			for (MagazineDTO magazineDTO : equipBufferList) {
				if (magazineDTO.getClassname().equals(magazine.getClassname())) {
					tabbedPane.setSelectedComponent(equipPanel);
					equipList.setSelectedIndex(index);
					equipListScrollPane.getVerticalScrollBar().setValue(
							equipListScrollPane.getVerticalScrollBar()
									.getMaximum()
									* index / equipBufferList.size());
					equipListScrollPane.updateUI();

					jTextAreaMagazines.setText("");

					String text = equipBufferList.get(index).getName() + "\n"
							+ "Type   : "
							+ equipBufferList.get(index).getCaliber() + "\n"
							+ "Weight : "
							+ equipBufferList.get(index).getAceWeight() + " Kg";
					jTextAreaWeapons.setText(text);
					magazineBufferList.clear();
					Object[] panels = new Object[1];
					panels[0] = new JPanel().add(new JLabel(""));
					magazinesList.setListData(panels);
					break;
				}
				index++;
			}
		}
		if (type.equals("MagCrewserved")) {

			for (MagazineDTO magazineDTO : crewServedBufferList) {
				if (magazineDTO.getClassname().equals(magazine.getClassname())) {
					tabbedPane.setSelectedComponent(crewServedPanel);
					crewServedList.setSelectedIndex(index);
					crewServedListScrollPane.getVerticalScrollBar().setValue(
							crewServedListScrollPane.getVerticalScrollBar()
									.getMaximum()
									* index / crewServedBufferList.size());
					crewServedListScrollPane.updateUI();

					jTextAreaMagazines.setText("");

					String text = crewServedBufferList.get(index).getName()
							+ "\n" + "Type   : "
							+ crewServedBufferList.get(index).getCaliber()
							+ "\n" + "Weight : "
							+ crewServedBufferList.get(index).getAceWeight()
							+ " Kg";
					jTextAreaWeapons.setText(text);
					magazineBufferList.clear();
					Object[] panels = new Object[1];
					panels[0] = new JPanel().add(new JLabel(""));
					magazinesList.setListData(panels);
					magazinesList
							.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

					int numberLigneShown = 0;
					magazinesList.setVisibleRowCount(numberLigneShown);
					magazinesList.setPreferredSize(magazinesList
							.getPreferredScrollableViewportSize());
					magazineListScrollPane.updateUI();
					break;
				}
				index++;
			}
		}
	}

	private void copyToClipboard(String text) {
		try {
			text = text.substring(7, text.length());
			StringSelection ss = new StringSelection(text);
			Toolkit.getDefaultToolkit().getSystemClipboard().setContents(ss,
					null);
		} catch (IllegalStateException e) {
			e.printStackTrace();
			// Clipboard may not be available (Windows).
		}
	}
}
