package com.lea.ui.mission;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Desktop;
import java.awt.FlowLayout;
import java.awt.Image;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.File;
import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.Locale;
import java.util.Stack;

import javax.management.modelmbean.RequiredModelMBean;
import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.ComboBoxModel;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.JSeparator;
import javax.swing.SwingUtilities;
import javax.swing.UnsupportedLookAndFeelException;
import javax.swing.filechooser.FileFilter;

import com.lea.controler.Observateur;
import com.lea.dto.MissionDTO;
import com.lea.dto.UnitDTO;
import com.lea.exception.FinderException;
import com.lea.exception.FtpException;
import com.lea.exception.LoadingException;
import com.lea.exception.WritingException;
import com.lea.service.CommonService;
import com.lea.service.FtpService;
import com.lea.service.MagazineService;
import com.lea.service.MissionService;
import com.lea.service.UnitService;
import com.lea.service.WeaponService;
import com.lea.ui.AboutPanel;
import com.lea.ui.AddonsManagerPanel;
import com.lea.ui.AutoAssignPanel;
import com.lea.ui.ExtractPBOPanel;
import com.lea.ui.Facade;
import com.lea.ui.PreferencesPanel;
import com.lea.ui.RequiredAddonsPanel;
import com.lea.ui.ftp.AutoConfiguratorPanel;
import com.lea.ui.ftp.FtpLoggerPanel;
import com.lea.ui.profile.ProfilesEditor;
import com.lea.ui.profile.ProfilesPanel;
import com.lea.ui.profile.ProfilesPanelLoader;

/**
 * This code was edited or generated using CloudGarden's Jigloo
 * SWT/Swing GUI Builder, which is free for non-commercial
 * use. If Jigloo is being used commercially (ie, by a corporation,
 * company or business for any purpose whatever) then you
 * should purchase a license for each developer using Jigloo.
 * Please visit www.cloudgarden.com for details.
 * Use of Jigloo implies acceptance of these licensing terms.
 * A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
 * THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
 * LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
 */
/**
 * Mission Editor View (main frame)
 * 
 */

public class MissionEditor extends JFrame {

	private JLabel status;
	private JCheckBox checkBoxEditable;
	private JLabel labelProfileName;
	private JLabel labelProfile;
	private JButton buttonApplyProfile;
	private JButton buttonSaveAsProfile;
	private JLabel jLabelUnitType;
	private JLabel jLabel6;
	private JProgressBar jProgressBarEditor;
	private JLabel jLabelDescription;

	private JLabel jLabel3;
	private JLabel jLabelDisplayname;
	private JLabel jLabel1;
	private JButton exitButton;
	private JPanel infosPanel, statusPanel, mainPanel;
	private JMenuItem menuUpdate, menuMods, menuEraseMission, menuLoadMission,
			menuSaveMission, menuExploreMissionsFolder, menuOpenProfiles,
			menuAutoConfig, menuExtractPBO, menuMakePBO;
	private JMenuBar menuBar;
	private JMenu menuProfiles, menuHelp, menuMission;
	private JMenuItem menuImportMission, menuGenerateLoadout, menuAbout,
			menuManual, menuPropertiesMission, menuPreferencesMission,
			menuMissionExportFTP, menuProfilesEdit, menuProfilesExportFTP,
			menuViewContent, menuViewAddons, menuRefresh, menuAutoAssign,
			menuMissionExportPbo, menuExplorePbosFolder, menuApplyMission;
	private JCheckBoxMenuItem menuHideNonAssigned;
	private String title = "Loadout Editor for ArmA 2 Combined Operations & ACE 2";
	private RuckandModsPanel ruckAndModsPanel;
	private LoadoutACEPanel loadoutPanel;
	private UnitsPanel unitsPanel;
	private JComboBox jcomboBoxDisplayOptions, jComboBoxType;
	private AmmoPanel ammoPanel;
	private Facade facade;

	public MissionEditor(Facade facade) {

		this.facade = facade;
		this.facade.setMissionEditor(this);

		setTitle(title);
		setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		setVisible(true);
		setLayout(new BorderLayout());
		setResizable(false);
		this.setSize(1280, 815);
		setLocationRelativeTo(null);
		Image icone = Toolkit
				.getDefaultToolkit()
				.getImage(
						java.lang.ClassLoader
								.getSystemResource("resources/pictures/system/lea.png"));
		setIconImage(icone);

		/* Toolbar */
		menuBar = new JMenuBar();
		menuMission = new JMenu("Mission");
		menuProfiles = new JMenu("Profiles");
		menuApplyMission = new JMenuItem("Apply");
		menuEraseMission = new JMenuItem("Erase");
		menuLoadMission = new JMenuItem("Load");
		menuSaveMission = new JMenuItem("Save");
		menuMission.add(menuApplyMission);
		menuMission.add(menuEraseMission);
		menuMission.add(menuLoadMission);
		menuMission.add(menuSaveMission);
		menuMission.add(new JSeparator());
		menuPropertiesMission = new JMenuItem("Properties");
		menuMission.add(menuPropertiesMission);
		menuPreferencesMission = new JMenuItem("Preferences");
		menuMission.add(menuPreferencesMission);
		menuMission.add(new JSeparator());
		menuExtractPBO = new JMenuItem("Extract mission from .pbo");
		menuImportMission = new JMenuItem("Import mission.sqm");
		menuMission.add(menuExtractPBO);
		menuMission.add(menuImportMission);
		menuMission.add(new JSeparator());
		menuAutoAssign = new JMenuItem("Auto assign units");
		menuHideNonAssigned = new JCheckBoxMenuItem("Hide non assigned units");
		menuRefresh = new JMenuItem("Refresh");
		menuViewAddons = new JMenuItem("Required addons");
		menuViewContent = new JMenuItem("View mission files");
		menuMission.add(menuAutoAssign);
		menuMission.add(menuHideNonAssigned);
		menuMission.add(menuRefresh);
		menuMission.add(menuViewAddons);
		menuMission.add(menuViewContent);
		menuMission.add(new JSeparator());
		menuGenerateLoadout = new JMenuItem("Generate loadout.sqf");
		menuMakePBO = new JMenuItem("Make mission.pbo");
		menuMission.add(menuGenerateLoadout);
		menuMission.add(menuMakePBO);
		menuMission.add(new JSeparator());
		menuExploreMissionsFolder = new JMenuItem("Explore missions folder");
		menuExplorePbosFolder = new JMenuItem("Explore pbos folder");
		menuMission.add(menuExploreMissionsFolder);
		menuMission.add(menuExplorePbosFolder);
		menuMission.add(new JSeparator());
		menuMissionExportFTP = new JMenuItem("Transfert mission by FTP");
		menuMissionExportPbo = new JMenuItem("Transfert pbo by FTP");
		menuMission.add(menuMissionExportFTP);
		menuMission.add(menuMissionExportPbo);
		menuMission.add(new JSeparator());
		menuProfilesEdit = new JMenuItem("Edit");
		menuProfiles.add(menuProfilesEdit);
		menuProfiles.add(new JSeparator());
		menuProfilesExportFTP = new JMenuItem("Transfert profile by FTP");
		menuOpenProfiles = new JMenuItem("Explore profiles folder");
		menuProfiles.add(menuOpenProfiles);
		menuProfiles.add(menuProfilesExportFTP);

		menuBar.add(menuMission);
		menuBar.add(menuProfiles);
		menuHelp = new JMenu("Help");
		menuBar.add(menuHelp);
		menuManual = new JMenuItem("Online Help");
		menuHelp.add(menuManual);
		menuHelp.add(new JSeparator());
		menuMods = new JMenuItem("Manage Addons");
		menuHelp.add(menuMods);
		menuAutoConfig = new JMenuItem("Generate ftp auto-config");
		menuHelp.add(menuAutoConfig);
		menuUpdate = new JMenuItem("Check for Updates");
		menuHelp.add(menuUpdate);
		menuHelp.add(new JSeparator());
		menuAbout = new JMenuItem("About");
		menuHelp.add(menuAbout);

		setJMenuBar(menuBar);

		/* Infos panel (top) */
		infosPanel = new JPanel();
		infosPanel.setLayout(null);
		add(infosPanel, BorderLayout.NORTH);
		infosPanel.setPreferredSize(new java.awt.Dimension(1280, 75));
		{
			jLabel1 = new JLabel();
			infosPanel.add(jLabel1);
			jLabel1.setText("Unit DisplayName");
			jLabel1.setBounds(246, 8, 119, 18);
		}
		{
			jLabelDisplayname = new JLabel();
			infosPanel.add(jLabelDisplayname);
			jLabelDisplayname.setText("Unknown");
			jLabelDisplayname.setBounds(266, 31, 210, 13);
		}
		{
			jLabel3 = new JLabel();
			infosPanel.add(jLabel3);
			jLabel3.setText("Unit Description");
			jLabel3.setBounds(483, 10, 145, 18);
		}
		{
			jLabelDescription = new JLabel();
			infosPanel.add(jLabelDescription);
			jLabelDescription.setText("Empty");
			jLabelDescription.setBounds(499, 30, 187, 16);
		}
		{
			jLabel6 = new JLabel();
			infosPanel.add(jLabel6);
			jLabel6.setText("Change Display");
			jLabel6.setBounds(126, 7, 108, 18);
		}
		{
			ComboBoxModel jComboBoxNameModel = new DefaultComboBoxModel(
					new String[] { "Name", "Displayname", "Classname",
							"Description" });
			jcomboBoxDisplayOptions = new JComboBox();
			infosPanel.add(jcomboBoxDisplayOptions);
			jcomboBoxDisplayOptions.setModel(jComboBoxNameModel);
			jcomboBoxDisplayOptions.setBounds(126, 28, 89, 26);
			jcomboBoxDisplayOptions.setEnabled(false);
		}
		{
			ComboBoxModel jComboBoxTypeModel = new DefaultComboBoxModel(
					new String[] { "Playable", "AI", "Empty" });
			jComboBoxType = new JComboBox();
			infosPanel.add(jComboBoxType);
			jComboBoxType.setModel(jComboBoxTypeModel);
			jComboBoxType.setBounds(10, 28, 94, 26);
			jComboBoxType.setEnabled(false);
		}
		{
			jLabelUnitType = new JLabel();
			infosPanel.add(jLabelUnitType);
			jLabelUnitType.setText("Switch Unit Type");
			jLabelUnitType.setBounds(10, 9, 110, 17);
		}
		{
			buttonSaveAsProfile = new JButton();
			infosPanel.add(buttonSaveAsProfile);
			buttonSaveAsProfile.setText("Save as Profile");
			buttonSaveAsProfile.setBounds(877, 18, 105, 28);
		}
		{
			buttonApplyProfile = new JButton();
			infosPanel.add(buttonApplyProfile);
			buttonApplyProfile.setText("Apply Profile");
			buttonApplyProfile.setBounds(752, 18, 105, 28);
		}
		{
			labelProfile = new JLabel();
			infosPanel.add(labelProfile);
			labelProfile.setText("Profile :");
			labelProfile.setBounds(825, 52, 46, 26);
		}
		{
			labelProfileName = new JLabel();
			infosPanel.add(labelProfileName);
			labelProfileName.setText("none");
			labelProfileName.setBounds(868, 53, 222, 25);
		}
		{
			checkBoxEditable = new JCheckBox();
			infosPanel.add(checkBoxEditable);
			checkBoxEditable.setText("Do not script this loadout");
			checkBoxEditable.setBounds(1025, 18, 208, 31);
			checkBoxEditable.setEnabled(false);
		}

		/* Main panel (center) */
		mainPanel = new JPanel();
		mainPanel.setPreferredSize(new java.awt.Dimension(1280, 600));
		add(mainPanel, BorderLayout.CENTER);
		mainPanel.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
		Box box2 = Box.createHorizontalBox();
		mainPanel.add(box2);
		mainPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
		{
			unitsPanel = this.facade.getUnitsPanel();
			box2.add(unitsPanel);
		}
		{
			ammoPanel = this.facade.getAmmoPanel();
			box2.add(ammoPanel);
			ammoPanel.setPreferredSize(new java.awt.Dimension(478, 600));
		}
		{
			loadoutPanel = this.facade.getLoadoutPanel();
			box2.add(loadoutPanel);
			loadoutPanel.setPreferredSize(new java.awt.Dimension(315, 600));
		}
		{
			ruckAndModsPanel = this.facade.getRuckandModsPanel();
			box2.add(ruckAndModsPanel);
		}

		/* Status panel (bottom) */
		statusPanel = new JPanel();
		statusPanel.setLayout(null);
		statusPanel.setPreferredSize(new java.awt.Dimension(1280, 40));
		add(statusPanel, BorderLayout.SOUTH);
		{
			status = new JLabel("   Status :");
			status.setBounds(18, 1, 181, 16);
			status.setText("Ready");
			statusPanel.add(status);
		}
		{
			jProgressBarEditor = new JProgressBar();
			statusPanel.add(jProgressBarEditor);
			jProgressBarEditor.setBounds(1030, 3, 162, 22);
		}
		{
			exitButton = new JButton();
			exitButton.setText("Exit");
			exitButton.setBounds(1195, 1, 62, 24);
			statusPanel.add(exitButton);
		}
		// Add Listeners
		addWindowListener(new WindowAdapter() {
			public void windowOpened(WindowEvent e) {
			}

			public void windowClosing(WindowEvent e) {
				menuExitPerformed();
			}
		});
		menuApplyMission.addActionListener(new ActionListener() {
			public void actionPerformed(final ActionEvent evt) {
				menuItemApplyActionPerformed();
			}
		});
		menuEraseMission.addActionListener(new ActionListener() {
			public void actionPerformed(final ActionEvent evt) {
				menuItemEraseActionPerformed();
			}
		});
		menuLoadMission.addActionListener(new ActionListener() {
			public void actionPerformed(final ActionEvent evt) {
				menuItemLoadActionPerformed();
			}
		});
		menuSaveMission.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				menuItemSaveActionPerformed();
			}
		});
		menuPropertiesMission.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				menuItemPropertiesPerformed();
			}
		});
		menuPreferencesMission.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				menuItemPreferencesPerformed();
			}
		});
		menuImportMission.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				menuItemImportMissionSQMPerformed();
			}
		});
		menuGenerateLoadout.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				menuItemGenerateLoadoutPerformed();
			}
		});
		menuProfilesEdit.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				menuItemProfilesEditPerformed();
			}
		});
		menuMods.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				menuItemModsPerformed();
			}
		});
		menuAbout.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				menuItemAboutPerformed();
			}
		});
		exitButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				menuExitPerformed();
			}
		});
		jComboBoxType.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				comboBoxTypePerformed();
			}
		});
		jcomboBoxDisplayOptions.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				comboBoxNamePerformed();
			}
		});
		buttonSaveAsProfile.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				saveAsProfileButtonPerformed();
			}
		});
		buttonApplyProfile.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				applyProfileButtonPerformed();
			}
		});
		checkBoxEditable.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				checkBoxEditablePerformed();
			}
		});
		menuExploreMissionsFolder.addActionListener(new ActionListener() {
			public void actionPerformed(final ActionEvent evt) {
				menuItemOpenActionPerformed("missions");
			}
		});
		menuExplorePbosFolder.addActionListener(new ActionListener() {
			public void actionPerformed(final ActionEvent evt) {
				menuItemOpenActionPerformed("pbos");
			}
		});
		menuOpenProfiles.addActionListener(new ActionListener() {
			public void actionPerformed(final ActionEvent evt) {
				menuItemOpenActionPerformed("profiles");
			}
		});
		menuAutoConfig.addActionListener(new ActionListener() {
			public void actionPerformed(final ActionEvent evt) {
				menuItemAutoConfigPerformed();
			}
		});
		menuMissionExportFTP.addActionListener(new ActionListener() {
			public void actionPerformed(final ActionEvent evt) {
				menuItemTransfertFTPPerformed("mission");
			}
		});
		menuProfilesExportFTP.addActionListener(new ActionListener() {
			public void actionPerformed(final ActionEvent evt) {
				menuItemTransfertFTPPerformed("profile");
			}
		});
		menuMissionExportPbo.addActionListener(new ActionListener() {
			public void actionPerformed(final ActionEvent evt) {
				menuItemTransfertFTPPerformed("pbo");
			}
		});
		menuRefresh.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				menuItemRefreshPerformed();
			}
		});
		menuAutoAssign.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				menuItemAutoAssignPerformed();
			}
		});
		menuHideNonAssigned.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				menuCheckBoxHideNonAssignedPerformed(e);
			}
		});
		menuViewAddons.addActionListener(new ActionListener() {
			public void actionPerformed(final ActionEvent evt) {
				menuItemViewAddonsPerformed();
			}
		});
		menuViewContent.addActionListener(new ActionListener() {
			public void actionPerformed(final ActionEvent evt) {
				menuItemViewContentPerformed();
			}
		});
		menuUpdate.addActionListener(new ActionListener() {
			public void actionPerformed(final ActionEvent evt) {
				SwingUtilities.invokeLater(new Runnable() {
					public void run() {
						menuItemUpdatePerformed();
					}
				});
			}
		});
		menuExtractPBO.addActionListener(new ActionListener() {
			public void actionPerformed(final ActionEvent evt) {
				status.setText("Extracting mission from pbo..");
				menuItemExtractPBOPerformed();
			}
		});
		menuMakePBO.addActionListener(new ActionListener() {
			public void actionPerformed(final ActionEvent evt) {
				status.setText("Making pbo..");
				SwingUtilities.invokeLater(new Runnable() {
					public void run() {
						menuItemMakePBOPerformed();
					}
				});
			}
		});
		menuManual.addActionListener(new ActionListener() {
			public void actionPerformed(final ActionEvent evt) {
				menuItemManualPerformed();
			}
		});
	}

	public void init() {

		try {
			menuEraseMission.setEnabled(false);
			menuSaveMission.setEnabled(false);
			menuPropertiesMission.setEnabled(false);
			menuPreferencesMission.setEnabled(false);
			menuGenerateLoadout.setEnabled(false);
			menuImportMission.setEnabled(false);
			menuRefresh.setEnabled(false);
			menuLoadMission.setEnabled(false);
			menuViewContent.setEnabled(false);
			menuViewAddons.setEnabled(false);
			menuAutoAssign.setEnabled(false);
			menuHideNonAssigned.setEnabled(false);
			menuHideNonAssigned.setSelected(false);
			menuApplyMission.setEnabled(false);
			status.setText("Loading, please wait...");
			jProgressBarEditor.setVisible(true);
			buttonSaveAsProfile.setEnabled(false);
			buttonApplyProfile.setEnabled(false);
			menuMissionExportFTP.setEnabled(true);
			facade.getLoadoutPanel().setOpenRuckButton(false);
			facade.getLoadoutPanel().enableClearButton(false);
			facade.getLoadoutPanel().SetDefaultButton(false);
			facade.getLoadoutPanel().SetVehicleButton(false);
			facade.getLoadoutPanel().enableClearButton(false);
			facade.setBottonVehiclePusched(false);
			facade.setToBeSaved(false);
			facade.setEnableUpdate(false);
			facade.setProfileEditMode(false);
			menuProfilesEdit.setEnabled(false);
			menuMakePBO.setEnabled(false);

			// Determine Installation Path
			CommonService commonService = new CommonService();
			commonService.determineInstallationPath();

			// Determine if ACE mod is selected
			facade.setNoACE(commonService.isACESelected());

			// Desable ACE back weapon feature if ACE mod is not selected
			if (facade.isNoACE()) {
				facade.getLoadoutPanel().setBackhandButton(false);
			} else {
				facade.getLoadoutPanel().setBackhandButton(true);
			}

			// Determine if ACRE mod is selected
			facade.setNoACRE(commonService.isACRESelected());

			// Update UI with recently opened mission file names
			updateMissionMenu();

			// Load Data from disk
			WeaponService weaponService = new WeaponService();
			MagazineService magazineService = new MagazineService();
			UnitService unitService = new UnitService();
			jProgressBarEditor.setMinimum(0);
			jProgressBarEditor.setMaximum(weaponService.readWeaponsClasslist());
			weaponService.getWeaponDAO().addObservateur(new Observateur() {
				public void update(double value) {
					jProgressBarEditor.setValue((int) value);
				}
			});
			weaponService.loadWeapons();
			jProgressBarEditor.setMinimum(0);
			jProgressBarEditor.setMaximum(magazineService
					.readMagazinesClasslist());
			magazineService.getMagazineDAO().addObservateur(new Observateur() {
				public void update(double value) {
					jProgressBarEditor.setValue((int) value);
				}
			});
			magazineService.loadMagazines();
			jProgressBarEditor.setMinimum(0);
			jProgressBarEditor.setMaximum(unitService.readUnitsClasslist());
			unitService.getUnitDAO().addObservateur(new Observateur() {
				public void update(double value) {
					jProgressBarEditor.setValue((int) value);
				}
			});
			unitService.loadUnits();

			// Data loaded
			jProgressBarEditor.setVisible(false);
			weaponService.getWeaponDAO().delObservateur();
			status.setText("Ready");
			menuLoadMission.setEnabled(true);
			menuImportMission.setEnabled(true);
			menuProfilesEdit.setEnabled(true);

			// Check for update
			checkForUpdate();

		} catch (RuntimeException e) {
			e.printStackTrace();
			JOptionPane.showMessageDialog(this, "An error occured." + "\n"
					+ e.getMessage() + "\n" + "Application will now close.",
					"Error", JOptionPane.ERROR_MESSAGE);
			dispose();
			System.exit(0);
		}
	}

	private void updateMissionMenu() {

		int numberMenuItems = menuMission.getItemCount();

		if (numberMenuItems > 25) {
			for (int i = numberMenuItems - 1; i > 25; i--) {
				JMenuItem menuItem = menuMission.getItem(i);
				menuMission.remove(menuItem);
			}
		}

		CommonService commonService = new CommonService();
		Stack<String> stack = commonService.getResentlyEditedMissions();

		if ((stack.size() > 0) && !(numberMenuItems > 23)) {
			menuMission.add(new JSeparator());
		}

		for (int i = 0; i < stack.size(); i++) {
			final String missionFileName = stack.elementAt(i);
			JMenuItem menuMissionFileName = new JMenuItem(i + 1 + ". "
					+ missionFileName);
			menuMission.add(menuMissionFileName);
			menuMissionFileName.addActionListener(new ActionListener() {
				public void actionPerformed(final ActionEvent evt) {
					menuItemLoadMissionActionPerformed(missionFileName);
				}
			});
		}
	}

	private void menuItemAutoAssignPerformed() {
		AutoAssignPanel assignPanel = new AutoAssignPanel(facade);
		assignPanel.setVisible(true);
	}

	private void menuCheckBoxHideNonAssignedPerformed(ActionEvent e) {
		JCheckBoxMenuItem checkBoxMenuItem = (JCheckBoxMenuItem) e.getSource();
		facade.setHideNonAssignedUnits(checkBoxMenuItem.isSelected());
		final String type = (String) jComboBoxType.getSelectedItem();
		final String name = (String) jcomboBoxDisplayOptions.getSelectedItem();
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				try {
					unitsPanel.update(type, name);
				} catch (FinderException e) {
					// JOptionPane.showMessageDialog(this, e.getMessage(),
					// "Error",JOptionPane.ERROR_MESSAGE);
				}
			}
		});
	}

	private void menuItemViewContentPerformed() {
		if (Desktop.isDesktopSupported()) {
			Desktop desktop = Desktop.getDesktop();
			if (desktop.isSupported(Desktop.Action.OPEN)) {
				try {
					MissionService missionService = new MissionService();
					String path = missionService.getMission()
							.getMissionFolderPath();
					desktop.open(new File(path));
				} catch (Exception e) {
					JOptionPane
							.showMessageDialog(
									this,
									e.getMessage()
											+ "\n"
											+ "Save your work then re-import the associated mission.sqm file.",
									"Error", JOptionPane.ERROR_MESSAGE);
					// e.printStackTrace();
				}
			}
		}
	}

	private void menuItemUpdatePerformed() {

		FtpService ftpService = new FtpService();
		try {
			String availableVersion = ftpService.checkForUpdate();

			if (availableVersion != null) {

				int response = JOptionPane.showConfirmDialog(this,
						"A new update is available. Proceed update?", "Update",
						JOptionPane.OK_CANCEL_OPTION);

				if (response == 0) {
					String command = "java -jar -Djava.net.preferIPv4Stack=true lea-updater.jar";
					try {
						Runtime.getRuntime().exec(command);
						System.exit(0);
					} catch (IOException ex) {
						ex.printStackTrace();
						JOptionPane.showMessageDialog(this, ex.getMessage(),
								"Update", JOptionPane.ERROR_MESSAGE);
					}
				}
			} else {
				JOptionPane.showMessageDialog(this, "No new update available.",
						"Update", JOptionPane.INFORMATION_MESSAGE);

			}
		} catch (FtpException e) {
			e.printStackTrace();
			JOptionPane.showMessageDialog(this, e.getMessage(), "Update",
					JOptionPane.ERROR_MESSAGE);
		}
	}

	private void checkForUpdate() {
		FtpService ftpService = new FtpService();
		try {
			String availableVersion = ftpService.checkForUpdate();

			if (availableVersion != null) {

				int response = JOptionPane.showConfirmDialog(this,
						"A new update is available. Proceed update?", "Update",
						JOptionPane.OK_CANCEL_OPTION);

				if (response == 0) {
					String command = "java -jar -Djava.net.preferIPv4Stack=true lea-updater.jar";
					try {
						Runtime.getRuntime().exec(command);
						System.exit(0);
					} catch (IOException ex) {
						ex.printStackTrace();
						JOptionPane.showMessageDialog(this, ex.getMessage(),
								"Update", JOptionPane.ERROR_MESSAGE);
					}
				}
			}
		} catch (FtpException e) {
			// e.printStackTrace();
		}
	}

	private void menuItemTransfertFTPPerformed(final String mode) {
		FtpLoggerPanel ftplogger = new FtpLoggerPanel(facade, mode);
		ftplogger.setVisible(true);
	}

	private void menuItemAutoConfigPerformed() {
		AutoConfiguratorPanel autoConfigurator = new AutoConfiguratorPanel(
				facade);
		autoConfigurator.setVisible(true);
	}

	private void menuItemOpenActionPerformed(String folderName) {
		if (Desktop.isDesktopSupported()) {
			Desktop desktop = Desktop.getDesktop();
			if (desktop.isSupported(Desktop.Action.OPEN)) {
				try {
					CommonService commonService = new CommonService();
					String path = commonService.getInstallationPath() + "/"
							+ folderName;
					desktop.open(new File(path));
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
	}

	private void saveAsProfileButtonPerformed() {
		ProfileSavePanel profileSavePanel = new ProfileSavePanel(facade);
		profileSavePanel.setVisible(true);
		this.setEnabled(false);
	}

	private void applyProfileButtonPerformed() {
		ProfileApplyPanel profileApplyPanel = new ProfileApplyPanel(facade);
		profileApplyPanel.setVisible(true);
		this.setEnabled(false);
	}

	private void menuItemAboutPerformed() {
		AboutPanel about = new AboutPanel(facade);
		about.setVisible(true);
	}

	private void menuItemModsPerformed() {
		AddonsManagerPanel mods = new AddonsManagerPanel(facade);
		mods.setVisible(true);
	}

	private void menuItemEraseActionPerformed() {
		int option = JOptionPane.showConfirmDialog(this, "Clear all loadouts?",
				"Confirmation", JOptionPane.OK_CANCEL_OPTION);
		if (option == 0) {
			MissionService missionService = new MissionService();
			missionService.eraseUnitsLoadout();
			facade.getLoadoutPanel().init();
			facade.getRuckandModsPanel().init();
		}
	}

	private void menuItemApplyActionPerformed() {

		try {
			CommonService commonService = new CommonService();
			String path = commonService.getInstallationPath();
			String missionsFolderPath = path + "/missions";
			status.setText("Loading LEA mission...");
			JFileChooser fc = new JFileChooser(missionsFolderPath);
			FileFilter currentFileFilter = fc.getFileFilter();
			if (currentFileFilter != null) {
				fc.removeChoosableFileFilter(currentFileFilter);
			}
			FileFilter typeMission = new ExtensionFilter(
					"LEA mission (.lea.mission)", ".mission");
			fc.addChoosableFileFilter(typeMission);

			fc.setLocale(Locale.ENGLISH);
			int returnVal = fc.showOpenDialog(MissionEditor.this);

			if (returnVal == JFileChooser.APPROVE_OPTION) {
				File file = fc.getSelectedFile();

				MissionService missionService = new MissionService();
				missionService.applyMission(file.getAbsolutePath());

				facade.getUnitsPanel().init();
				facade.getLoadoutPanel().init();
				facade.getRuckandModsPanel().init();

				facade.setFactionSelected(true);
				facade.getAmmoPanel().init();
				facade.setFactionSelected(false);

				menuSaveMission.setEnabled(true);
				menuPropertiesMission.setEnabled(true);
				menuGenerateLoadout.setEnabled(true);
				menuRefresh.setEnabled(true);
				menuAutoAssign.setEnabled(false);
				menuHideNonAssigned.setEnabled(true);
				menuApplyMission.setEnabled(true);

				if (facade.isNoACE()) {
					facade.getLoadoutPanel().setBackhandButton(false);
				} else {
					facade.getLoadoutPanel().setBackhandButton(true);
				}

				facade.getLoadoutPanel().setOpenRuckButton(false);
				facade.getLoadoutPanel().enableClearButton(true);
				jComboBoxType.setEnabled(true);
				jcomboBoxDisplayOptions.setEnabled(true);
				facade.getAmmoPanel().SetFactionComboBox(true);
				jComboBoxType.setSelectedIndex(0);
				jcomboBoxDisplayOptions.setSelectedIndex(0);
				menuPreferencesMission.setEnabled(true);
				menuEraseMission.setEnabled(true);
				menuMakePBO.setEnabled(true);
				menuViewContent.setEnabled(true);
				menuViewAddons.setEnabled(true);

				title = "Loadout Editor for ArmA 2 Combined Operation & ACE 2"
						+ " - "
						+ missionService.getMission().getMissionFileName();
				setTitle(title);
				status.setText("Ready");

				JOptionPane.showMessageDialog(this, "Mission applied.", "Load",
						JOptionPane.INFORMATION_MESSAGE);
			}
		} catch (Exception e) {
			JOptionPane
					.showMessageDialog(this, "Can't apply the mission!" + "\n"
							+ e.getMessage(), "Error",
							JOptionPane.ERROR_MESSAGE);
		} finally {
			status.setText("Ready");
			this.setEnabled(true);
		}
	}

	// This method load a serialized mission from missions folder.
	private void menuItemLoadActionPerformed() {

		CommonService commonService = new CommonService();
		String missionsFolderPath = commonService.getMissionsFolderPath();
		status.setText("Loading LEA mission...");
		JFileChooser fc = new JFileChooser(missionsFolderPath);
		FileFilter currentFileFilter = fc.getFileFilter();
		if (currentFileFilter != null) {
			fc.removeChoosableFileFilter(currentFileFilter);
		}
		FileFilter typeMission = new ExtensionFilter("LEA mission ("
				+ commonService.getFileMissionExtension() + ")", ".mission");
		fc.addChoosableFileFilter(typeMission);

		fc.setLocale(Locale.ENGLISH);
		int returnVal = fc.showOpenDialog(MissionEditor.this);

		if (returnVal == JFileChooser.APPROVE_OPTION) {
			File file = fc.getSelectedFile();
			try {
				loadMission(file);
				MissionService missionService = new MissionService();
				commonService.setResentlyEditedMission(missionService
						.getMission().getMissionFileName());
				updateMissionMenu();
			} catch (Exception e) {
				JOptionPane.showMessageDialog(this, "Can't load the mission!"
						+ "\n" + e.getMessage(), "Error",
						JOptionPane.ERROR_MESSAGE);
			} finally {
				status.setText("Ready");
				this.setEnabled(true);
			}
		} else {
			status.setText("Ready");
		}
	}

	private void menuItemLoadMissionActionPerformed(String missionFileName) {
		System.out.println(missionFileName);
		status.setText("Loading LEA mission...");
		CommonService commonService = new CommonService();
		String missionsFolderPath = commonService.getMissionsFolderPath();
		File file = new File(missionsFolderPath + "/" + missionFileName
				+ commonService.getFileMissionExtension());

		try {
			loadMission(file);
			commonService.setResentlyEditedMission(missionFileName);
		} catch (Exception e) {
			JOptionPane
					.showMessageDialog(this, "Can't load the mission!" + "\n"
							+ e.getMessage(), "Error",
							JOptionPane.ERROR_MESSAGE);
			commonService.removeResentlyEditedMission(missionFileName);
		} finally {
			updateMissionMenu();
			status.setText("Ready");
			this.setEnabled(true);
		}
	}

	private void loadMission(File file) throws LoadingException,
			FinderException {

		MissionService missionService = new MissionService();
		missionService.loadMission(file.getAbsolutePath());
		facade.getUnitsPanel().init();
		facade.getLoadoutPanel().init();
		facade.getRuckandModsPanel().init();

		facade.setFactionSelected(true);
		facade.getAmmoPanel().init();
		facade.setFactionSelected(false);

		menuSaveMission.setEnabled(true);
		menuPropertiesMission.setEnabled(true);
		menuGenerateLoadout.setEnabled(true);
		menuRefresh.setEnabled(true);
		menuAutoAssign.setEnabled(false);
		menuHideNonAssigned.setEnabled(true);
		menuApplyMission.setEnabled(true);
		if (facade.isNoACE()) {
			facade.getLoadoutPanel().setBackhandButton(false);
		} else {
			facade.getLoadoutPanel().setBackhandButton(true);
		}
		facade.getLoadoutPanel().setOpenRuckButton(false);
		facade.getLoadoutPanel().enableClearButton(true);
		jComboBoxType.setEnabled(true);
		jcomboBoxDisplayOptions.setEnabled(true);
		facade.getAmmoPanel().SetFactionComboBox(true);
		jComboBoxType.setSelectedIndex(0);
		jcomboBoxDisplayOptions.setSelectedIndex(0);
		menuPreferencesMission.setEnabled(true);
		menuEraseMission.setEnabled(true);
		menuMakePBO.setEnabled(true);
		buttonApplyProfile.setEnabled(true);
		buttonSaveAsProfile.setEnabled(true);
		checkBoxEditable.setEnabled(true);
		checkBoxEditable.setSelected(false);
		checkBoxEditable.setForeground(Color.black);
		menuViewContent.setEnabled(true);
		menuViewAddons.setEnabled(true);

		title = "Loadout Editor for ArmA 2 Combined Operation & ACE 2" + " - "
				+ missionService.getMission().getMissionFileName();
		setTitle(title);
		status.setText("Ready");

		JOptionPane.showMessageDialog(this, "Mission loaded.", "Load",
				JOptionPane.INFORMATION_MESSAGE);
	}

	private void menuItemSaveActionPerformed() {
		try {
			MissionService missionService = new MissionService();
			saveUnitLoadout(facade.getId());
			missionService.saveMissionListMods(facade.isNoACE());
			missionService.saveMission();
			facade.setToBeSaved(false);

			JOptionPane.showMessageDialog(this,
					"Mission saved in LEA missions folder.", "Save",
					JOptionPane.INFORMATION_MESSAGE);

		} catch (WritingException e) {
			JOptionPane.showMessageDialog(this, e.getMessage(), "Error",
					JOptionPane.ERROR_MESSAGE);
		}
	}

	private void menuItemPreferencesPerformed() {
		PreferencesPanel preferences = new PreferencesPanel(facade);
		preferences.setVisible(true);
	}

	private void menuItemPropertiesPerformed() {
		MissionService missionService = new MissionService();
		MissionDTO missionDTO = missionService.loadMissionInfos();

		JOptionPane.showMessageDialog(this, "Mission File Name     "
				+ missionDTO.getMissionFileName() + "\n"
				+ "Number of Players     " + missionDTO.getNumberPlayers()
				+ "\n" + "Mission Name            "
				+ missionDTO.getMissionName() + "\n" + "Mission Description   "
				+ missionDTO.getMissionDescription(), "Mission Properties",
				JOptionPane.INFORMATION_MESSAGE);
	}

	private void menuItemImportMissionSQMPerformed() {

		JFileChooser fc = new JFileChooser();
		status.setText("Importing mission.sqm...");

		FileFilter currentFileFilter = fc.getFileFilter();
		if (currentFileFilter != null) {
			fc.removeChoosableFileFilter(currentFileFilter);
		}
		FileFilter typeSQMMission = new ExtensionFilter(
				"ArmA 2 mission (mission.sqm)", ".sqm");
		fc.addChoosableFileFilter(typeSQMMission);

		fc.setLocale(Locale.ENGLISH);
		int returnVal = fc.showOpenDialog(MissionEditor.this);

		if (returnVal == JFileChooser.APPROVE_OPTION) {
			File file = fc.getSelectedFile();
			System.out.println(file.getAbsolutePath());

			// Determine if lea.mission exists in folder "lea" of the imported
			// ArmA 2 mission.
			File missionFolder = file.getParentFile();
			MissionService missionService = new MissionService();
			boolean sourceExists = missionService
					.isMissionExists(missionFolder);

			// Determine if the same lea.mission is in LEA missions folder.
			CommonService commonService = new CommonService();
			String missionFilePath = commonService.getMissionsFolderPath()
					+ "/" + missionFolder.getName() + ".lea.mission";
			boolean destinationExists = new File(missionFilePath).exists();

			if (sourceExists && destinationExists) {
				int response = JOptionPane
						.showConfirmDialog(
								this,
								missionFolder.getName()
										+ ".lea.mission "
										+ "already exists in LEA missions folder. Overwrite local copy?",
								"Import", JOptionPane.YES_NO_OPTION);
				if (response == 0) {
					try {
						missionService.copyMissionToLEA(missionFolder
								.getAbsolutePath());
					} catch (WritingException e) {
						JOptionPane.showMessageDialog(this, e.getMessage(),
								"Error", JOptionPane.ERROR_MESSAGE);
					}
				}
			}

			else if (sourceExists) {
				try {
					missionService.copyMissionToLEA(missionFolder
							.getAbsolutePath());
				} catch (WritingException e) {
					JOptionPane.showMessageDialog(this, e.getMessage(),
							"Error", JOptionPane.ERROR_MESSAGE);
				}
			}
			importMissionSQM(file.getAbsolutePath());
		}
		status.setText("Ready");
	}

	public void importMissionSQM(String missionSQMPath) {

		MissionService missionService = new MissionService();
		try {
			System.out.println("Path = " + missionSQMPath);
			missionService.importMissionSQM(missionSQMPath);
			facade.getUnitsPanel().init();
			facade.getLoadoutPanel().init();
			facade.getRuckandModsPanel().init();

			facade.setFactionSelected(true);
			facade.getAmmoPanel().init();
			facade.setFactionSelected(false);

			menuPropertiesMission.setEnabled(true);
			menuPreferencesMission.setEnabled(true);
			menuGenerateLoadout.setEnabled(true);
			menuRefresh.setEnabled(true);
			menuAutoAssign.setEnabled(false);
			menuHideNonAssigned.setEnabled(true);
			menuApplyMission.setEnabled(true);
			jComboBoxType.setEnabled(true);
			jcomboBoxDisplayOptions.setEnabled(true);
			facade.getAmmoPanel().SetFactionComboBox(true);
			jComboBoxType.setSelectedIndex(0);
			jcomboBoxDisplayOptions.setSelectedIndex(0);
			buttonApplyProfile.setEnabled(true);
			buttonSaveAsProfile.setEnabled(true);
			checkBoxEditable.setEnabled(true);
			checkBoxEditable.setSelected(false);
			checkBoxEditable.setForeground(Color.black);

			title = "Loadout Editor for ArmA 2 Combined Operation & ACE 2"
					+ " - " + missionService.getMission().getMissionFileName();
			setTitle(title);

			JOptionPane.showMessageDialog(this,
					"Mission successfully imported.", "Import",
					JOptionPane.INFORMATION_MESSAGE);

			menuPreferencesMission.setEnabled(true);
			menuEraseMission.setEnabled(true);
			menuViewContent.setEnabled(true);
			menuViewAddons.setEnabled(true);
			menuMakePBO.setEnabled(true);

			CommonService commonService = new CommonService();
			commonService.setResentlyEditedMission(missionService.getMission()
					.getMissionFileName());

		} catch (LoadingException e) {
			JOptionPane.showMessageDialog(this, e.getMessage(), "Error",
					JOptionPane.ERROR_MESSAGE);
		} catch (FinderException e) {
			JOptionPane.showMessageDialog(this, e.getMessage(), "Error",
					JOptionPane.ERROR_MESSAGE);
		} finally {
			status.setText("Ready");
		}
	}

	private void menuItemViewAddonsPerformed() {

		saveUnitLoadout(facade.getId());
		RequiredAddonsPanel requiredAddonsPanel = new RequiredAddonsPanel(
				facade);
		requiredAddonsPanel.setVisible(true);
	}

	private void menuItemRefreshPerformed() {
		MissionService missionService = new MissionService();
		try {
			saveUnitLoadout(facade.getId());
			missionService.saveMissionListMods(facade.isNoACE());
			missionService.saveMission();
			importMissionSQM(missionService.getMission().getMissionPath());

		} catch (WritingException e) {
			JOptionPane.showMessageDialog(this, e.getMessage(), "Error",
					JOptionPane.ERROR_MESSAGE);
		}
	}

	private void menuItemGenerateLoadoutPerformed() {

		MissionService missionService = new MissionService();
		saveUnitLoadout(facade.getId());
		missionService.saveMissionListMods(facade.isNoACE());

		String path = missionService.getMission().getMissionFolderPath();
		File folderMissionFile = new File(path);
		File parentFolderMissionFile = folderMissionFile.getParentFile();
		JFileChooser fc = null;
		if (!parentFolderMissionFile.exists()) {
			fc = new JFileChooser();
		} else {
			fc = new JFileChooser(parentFolderMissionFile.getAbsolutePath());
		}
		fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		fc.setCurrentDirectory(folderMissionFile);

		int returnVal = fc.showOpenDialog(MissionEditor.this);

		if (returnVal == JFileChooser.APPROVE_OPTION) {

			File file = fc.getSelectedFile();

			try {
				missionService.generateLoadoutSQFScript(file.getAbsolutePath(),
						facade.isNoACE());

				int response = JOptionPane
						.showConfirmDialog(
								this,
								"Also insert call for loadout.sqf script into init.sqf?",
								"loadout.sqf", JOptionPane.YES_NO_OPTION);

				if (response == 0) {
					missionService.generateInitSQFScript(
							file.getAbsolutePath(), facade.isNoACE());
				}

				missionService.saveMission();
				facade.setToBeSaved(false);
				String destinationPath = file.getAbsolutePath();
				missionService.copyMissionFromLEA(destinationPath);
				menuViewContent.setEnabled(true);
				menuViewAddons.setEnabled(true);

				JOptionPane.showMessageDialog(this,
						"Script successfully generated in mission folder."
								+ "\nMission saved in LEA missions folder.",
						"Script Loadout.sqf", JOptionPane.INFORMATION_MESSAGE);

			} catch (WritingException e) {
				// e.printStackTrace();
				JOptionPane.showMessageDialog(this, e.getMessage(), "Error",
						JOptionPane.ERROR_MESSAGE);
			} catch (IOException e) {
				// e.printStackTrace();
				JOptionPane.showMessageDialog(this,
						"Can't write loadout.sqf file!", "Error",
						JOptionPane.ERROR_MESSAGE);
			}
		}
	}

	private void menuExitPerformed() {

		int rep = 1;

		if (facade.isToBeSaved() == true) {
			rep = JOptionPane.showConfirmDialog(this, "Save the mission?");
		}
		switch (rep) {
		case 0:
			MissionService missionService = new MissionService();
			saveUnitLoadout(facade.getId());
			try {
				missionService.saveMission();
				System.exit(0);
			} catch (WritingException e) {
				JOptionPane.showMessageDialog(this, e.getMessage(), "Error",
						JOptionPane.ERROR_MESSAGE);
			}
			break;
		case 1:
			if (facade.getProfilesEditor() != null)
				facade.getProfilesEditor().dispose();
			System.exit(0);
			break;
		case 2:
			break;
		}
	}

	private void comboBoxTypePerformed() {

		final String type = (String) jComboBoxType.getSelectedItem();
		final String name = (String) jcomboBoxDisplayOptions.getSelectedItem();

		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				try {
					unitsPanel.update(type, name);
				} catch (FinderException e) {
					// JOptionPane.showMessageDialog(this, e.getMessage(),
					// "Error",JOptionPane.ERROR_MESSAGE);
				}
			}
		});
	}

	private void comboBoxNamePerformed() {

		final String type = (String) jComboBoxType.getSelectedItem();
		final String name = (String) jcomboBoxDisplayOptions.getSelectedItem();

		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				try {
					unitsPanel.update(type, name);
				} catch (FinderException e) {
					// JOptionPane.showMessageDialog(this, e.getMessage(),
					// "Error",JOptionPane.ERROR_MESSAGE);
				}
			}
		});
	}

	public void checkBoxEditablePerformed() {
		MissionService missionService = new MissionService();
		boolean value = true;

		if (checkBoxEditable.isSelected()) {
			value = false;
			checkBoxEditable.setForeground(Color.red);
			facade.getLoadoutPanel().enableWeightPanel(false);
			facade.setEnableUpdate(false);
			buttonApplyProfile.setEnabled(false);
			buttonSaveAsProfile.setEnabled(false);
		} else {
			checkBoxEditable.setForeground(Color.black);
			UnitDTO unitDTO = null;
			try {
				unitDTO = missionService.loadUnit(facade.getId());
			} catch (FinderException e) {
				// e.printStackTrace();
			}
			if (unitDTO != null) {
				if (!unitDTO.isVehicle()) {
					facade.getLoadoutPanel().enableWeightPanel(true);
				}
			}
			facade.setEnableUpdate(true);
			buttonApplyProfile.setEnabled(true);
			buttonSaveAsProfile.setEnabled(true);
		}
		missionService.setUnitEditable(value, facade.getId());
	}

	public void saveUnitLoadout(int unitId) {

		MissionService missionService = new MissionService();

		try {
			missionService.saveUnitPrimaryWeaponLoadout(facade
					.getLoadoutPanel().getPrimaryWeapon(), unitId);
			missionService.saveUnitSecondaryWeaponLoadout(facade
					.getLoadoutPanel().getSecondaryWeapon(), unitId);
			missionService.saveUnitBackWeaponLoadout(facade.getLoadoutPanel()
					.getBackWeapon(), unitId);
			missionService.saveUnitPistolLoadout(facade.getLoadoutPanel()
					.getPistol(), unitId);
			missionService.saveUnitOpticalsLoadout(facade.getLoadoutPanel()
					.getOpticals(), unitId);
			missionService.saveUnitItems(facade.getLoadoutPanel().getItems(),
					unitId);
			missionService.saveUnitPrimaryMagazines(facade.getLoadoutPanel()
					.getPrimaryMagazines(), unitId);
			missionService.saveUnitSecondaryMagazines(facade.getLoadoutPanel()
					.getSecondaryMagazines(), unitId);
			missionService.saveUnitMods(facade.getRuckandModsPanel()
					.getAddonsListModel().getList(), unitId);
			missionService.saveUnitRuck(facade.getRuckandModsPanel()
					.getListRuck(), unitId);
			missionService.saveUnitFirstAid(facade.getLoadoutPanel()
					.getListFirstAid(), unitId);

		} catch (FinderException e) {
			// e.printStackTrace();
		}
	}

	public void saveUnitProfileName(int unitId) {
		MissionService missionService = new MissionService();
		missionService.saveUnitProfileName(labelProfileName.getText(), unitId);
	}

	public void loadUnitLoadout() {

		MissionService missionService = new MissionService();
		facade.getLoadoutPanel().init();
		facade.getRuckandModsPanel().init();

		try {
			facade.getLoadoutPanel().setPrimaryMagazineCapacity(
					missionService.loadUnitNumberPrimarySlot(facade.getId()));
			facade.getLoadoutPanel().initVisibilityPrimaryMagazinePanels();
		} catch (FinderException e) {
		}

		try {
			facade.getLoadoutPanel().setSecondaryMagazineCapacity(
					missionService.loadUnitNumberSecondarySlot(facade.getId()));
			facade.getLoadoutPanel().initVisibilitySecondaryMagazinePanels();
		} catch (FinderException e) {
		}

		try {
			facade.getLoadoutPanel()
					.setPrimaryWeapon(
							missionService.loadUnitPrimaryWeaponLoadout(facade
									.getId()));
		} catch (FinderException e) {
		}
		try {
			facade.getLoadoutPanel().SetSecondaryWeapon(
					missionService.loadUnitSecondaryWeaponLoadout(facade
							.getId()));
		} catch (FinderException e) {
		}
		try {
			facade.getLoadoutPanel().setBackWeapon(
					missionService.loadUnitBackWeaponLoadout(facade.getId()));
		} catch (FinderException e) {
		}
		try {
			facade.getLoadoutPanel().SetPistol(
					missionService.loadUnitPistolLoadout(facade.getId()));
		} catch (FinderException e) {
		}
		try {
			facade.getLoadoutPanel().SetOpticals(
					missionService.loadUnitOpticalLoadout(facade.getId()));
		} catch (FinderException e) {
		}
		try {
			facade.getLoadoutPanel().SetItems(
					missionService.loadUnitItemLoadout(facade.getId()));
		} catch (FinderException e) {
		}
		try {
			facade.getLoadoutPanel().SetPrimaryMagazines(
					missionService.loadUnitPrimaryMagazineLoadout(facade
							.getId()));
		} catch (FinderException e) {
		}
		try {
			facade.getLoadoutPanel().SetSecondaryMagazines(
					missionService.loadUnitSecondaryMagazineLoadout(facade
							.getId()));
		} catch (FinderException e) {
		}
		try {
			facade.getRuckandModsPanel().setListRuck(
					missionService.loadUnitRuckWeapons(facade.getId()));
		} catch (FinderException e) {
		}
		try {
			facade.getRuckandModsPanel().setListRuck(
					missionService.loadUnitRuckMagazines(facade.getId()));
		} catch (FinderException e) {
		}
		try {
			facade.getLoadoutPanel().setListFirstAid(
					missionService.loadUnitFirstAidMagazineLoadout(facade
							.getId()));
		} catch (FinderException e) {
		}

	}

	private void menuItemProfilesEditPerformed() {

		if (!this.facade.isProfileEditMode()) {

			facade.setProfileEditMode(true);
			menuProfilesEdit.setEnabled(false);
			// SwingUtilities.invokeLater(new Runnable() {
			// public void run() {
			final Facade profilesFacade = new Facade();
			profilesFacade.setMissionEditor(this);
			new ProfilesPanel(profilesFacade);
			new AmmoPanel(profilesFacade);
			new LoadoutACEPanel(profilesFacade);
			new RuckandModsPanel(profilesFacade);
			ProfilesEditor profilesEditor = new ProfilesEditor(profilesFacade,
					facade);
			facade.setProfilesEditor(profilesEditor);

			status.setText("Loading profiles, please wait...");

			profilesFacade.getProfilesPanel().init();
			profilesFacade.getLoadoutPanel().init();
			profilesFacade.getRuckandModsPanel().init();
			profilesEditor.init();

			// Loading profiles in a dedicated thread
			ProfilesPanelLoader profilesLoader = new ProfilesPanelLoader(
					profilesFacade);

			profilesLoader.start();
			try {
				profilesLoader.join();
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

			// Display profiles editor
			profilesEditor.setVisible(true);

			status.setText("Ready");

			// Loading ammo panel in dedicated threads
			profilesFacade.setFactionSelected(true);
			profilesFacade.getAmmoPanel().init();
			profilesFacade.setFactionSelected(false);
		}

	}

	public void loadMission(String path) {

		try {
			CommonService commonService = new CommonService();
			status.setText("Loading LEA mission...");

			MissionService missionService = new MissionService();
			missionService.loadMission(path);
			facade.getUnitsPanel().init();
			facade.getLoadoutPanel().init();
			facade.getRuckandModsPanel().init();

			facade.setFactionSelected(true);
			facade.getAmmoPanel().init();
			facade.setFactionSelected(false);

			menuSaveMission.setEnabled(true);
			menuPropertiesMission.setEnabled(true);
			menuGenerateLoadout.setEnabled(true);

			if (facade.isNoACE()) {
				facade.getLoadoutPanel().setBackhandButton(false);
			} else {
				facade.getLoadoutPanel().setBackhandButton(true);
			}

			facade.getLoadoutPanel().setOpenRuckButton(false);
			facade.getLoadoutPanel().enableClearButton(true);
			jComboBoxType.setEnabled(true);
			jcomboBoxDisplayOptions.setEnabled(true);
			facade.getAmmoPanel().SetFactionComboBox(true);
			jComboBoxType.setSelectedIndex(0);
			jcomboBoxDisplayOptions.setSelectedIndex(0);
			menuPreferencesMission.setEnabled(true);

			title = "Loadout Editor for ArmA 2 Combined Operation & ACE 2"
					+ " - " + missionService.getMission().getMissionFileName();
			setTitle(title);
			status.setText("Ready");

			JOptionPane.showMessageDialog(this, "Mission loaded.", "Load",
					JOptionPane.INFORMATION_MESSAGE);

		} catch (Exception e) {
			JOptionPane
					.showMessageDialog(this, "Can't load the mission!" + "\n"
							+ e.getMessage(), "Error",
							JOptionPane.ERROR_MESSAGE);

		} finally {
			status.setText("Ready");
			this.setEnabled(true);
		}
	}

	public void loadProfile(String path) {

		status.setText("Loading profiles...");
		facade.setProfileEditMode(true);
		menuProfilesEdit.setEnabled(false);
		final Facade profilesFacade = new Facade();
		profilesFacade.setMissionEditor(this);
		new ProfilesPanel(profilesFacade);
		new AmmoPanel(profilesFacade);
		new LoadoutACEPanel(profilesFacade);
		new RuckandModsPanel(profilesFacade);
		ProfilesEditor profilesEditor = new ProfilesEditor(profilesFacade,
				facade);
		facade.setProfilesEditor(profilesEditor);

		// load profile and copy it into profiles folder
		profilesEditor.loadProfile(path);

		// Loading profiles in dedicated thread
		profilesFacade.getProfilesPanel().init();

		profilesFacade.getLoadoutPanel().init();
		profilesFacade.getRuckandModsPanel().init();
		profilesEditor.init();

		// Wait for profiles to be loaded
		try {
			if (profilesFacade.getProfilesPanel().getProfilesPanelLoader() != null) {
				profilesFacade.getProfilesPanel().getProfilesPanelLoader()
						.join();
			}
		} catch (InterruptedException e) {
			e.printStackTrace();
		}

		status.setText("Ready");

		// Display profiles in profiles editor
		profilesEditor.setVisible(true);

		// Loading ammo panel in dedicated threads
		profilesFacade.setFactionSelected(true);
		profilesFacade.getAmmoPanel().init();
		profilesFacade.setFactionSelected(false);
	}

	public void updateMissionSQM() {

		MissionService missionService = new MissionService();
		try {
			missionService.backupMissionSQM();// made a backup of mission.sqm =>
			// mission.sqm.bck
			missionService.deleteMissionSQM();
			missionService.generateMissionSQM();
			// JOptionPane.showMessageDialog(this,"Some units have been auto assigned a name."+
			// "\n" +
			// "If mission is open in ArmA 2 Editor, reload it to see changes.","Import",
			// JOptionPane.INFORMATION_MESSAGE);
		} catch (WritingException e1) {
			e1.printStackTrace();
			JOptionPane
					.showMessageDialog(
							this,
							"Failed to rewrite mission.sqm. Rollbacking to original one.",
							"Error", JOptionPane.ERROR_MESSAGE);

			missionService.deleteMissionSQM();

			try {
				missionService.rollBackMissionSQM();
			} catch (WritingException e2) {
				e2.printStackTrace();
				JOptionPane
						.showMessageDialog(
								this,
								"Failed to rollback. Try to change mission.sqm.bck to mission.sqm by hands.",
								"Error", JOptionPane.ERROR_MESSAGE);
			}
			try {
				CommonService commonService = new CommonService();
				missionService.loadMission(commonService
						.getMissionsFolderPath()
						+ "/"
						+ missionService.getMission().getMissionFileName()
						+ ".lea.mission");
				facade.getUnitsPanel().init();
				facade.getLoadoutPanel().init();
				facade.getRuckandModsPanel().init();
			} catch (LoadingException e3) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			} catch (FinderException e4) {
				// TODO Auto-generated catch block
				e4.printStackTrace();
			}
		}
	}

	private void menuItemExtractPBOPerformed() {

		if (!System.getProperty("os.name").contains("Windows")) {
			JOptionPane
					.showMessageDialog(
							this,
							"Extracting pbo archive feature is not available for your OS.",
							"Extract pbo", JOptionPane.INFORMATION_MESSAGE);
			return;
		}
		ExtractPBOPanel extractPBOPanel = new ExtractPBOPanel(facade);
		extractPBOPanel.setVisible(true);
	}

	private void menuItemMakePBOPerformed() {

		if (!System.getProperty("os.name").contains("Windows")) {
			JOptionPane.showMessageDialog(this,
					"Making pbo archive feature is not available for your OS.",
					"Make pbo", JOptionPane.INFORMATION_MESSAGE);
			return;
		}
		PboLoader pboLoader = new PboLoader(facade, "make", jProgressBarEditor);
		pboLoader.start();
	}

	private void menuItemManualPerformed() {
		CommonService commonService = new CommonService();
		String urlValue = commonService.getWiki();
		try {
			URI url = new java.net.URI(urlValue);
			if (Desktop.isDesktopSupported()) {
				Desktop desktop = Desktop.getDesktop();
				desktop.browse(url);
			}
		} catch (Exception e) {
			JOptionPane.showMessageDialog(this,
					"Can't open system web browser.", "Error",
					JOptionPane.ERROR_MESSAGE);
			e.printStackTrace();
		}
	}

	public void setLabelProfileName(String profileName) {
		labelProfileName.setText(profileName);
	}

	public String getLabelProfileName() {
		return labelProfileName.getText();
	}

	public void setMenuProfilesEdit(boolean value) {
		menuProfilesEdit.setEnabled(value);
	}

	public JLabel getStatus() {
		return status;
	}

	public void setStatus(JLabel status) {
		this.status = status;
	}

	public JCheckBox getCheckBoxEditable() {
		return checkBoxEditable;
	}

	public void setLabelDisplayname(String unitDisplayName) {
		jLabelDisplayname.setText(unitDisplayName);
	}

	public void setLabelDescription(String unitDescription) {
		jLabelDescription.setText(unitDescription);
	}

	public void enableSaveMenu(boolean value) {
		menuSaveMission.setEnabled(value);
	}

	public void setButtonSaveAsProfile(boolean value) {
		buttonSaveAsProfile.setEnabled(value);
	}

	public void setButtonApplyProfile(boolean value) {
		buttonApplyProfile.setEnabled(value);
	}

	public JProgressBar getJProgressBarEditor() {
		return jProgressBarEditor;
	}

	public String getComboBoxTypeSelectedItem() {
		return (String) this.jComboBoxType.getSelectedItem();
	}

	public String getComboBoxDisplayOptionsSelectedItem() {
		return (String) jcomboBoxDisplayOptions.getSelectedItem();
	}

	public void enableAutoAssign(boolean value) {
		menuAutoAssign.setEnabled(value);
	}
}
