package com.lea.ui.mission;

import java.io.File;

import javax.swing.JCheckBox;
import javax.swing.JOptionPane;
import javax.swing.JProgressBar;

import com.lea.controler.Observateur;
import com.lea.exception.WritingException;
import com.lea.service.MissionService;
import com.lea.ui.Facade;



public class PboLoader extends Thread {

	private Facade facade;
	private String action = "";
	private JProgressBar progressBar;
	private File sourceFile;
	private File destinationFile;
	private JCheckBox checkBox;

	public PboLoader(Facade facade, String action,
			JProgressBar progressBarEditor) {
		this.facade = facade;
		this.action = action;
		this.progressBar = progressBarEditor;
	}

	public PboLoader(Facade facade, String action, JProgressBar progressBar,
			JCheckBox checkBoxImportMissionSQM, File sourceFile,
			File destinationFile) {

		this.facade = facade;
		this.action = action;
		this.progressBar = progressBar;
		this.sourceFile = sourceFile;
		this.destinationFile = destinationFile;
		this.checkBox = checkBoxImportMissionSQM;
	}

	public void run() {
		MissionService missionService = new MissionService();
		progressBar.setValue(0);
		progressBar.setMinimum(0);
		progressBar.setMaximum(20);
		progressBar.setVisible(true);
		missionService.getMissionDAO().addObservateur(new Observateur() {
			public void update(double value) {
				progressBar.setValue((int) value);
				System.out.println("progressBar = " + value);
			}
		});

		if (action.equals("make")) {
			try {
				missionService.makePBO();
				JOptionPane.showMessageDialog(facade.getMissionEditor(),
						"Pbo generated in LEA pbos folder.", "Make pbo",
						JOptionPane.INFORMATION_MESSAGE);

			} catch (WritingException e) {
				JOptionPane.showMessageDialog(facade.getMissionEditor(),
						"Can't create pbo!" + "\n" + e.getMessage(), "Error",
						JOptionPane.ERROR_MESSAGE);
			} finally {
				facade.getMissionEditor().getStatus().setText("Ready");
				progressBar.setValue(0);
				progressBar.setVisible(false);
			}
		}

		else if (action.equals("extract")) {

			try {
				missionService.extractPBO(sourceFile, destinationFile);

				JOptionPane.showMessageDialog(facade.getMissionEditor(),
						"Mission sucessfully extracted from pbo.",
						"Extract mission from pbo",
						JOptionPane.INFORMATION_MESSAGE);

				facade.getMissionEditor().getStatus().setText("Ready");

				if (checkBox.isSelected()) {
					String missionFolderName = sourceFile.getName().replaceAll(
							".pbo", "");
					String missionSQMPath = destinationFile.getAbsoluteFile()
							+ "/" + missionFolderName + "/mission.sqm";
					if (new File(missionSQMPath).exists()) {
						facade.getMissionEditor().importMissionSQM(missionSQMPath);
						try {
							missionService.copyMissionToLEA(destinationFile
									.getAbsoluteFile()
									+ "/" + missionFolderName);
						} catch (WritingException e) {
							JOptionPane.showMessageDialog(facade
									.getMissionEditor(), e.getMessage(),
									"Error", JOptionPane.ERROR_MESSAGE);
						}
					} else {
						JOptionPane.showMessageDialog(
								facade.getMissionEditor(),
								"No mission.sqm file was found in pbo.",
								"Error", JOptionPane.WARNING_MESSAGE);
					}
				}

			} catch (WritingException e) {
				JOptionPane.showMessageDialog(facade.getMissionEditor(),
						"Can't create pbo!" + "\n" + e.getMessage(), "Error",
						JOptionPane.ERROR_MESSAGE);
			} finally {
				facade.getMissionEditor().getStatus().setText("Ready");
				progressBar.setValue(0);
				progressBar.setVisible(false);
			}
		}
		missionService.getMissionDAO().delObservateur();
	}
}
