package com.lea.ui.mission;

import java.awt.Color;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.StringTokenizer;

import javax.swing.BorderFactory;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTree;
import javax.swing.border.BevelBorder;
import javax.swing.event.TreeExpansionEvent;
import javax.swing.event.TreeExpansionListener;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreeNode;
import javax.swing.tree.TreePath;

import com.lea.dto.GroupDTO;
import com.lea.dto.UnitDTO;
import com.lea.exception.FinderException;
import com.lea.service.CommonService;
import com.lea.service.MissionService;
import com.lea.ui.AssignPanel;
import com.lea.ui.Facade;



/**
 * This code was edited or generated using CloudGarden's Jigloo
 * SWT/Swing GUI Builder, which is free for non-commercial
 * use. If Jigloo is being used commercially (ie, by a corporation,
 * company or business for any purpose whatever) then you
 * should purchase a license for each developer using Jigloo.
 * Please visit www.cloudgarden.com for details.
 * Use of Jigloo implies acceptance of these licensing terms.
 * A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
 * THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
 * LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
 */
/**
 * UnitsPanel view, component of MissionEdiror frame.
 * 
 */

public class UnitsPanel extends JPanel {

	private DefaultMutableTreeNode racine, bluefor, opfor, resistance,
			civilian, empty;
	private JScrollPane jScrollPane_IL;
	private JPanel jPanel1;
	private String unitsTitle = "Units";
	private JTree arbre;
	private String type, display;
	private Collection<UnitDTO> unitsDTO = new ArrayList<UnitDTO>();
	private List<GroupDTO> listgroups = new ArrayList<GroupDTO>();
	private String selectedSide;
	private String selectedGroupName;
	private int selectedUnit;
	private Facade facade;

	public UnitsPanel(final Facade facade) {

		this.facade = facade;
		this.facade.setUnitsPanel(this);
		this.setPreferredSize(new java.awt.Dimension(227, 635));
		this.setLayout(null);

		jPanel1 = new JPanel();
		this.add(jPanel1);
		jPanel1.setBounds(0, 0, 227, 635);
		jPanel1.setBorder(BorderFactory.createTitledBorder(BorderFactory
				.createEmptyBorder(), unitsTitle));
		jPanel1.setLayout(null);

		racine = new DefaultMutableTreeNode("Racine");
		bluefor = new DefaultMutableTreeNode("West");
		opfor = new DefaultMutableTreeNode("East");
		resistance = new DefaultMutableTreeNode("Resistance");
		civilian = new DefaultMutableTreeNode("Civilian");
		empty = new DefaultMutableTreeNode("Empty");
		racine.add(bluefor);
		racine.add(opfor);
		racine.add(resistance);
		racine.add(civilian);
		racine.add(empty);

		arbre = new JTree(racine);
		arbre.setRootVisible(false);
		arbre.setPreferredSize(new java.awt.Dimension(201, 378));
		arbre.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));

		jScrollPane_IL = new JScrollPane(arbre);
		jPanel1.add(jScrollPane_IL);
		jScrollPane_IL.setBounds(9, 23, 213, 602);
		jScrollPane_IL.setBorder(BorderFactory
				.createEtchedBorder(BevelBorder.LOWERED));
		jPanel1.add(jScrollPane_IL);

		arbre.addTreeExpansionListener(new TreeExpansionListener() {
			public void treeExpanded(TreeExpansionEvent event) {
				onTreeExpanded();
			}

			public void treeCollapsed(TreeExpansionEvent event) {
				onTreeCollapsed();
			}
		});
		arbre.addTreeSelectionListener(new TreeSelectionListener() {
			public void valueChanged(TreeSelectionEvent evt) {
				TreePath treePath = arbre.getLeadSelectionPath();

				if (treePath != null) {
					facade.getMissionEditor().setLabelDisplayname("Unknown");
					facade.getMissionEditor().setLabelDescription("Empty");
					facade.getMissionEditor().setLabelProfileName("none");
					facade.setEnableUpdate(false);
					facade.getLoadoutPanel().enableDefaultButton(false);
					facade.getMissionEditor().setButtonSaveAsProfile(false);
					facade.getMissionEditor().setButtonApplyProfile(false);
					facade.getLoadoutPanel().enableClearButton(false);
					facade.getLoadoutPanel().setBackhandButton(false);
					facade.getMissionEditor().getCheckBoxEditable().setEnabled(false);
					facade.getMissionEditor().enableAutoAssign(false);
					facade.getMissionEditor().getCheckBoxEditable().setSelected(false);
					facade.getMissionEditor().getCheckBoxEditable().setForeground(Color.black);
					if ((treePath.getPathCount() == 4)) {
						onTreeSelected(evt, treePath.toString());
						facade.getMissionEditor().enableSaveMenu(true);
						facade.setToBeSaved(true);
						facade.getMissionEditor().enableAutoAssign(true);
					} else if (facade.isToBeSaved()) {
						facade.getMissionEditor().saveUnitLoadout(
								facade.getId());
						facade.setToBeSaved(false);
						facade.getLoadoutPanel().init();
						facade.getRuckandModsPanel().init();
						facade.setId(CommonService.intNoValue());
					}
				}
			}
		});
		arbre.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent evt) {
				if (evt.getClickCount() >= 2) {
					TreePath treePath = arbre.getLeadSelectionPath();
					if (treePath == null) {
						return;
					} else if ((treePath.getPathCount() == 4)) {
						assignPerformed();
					}
				}
			}
		});
	}

	public void init() throws FinderException {
		facade.setId(CommonService.intNoValue());
		unitsDTO = new ArrayList<UnitDTO>();
		MissionService missionService = new MissionService();
		unitsDTO = missionService.loadAllUnits();
		update("Playable", "Name");
	}

	public void update(String type, String display) throws FinderException {

		this.type = type;
		this.display = display;
		int numberRowShown = 0;

		List<UnitDTO> typedUnitsDTO = new ArrayList<UnitDTO>();
		// Retrieve units from there type: PLAYABLE,IA,EMPTY
		for (UnitDTO unitDTO : unitsDTO) {
			if (unitDTO.getType().equals(type.toUpperCase())) {
				// Check if non assigned units must be displayed
				if (!unitDTO.getEditorName().equals("not assigned")) {
					typedUnitsDTO.add(unitDTO);
				} else if (unitDTO.getEditorName().equals("not assigned")
						&& !facade.isHideNonAssignedUnits()) {
					typedUnitsDTO.add(unitDTO);
				}
			}
		}

		// Order groups by their number
		List<Integer> listgroupNumbers = new ArrayList<Integer>();
		for (UnitDTO unitDTO : typedUnitsDTO) {
			int groupNumber = unitDTO.getGroupNumber();
			if (!listgroupNumbers.contains(groupNumber)) {
				listgroupNumbers.add(groupNumber);
			}
		}
		Collections.sort(listgroupNumbers);

		listgroups = new ArrayList<GroupDTO>(listgroupNumbers.size());

		for (int i = 0; i < listgroupNumbers.size(); i++) {
			GroupDTO group = new GroupDTO(listgroupNumbers.get(i));
			listgroups.add(group);
		}

		for (UnitDTO unitDTO : typedUnitsDTO) {
			int groupNumber = unitDTO.getGroupNumber();
			for (GroupDTO group : listgroups) {
				if (groupNumber == group.getGroupNumber()) {
					group.getListUnits().add(unitDTO);
					group.setSide(unitDTO.getSide());
				}
			}
		}
		for (GroupDTO group : listgroups) {
			List<UnitDTO> list = new ArrayList<UnitDTO>();
			for (UnitDTO unitDTO : group.getListUnits()) {
				if (unitDTO.getLeader()) {
					// System.out.println("Description = "
					// + unitDTO.getEditorDescription());
					list.add(unitDTO);
				}
			}
			for (UnitDTO unitDTO : group.getListUnits()) {
				if (!list.contains(unitDTO)) {
					list.add(unitDTO);
				}
			}
			group.getListUnits().clear();
			group.setListUnits(list);
		}

		bluefor.removeAllChildren();
		opfor.removeAllChildren();
		resistance.removeAllChildren();
		civilian.removeAllChildren();
		empty.removeAllChildren();

		int nameGroupWest = 0;
		int nameGroupEast = 0;
		int nameGroupResistance = 0;
		int nameGroupCivilian = 0;
		int nameGroupEmpty = 0;

		int indexGroupWest = 0;
		int indexGroupEast = 0;
		int indexGroupResistance = 0;
		int indexGroupCivilian = 0;
		int indexGroupEmpty = 0;

		for (GroupDTO group : listgroups) {

			if (group.getSide().equals("WEST")) {
				nameGroupWest++;
				group.setGroupName(Integer.toString(nameGroupWest));
				group.setIndexGroup(indexGroupWest);
				indexGroupWest++;

			}
			if (group.getSide().equals("EAST")) {
				nameGroupEast++;
				group.setGroupName(Integer.toString(nameGroupEast));
				group.setIndexGroup(indexGroupEast);
				indexGroupEast++;
			}
			if (group.getSide().equals("GUER")) {
				nameGroupResistance++;
				group.setGroupName(Integer.toString(nameGroupResistance));
				group.setIndexGroup(indexGroupResistance);
				indexGroupResistance++;
			}
			if (group.getSide().equals("CIV")) {
				nameGroupCivilian++;
				group.setGroupName(Integer.toString(nameGroupCivilian));
				group.setIndexGroup(indexGroupCivilian);
				indexGroupCivilian++;
			}
			if (group.getSide().equals("EMPTY")) {
				nameGroupEmpty++;
				group.setGroupName(Integer.toString(nameGroupEmpty));
				group.setIndexGroup(indexGroupEmpty);
				indexGroupEmpty++;
			}

			DefaultMutableTreeNode nodeGroup = new DefaultMutableTreeNode(group
					.getGroupName());

			if (group.getSide().equals("WEST")) {
				bluefor.add(nodeGroup);
			}
			if (group.getSide().equals("EAST")) {
				opfor.add(nodeGroup);
			}
			if (group.getSide().equals("GUER")) {
				resistance.add(nodeGroup);
			}
			if (group.getSide().equals("CIV")) {
				civilian.add(nodeGroup);
			}
			if (group.getSide().equals("EMPTY")) {
				empty.add(nodeGroup);
			}
			int j = 0;
			for (UnitDTO unitDTO : group.getListUnits()) {

				unitDTO.setGroupName(group.getGroupName());
				unitDTO.setIndexGroup(group.getIndexGroup());
				unitDTO.setIndexUnit(j);
				j++;

				String filter = "";
				if (display.equals("Name"))
					filter = unitDTO.getEditorName();
				else if (display.equals("Displayname")) {
					filter = unitDTO.getName();
				} else if (display.equals("Classname")) {
					filter = unitDTO.getClassname();
				} else if (display.equals("Description")) {
					filter = unitDTO.getEditorDescription();
				}

				DefaultMutableTreeNode nodeUnit = new DefaultMutableTreeNode(
						filter);
				nodeGroup.add(nodeUnit);

			}
		}
		numberRowShown = arbre.getRowCount();
		arbre.setVisibleRowCount(numberRowShown);
		arbre.setPreferredSize(arbre.getPreferredScrollableViewportSize());
		arbre.updateUI();
		expand(new TreePath(arbre.getModel().getRoot()));
		jScrollPane_IL.updateUI();
	}

	private void onTreeSelected(TreeSelectionEvent evt, String treepath) {

		System.out.println("treepath UnitsPanel = " + treepath);
		StringTokenizer st = new StringTokenizer(treepath, ",");
		st.nextToken();
		selectedSide = st.nextToken().trim();

		if (selectedSide.equals("Resistance"))
			selectedSide = "GUER";
		if (selectedSide.equals("Civilian"))
			selectedSide = "CIV";

		selectedGroupName = st.nextToken().trim();
		DefaultMutableTreeNode node = (DefaultMutableTreeNode) (evt.getPath()
				.getLastPathComponent());
		selectedUnit = node.getParent().getIndex(node);

		String unitDisplayName = "Unknown";
		String unitDescription = "Empty";
		String unitProfileName = "none";
		String unitEditorName = "not assigned";
		boolean unitIsVehicle = false;

		int tempUnitId = facade.getId();

		for (GroupDTO group : listgroups) {
			if ((group.getSide().equalsIgnoreCase(selectedSide))
					&& (group.getGroupName()
							.equalsIgnoreCase(selectedGroupName))) {
				for (UnitDTO unitDTO : group.getListUnits()) {
					if (unitDTO.getIndexUnit() == selectedUnit) {
						unitDisplayName = unitDTO.getName();
						unitDescription = unitDTO.getEditorDescription();
						unitEditorName = unitDTO.getEditorName();
						facade.setId(unitDTO.getId());
						break;
					}
				}
			}
		}
		MissionService missionService = new MissionService();
		facade.getMissionEditor().setLabelDisplayname(unitDisplayName);
		facade.getMissionEditor().setLabelDescription(unitDescription);

		if (tempUnitId != facade.getId()
				&& tempUnitId != CommonService.intNoValue()) {
			facade.getMissionEditor().saveUnitLoadout(tempUnitId);
			tempUnitId = facade.getId();
		}

		missionService.applyMissionListItemsPreferences();
		missionService.applyMissionListOpticalsPreferences();
		missionService.applyMissionListEquipPreferences();

		facade.getMissionEditor().loadUnitLoadout();

		try {
			unitProfileName = missionService
					.loadUnitProfileName(facade.getId());
		} catch (FinderException e) {
		}

		try {
			unitIsVehicle = missionService.UnitIsVehicle(facade.getId());
			facade.setVehicle(unitIsVehicle);
		} catch (FinderException e) {
		}

		facade.getMissionEditor().setLabelProfileName(unitProfileName);

		if (facade.getLoadoutPanel().getBackWeapon() == null) {
			facade.getLoadoutPanel().setBackhandButton("on back");
		} else {
			facade.getLoadoutPanel().setBackhandButton("in hands");
		}

		if (unitEditorName.equals("not assigned")) {
			facade.setEnableUpdate(false);
			facade.getLoadoutPanel().enableDefaultButton(false);
			facade.getLoadoutPanel().enableVehicleButton(false);
			facade.getLoadoutPanel().enableClearButton(false);
			facade.getLoadoutPanel().setBackhandButton(false);
			facade.getLoadoutPanel().enableWeightPanel(false);
			facade.setRuckOpened(false);
			facade.getMissionEditor().setButtonApplyProfile(false);
			facade.getMissionEditor().setButtonSaveAsProfile(false);
			facade.getMissionEditor().getCheckBoxEditable().setEnabled(false);
			facade.getMissionEditor().getCheckBoxEditable().setSelected(false);
			facade.getMissionEditor().getCheckBoxEditable().setForeground(Color.black);
		}
		else {
			if (!unitDisplayName.equals("Unknown") && !unitIsVehicle) {
				facade.setEnableUpdate(true);
				facade.getRuckandModsPanel().setTitle("Ruck content");
				facade.getLoadoutPanel().enableDefaultButton(true);
				facade.getLoadoutPanel().enableVehicleButton(false);
				facade.getLoadoutPanel().setTextVehicleButton("vehicle");
				facade.getLoadoutPanel().enableClearButton(true);
				if (facade.isNoACE()) {
					facade.getLoadoutPanel().setBackhandButton(false);
				} else {
					facade.getLoadoutPanel().setBackhandButton(true);
				}
				facade.getLoadoutPanel().enableWeightPanel(true);
				facade.getMissionEditor().setButtonSaveAsProfile(true);
				facade.getMissionEditor().setButtonApplyProfile(true);
				facade.getMissionEditor().getCheckBoxEditable()
						.setEnabled(true);
			} else if (!unitDisplayName.equals("Unknown") && unitIsVehicle) {
				facade.setEnableUpdate(true);
				facade.getRuckandModsPanel().setTitle("Vehicle content");
				facade.getLoadoutPanel().enableDefaultButton(false);
				facade.getLoadoutPanel().enableVehicleButton(false);
				facade.getLoadoutPanel().setTextVehicleButton("vehicle");
				facade.getLoadoutPanel().enableClearButton(true);
				if (facade.isNoACE()) {
					facade.getLoadoutPanel().setBackhandButton(false);
				} else {
					facade.getLoadoutPanel().setBackhandButton(true);
				}
				facade.getLoadoutPanel().enableWeightPanel(false);
				facade.setRuckOpened(true);
				facade.getMissionEditor().setButtonSaveAsProfile(true);
				facade.getMissionEditor().setButtonApplyProfile(true);
				facade.getMissionEditor().getCheckBoxEditable()
						.setEnabled(true);
			} else if (unitDisplayName.equals("Unknown") && unitIsVehicle) {
				facade.setEnableUpdate(true);
				facade.getRuckandModsPanel().setTitle("Vehicle content");
				facade.getLoadoutPanel().enableDefaultButton(false);
				facade.getLoadoutPanel().enableVehicleButton(true);
				facade.getLoadoutPanel().setTextVehicleButton("unit");
				facade.getLoadoutPanel().SetVehicleButton(true);
				facade.getLoadoutPanel().enableClearButton(true);
				if (facade.isNoACE()) {
					facade.getLoadoutPanel().setBackhandButton(false);
				} else {
					facade.getLoadoutPanel().setBackhandButton(true);
				}
				facade.getLoadoutPanel().enableWeightPanel(false);
				facade.setRuckOpened(true);
				facade.getMissionEditor().setButtonSaveAsProfile(true);
				facade.getMissionEditor().setButtonApplyProfile(true);
				facade.getMissionEditor().getCheckBoxEditable()
						.setEnabled(true);
			} else {
				facade.setEnableUpdate(true);
				facade.getRuckandModsPanel().setTitle("Ruck content");
				facade.getLoadoutPanel().enableDefaultButton(true);
				facade.getLoadoutPanel().enableVehicleButton(true);
				facade.getLoadoutPanel().setTextVehicleButton("vehicle");
				facade.getLoadoutPanel().enableClearButton(true);
				facade.getLoadoutPanel().enableWeightPanel(true);
				facade.getMissionEditor().setButtonSaveAsProfile(true);
				facade.getMissionEditor().setButtonApplyProfile(true);
				facade.getMissionEditor().getCheckBoxEditable()
						.setEnabled(true);
				facade.setRuckOpened(false);
			}

			boolean value = missionService.unitIsEditable(facade.getId());

			if (value == false) {
				facade.getMissionEditor().getCheckBoxEditable().setSelected(
						true);
				facade.getMissionEditor().getCheckBoxEditable().setForeground(
						Color.red);
				facade.getLoadoutPanel().enableWeightPanel(false);
				facade.setEnableUpdate(false);
				facade.getMissionEditor().setButtonApplyProfile(false);
				facade.getMissionEditor().setButtonSaveAsProfile(false);
			} else {
				facade.getMissionEditor().getCheckBoxEditable().setSelected(false);
				facade.getMissionEditor().getCheckBoxEditable().setForeground(Color.black);

				missionService = new MissionService();
				UnitDTO unitDTO = null;
				try {
					unitDTO = missionService.loadUnit(facade.getId());
				} catch (FinderException e) {
					// e.printStackTrace();
				}
				if (unitDTO != null) {
					if (!unitDTO.isVehicle()) {
						facade.getLoadoutPanel().enableWeightPanel(true);
					}
				}
				facade.setEnableUpdate(true);
				facade.getMissionEditor().setButtonApplyProfile(true);
				facade.getMissionEditor().setButtonSaveAsProfile(true);
			}
		}
	}

	private void onTreeExpanded() {
		int numberRowShown = arbre.getRowCount();
		arbre.setVisibleRowCount(numberRowShown);
		arbre.setPreferredSize(arbre.getPreferredScrollableViewportSize());
		jScrollPane_IL.updateUI();
	}

	private void onTreeCollapsed() {
		int numberRowShown = arbre.getRowCount();
		arbre.setVisibleRowCount(numberRowShown);
		arbre.setPreferredSize(arbre.getPreferredScrollableViewportSize());
		jScrollPane_IL.updateUI();
	}

	private void expand(TreePath path) {
		TreeNode node = (TreeNode) path.getLastPathComponent();
		if (node.getChildCount() >= 0) {
			java.util.Enumeration e = node.children();
			while (e.hasMoreElements()) {
				TreeNode n = (TreeNode) e.nextElement();
				expand(path.pathByAddingChild(n));
			}
		}
		arbre.expandPath(path);
	}

	private void assignPerformed() {
		AssignPanel assignPanel = new AssignPanel(facade);
		assignPanel.setVisible(true);
	}
}
