package com.lea.ui.profile;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.Image;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;
import javax.swing.UnsupportedLookAndFeelException;

import com.lea.exception.FinderException;
import com.lea.exception.LoadingException;
import com.lea.exception.WritingException;
import com.lea.service.CommonService;
import com.lea.service.ProfileService;
import com.lea.ui.Facade;
import com.lea.ui.mission.AmmoPanel;
import com.lea.ui.mission.LoadoutACEPanel;
import com.lea.ui.mission.RuckandModsPanel;



/**
 * This code was edited or generated using CloudGarden's Jigloo
 * SWT/Swing GUI Builder, which is free for non-commercial
 * use. If Jigloo is being used commercially (ie, by a corporation,
 * company or business for any purpose whatever) then you
 * should purchase a license for each developer using Jigloo.
 * Please visit www.cloudgarden.com for details.
 * Use of Jigloo implies acceptance of these licensing terms.
 * A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
 * THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
 * LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
 */
/**
 * Profiles Editor main frame.
 * 
 */

public class ProfilesEditor extends JFrame {

	private JPanel statusPanel, mainPanel, infosPanel;
	private JButton exitButton;
	private RuckandModsPanel ruckAndModsPanel;
	private LoadoutACEPanel loadoutPanel;
	private JButton buttonRefresh;
	private JButton buttonInitLeaAddon;
	private JButton buttonApplyProfile;
	private JButton buttonRename;
	private JButton buttonDelete;
	private JButton buttonNew;
	private ProfilesPanel profilesPanel;
	private AmmoPanel ammoPanel;
	private Facade profilesFacade;
	private Facade facade;
	private JLabel status;
	private JButton buttonSaveAll;

	public ProfilesEditor(Facade profilesFacade, Facade facade) {

		try {
			javax.swing.UIManager
					.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
		} catch (ClassNotFoundException e) {
		} catch (InstantiationException e) {
		} catch (IllegalAccessException e) {
		} catch (UnsupportedLookAndFeelException e) {
		}

		this.profilesFacade = profilesFacade;
		this.facade = facade;
		this.profilesFacade.setProfilesEditor(this);
		this.profilesFacade.setNoACE(facade.isNoACE());
		this.profilesFacade.setNoACRE(facade.isNoACRE());

		setTitle("Profiles");
		setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		setResizable(false);
		setLayout(new BorderLayout());

		this.setSize(1280, 750);
		Image icone = Toolkit
				.getDefaultToolkit()
				.getImage(
						java.lang.ClassLoader
								.getSystemResource("resources/pictures/system/lea.png"));
		setIconImage(icone);

		this.setLocation((int) facade.getMissionEditor().getLocation().getX()
				+ facade.getMissionEditor().getWidth() / 2 - this.getWidth()
				/ 2, (int) facade.getMissionEditor().getLocation().getY()
				+ facade.getMissionEditor().getHeight() / 2 - this.getHeight()
				/ 2);

		/* Infos panel */
		infosPanel = new JPanel();
		infosPanel.setPreferredSize(new java.awt.Dimension(1280, 44));
		add(infosPanel, BorderLayout.NORTH);
		infosPanel.setLayout(null);
		{
			buttonNew = new JButton();
			infosPanel.add(buttonNew);
			buttonNew.setText("New");
			buttonNew.setBounds(30, 7, 74, 27);
			buttonNew.setEnabled(false);
		}
		{
			buttonRename = new JButton();
			infosPanel.add(buttonRename);
			buttonRename.setText("Rename");
			buttonRename.setBounds(110, 7, 74, 27);
			buttonRename.setEnabled(false);
		}
		{
			buttonDelete = new JButton();
			infosPanel.add(buttonDelete);
			buttonDelete.setText("Delete");
			buttonDelete.setBounds(190, 7, 74, 27);
			buttonDelete.setEnabled(false);
		}
		{
			buttonApplyProfile = new JButton();
			infosPanel.add(buttonApplyProfile);
			buttonApplyProfile.setEnabled(false);
			buttonApplyProfile.setText("Apply Profile");
			buttonApplyProfile.setBounds(809, 6, 102, 29);
		}
		{
			buttonSaveAll = new JButton();
			infosPanel.add(buttonSaveAll);
			buttonSaveAll.setText("Save All");
			buttonSaveAll.setEnabled(false);
			buttonSaveAll.setBounds(270, 7, 74, 27);
		}
		{
			buttonRefresh = new JButton();
			infosPanel.add(buttonRefresh);
			buttonRefresh.setText("Refresh");
			buttonRefresh.setBounds(350, 7, 74, 27);
			buttonRefresh.setEnabled(false);
		}
		{
			buttonInitLeaAddon = new JButton();
			infosPanel.add(buttonInitLeaAddon);
			buttonInitLeaAddon.setText("Apply to @LEA");
			buttonInitLeaAddon.setBounds(430, 7, 108, 27);
			buttonInitLeaAddon.setEnabled(false);
		}

		/* Main panel */
		mainPanel = new JPanel();
		mainPanel.setPreferredSize(new java.awt.Dimension(1280, 600));
		add(mainPanel, BorderLayout.CENTER);
		mainPanel.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
		Box box2 = Box.createHorizontalBox();
		mainPanel.add(box2);
		mainPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
		{
			profilesPanel = this.profilesFacade.getProfilesPanel();
			box2.add(profilesPanel);
			profilesPanel.setPreferredSize(new java.awt.Dimension(224, 419));
		}
		{
			ammoPanel = this.profilesFacade.getAmmoPanel();
			box2.add(ammoPanel);
			ammoPanel.setPreferredSize(new java.awt.Dimension(478, 600));
		}
		{
			loadoutPanel = this.profilesFacade.getLoadoutPanel();
			box2.add(loadoutPanel);
			loadoutPanel.setPreferredSize(new java.awt.Dimension(315, 600));
		}

		/* Ruck panel */
		ruckAndModsPanel = this.profilesFacade.getRuckandModsPanel();
		box2.add(ruckAndModsPanel);

		/* Status panel */
		statusPanel = new JPanel();
		statusPanel.setLayout(null);
		statusPanel.setPreferredSize(new java.awt.Dimension(1280, 40));
		add(statusPanel, BorderLayout.SOUTH);
		{
			status = new JLabel("");
			status.setBounds(10, 0, 208, 25);
			statusPanel.add(status);
		}
		{
			exitButton = new JButton();
			exitButton.setText("Close");
			exitButton.setBounds(1190, 5, 65, 25);
			statusPanel.add(exitButton);
		}

		// Add Listeners
		addWindowListener(new WindowAdapter() {
			public void windowOpened(WindowEvent e) {
			}

			public void windowClosing(WindowEvent e) {
				menuExitPerformed();
			}
		});
		exitButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				menuExitPerformed();
			}
		});
		buttonNew.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				newProfile();
			}
		});
		buttonRename.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				renameProfile();
			}
		});
		buttonDelete.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				deleteProfile();
			}
		});
		buttonApplyProfile.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				status.setText("  Loading profiles please wait...");
				SwingUtilities.invokeLater(new Runnable() {
					public void run() {
						applyProfileButtonPerformed();
					}
				});
			}
		});
		buttonRefresh.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				status.setText("  Loading profiles please wait...");
				SwingUtilities.invokeLater(new Runnable() {
					public void run() {
						reloadProfiles();
					}
				});
			}
		});
		buttonInitLeaAddon.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				initLeaAddonButtonPerformed();
			}
		});
		
	}

	public void init() {
		profilesFacade.getAmmoPanel().SetFactionComboBox(true);
		profilesFacade.getLoadoutPanel().setBackhandButton(false);
		profilesFacade.getLoadoutPanel().setOpenRuckButton(false);
		profilesFacade.getLoadoutPanel().enableClearButton(false);
		profilesFacade.getLoadoutPanel().SetDefaultButton(false);
		profilesFacade.getLoadoutPanel().SetVehicleButton(false);
		profilesFacade.getLoadoutPanel().enableClearButton(false);
		profilesFacade.setBottonVehiclePusched(false);
		profilesFacade.getLoadoutPanel().setDefaultButtonVisible(false);
		profilesFacade.getLoadoutPanel().setVehicleButtonVisible(false);
		profilesFacade.setProfileEditMode(true);
		profilesFacade.setToBeSaved(false);
		profilesFacade.setEnableUpdate(false);
	}
	
	private void reloadProfiles() {
		// Loading profiles in a dedicated thread
		ProfilesPanelLoader profilesLoader = new ProfilesPanelLoader(this.profilesFacade);
		
		profilesLoader.start();
		try {
			profilesLoader.join();
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}

	private void menuExitPerformed() {

		// Save last modified profile.
		profilesFacade.setProfileEditMode(false);
		ProfileService profileService = new ProfileService();
		status.setText("Saving profiles...");
		if (profilesFacade.getId() != CommonService.intNoValue()) {
			saveProfileLoadout(profilesFacade.getId());
		}
		dispose();
		facade.getMissionEditor().setMenuProfilesEdit(true);
		facade.setProfileEditMode(false);
	}

	public void saveProfileLoadout(int profileId) {

		ProfileService profileService = new ProfileService();

		try {
			profileService.saveProfilePrimaryWeaponLoadout(profilesFacade
					.getLoadoutPanel().getPrimaryWeapon(), profileId);
			profileService.saveProfileSecondaryWeaponLoadout(profilesFacade
					.getLoadoutPanel().getSecondaryWeapon(), profileId);
			profileService.saveProfileBackWeaponLoadout(profilesFacade
					.getLoadoutPanel().getBackWeapon(), profileId);
			profileService.saveProfilePistolLoadout(profilesFacade
					.getLoadoutPanel().getPistol(), profileId);
			profileService.saveProfileOpticalsLoadout(profilesFacade
					.getLoadoutPanel().getOpticals(), profileId);
			profileService.saveProfileItems(profilesFacade.getLoadoutPanel()
					.getItems(), profileId);
			profileService.saveProfilePrimaryMagazines(profilesFacade
					.getLoadoutPanel().getPrimaryMagazines(), profileId);
			profileService.saveProfileSecondaryMagazines(profilesFacade
					.getLoadoutPanel().getSecondaryMagazines(), profileId);
			profileService.saveProfileMods(profilesFacade.getRuckandModsPanel()
					.getAddonsListModel().getList(), profileId);
			profileService.saveProfileRuck(profilesFacade.getRuckandModsPanel()
					.getListRuck(), profileId);
			profileService.saveProfileFirstAid(profilesFacade.getLoadoutPanel()
					.getListFirstAid(), profileId);

			profileService.saveProfile(profileId);

		} catch (FinderException e) {
			// e.printStackTrace();
		} catch (WritingException e) {
			JOptionPane.showMessageDialog(this, "Can't save profile!" + "\n"
					+ e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
		}
	}

	public void loadProfileLoadout(int profileId) {

		ProfileService profileService = new ProfileService();
		profilesFacade.getLoadoutPanel().init();
		profilesFacade.getRuckandModsPanel().init();

		profilesFacade.getLoadoutPanel().setPrimaryMagazineCapacity(12);
		profilesFacade.getLoadoutPanel().initVisibilityPrimaryMagazinePanels();

		profilesFacade.getLoadoutPanel().setSecondaryMagazineCapacity(12);
		profilesFacade.getLoadoutPanel()
				.initVisibilitySecondaryMagazinePanels();

		try {
			profilesFacade.getLoadoutPanel().setPrimaryWeapon(
					profileService.loadProfilePrimaryWeaponLoadout(profileId));
		} catch (FinderException e) {
		}
		try {
			profilesFacade
					.getLoadoutPanel()
					.SetSecondaryWeapon(
							profileService
									.loadProfileSecondaryWeaponLoadout(profileId));
		} catch (FinderException e) {
		}
		try {
			profilesFacade.getLoadoutPanel().setBackWeapon(
					profileService.loadProfileBackWeaponLoadout(profileId));
		} catch (FinderException e) {
		}
		try {
			profilesFacade.getLoadoutPanel().SetPistol(
					profileService.loadProfilePistolLoadout(profileId));
		} catch (FinderException e) {
		}
		try {
			profilesFacade.getLoadoutPanel().SetOpticals(
					profileService.loadProfileOpticalLoadout(profileId));
		} catch (FinderException e) {
		}
		try {
			profilesFacade.getLoadoutPanel().SetItems(
					profileService.loadProfileItemLoadout(profileId));
		} catch (FinderException e) {
		}
		try {
			profilesFacade
					.getLoadoutPanel()
					.SetPrimaryMagazines(
							profileService
									.loadProfilePrimaryMagazineLoadout(profileId));
		} catch (FinderException e) {
		}
		try {
			profilesFacade.getLoadoutPanel().SetSecondaryMagazines(
					profileService
							.loadProfileSecondaryMagazineLoadout(profileId));
		} catch (FinderException e) {
		}
		try {
			profilesFacade.getRuckandModsPanel().setListRuck(
					profileService.loadProfileRuckWeapons(profileId));
		} catch (FinderException e) {
		}
		try {
			profilesFacade.getRuckandModsPanel().setListRuck(
					profileService.loadProfileRuckMagazines(profileId));
		} catch (FinderException e) {
		}
		try {
			profilesFacade.getLoadoutPanel().setListFirstAid(
					profileService
							.loadProfileFirstAidMagazineLoadout(profileId));
		} catch (FinderException e) {
		}
	}

	public void deleteProfile() {
		int option = JOptionPane.showConfirmDialog(this, "Delete profile?",
				"Confirmation", JOptionPane.OK_CANCEL_OPTION);
		if (option == 0) {
			ProfileService profileService = new ProfileService();
			int profileId = profilesFacade.getId();
			profileService.removeProfile(profileId);
			profilesFacade.getProfilesPanel().init();
			profilesFacade.getProfilesPanel().loadProfiles();
			buttonRename.setEnabled(false);
			buttonSaveAll.setEnabled(false);
			buttonDelete.setEnabled(false);
			buttonRefresh.setEnabled(false);
		}
	}

	public void renameProfile() {

		ProfilesRenameProfilePanel profilesRenameProfilePanel = new ProfilesRenameProfilePanel(
				profilesFacade);
		profilesRenameProfilePanel.setTextFieldProfileName(profilesFacade
				.getProfileName());
		profilesRenameProfilePanel.setVisible(true);
	}

	public void newProfile() {

		if (profilesFacade.getId() != CommonService.intNoValue())
			saveProfileLoadout(profilesFacade.getId());

		ProfilesNewProfilePanel profilesNewProfilePanel = new ProfilesNewProfilePanel(
				profilesFacade);
		profilesNewProfilePanel.setVisible(true);
	}

	private void applyProfileButtonPerformed() {

		if (profilesFacade.getId() != CommonService.intNoValue())
			saveProfileLoadout(profilesFacade.getId());

		ProfilesApplyProfilePanel profileApplyPanel = new ProfilesApplyProfilePanel(profilesFacade);
		profileApplyPanel.setVisible(true);
	}

	public void setRenameButton(boolean value) {
		buttonRename.setEnabled(value);
	}

	public void setDeleteButton(boolean value) {
		buttonDelete.setEnabled(value);
	}

	public void setNewButton(boolean value) {
		buttonNew.setEnabled(value);
	}

	public void setSaveButton(boolean value) {
		buttonSaveAll.setEnabled(value);
	}

	public void setApplyProfileButton(boolean value) {
		buttonApplyProfile.setEnabled(value);
	}
	
	public void setRefreshButton(boolean value) {
		this.buttonRefresh.setEnabled(value);
	}
	
	public void setInitLeaAddon(boolean value) {
		this.buttonInitLeaAddon.setEnabled(value);
	}

	private void saveProfileButtonPerformed() {
		try {
			ProfileService profileService = new ProfileService();
			if (profilesFacade.getId() != CommonService.intNoValue()) {
				saveProfileLoadout(profilesFacade.getId());
				profileService.saveProfile(profilesFacade.getId());

				JOptionPane.showMessageDialog(this,
						"Profiles saved in profiles folder.", "Information",
						JOptionPane.INFORMATION_MESSAGE);

			}
		} catch (WritingException e) {
			JOptionPane.showMessageDialog(this, e.getMessage(), "Error",
					JOptionPane.ERROR_MESSAGE);
		}
	}

	public void loadProfile(String path) {
		ProfileService profileService = new ProfileService();
		try {
			profileService.importProfile(path);
		} catch (LoadingException e) {
			e.printStackTrace();
			JOptionPane.showMessageDialog(this, e.getMessage(), "Error",
					JOptionPane.ERROR_MESSAGE);
		} finally {
			profilesFacade.getProfilesPanel().init();
		}
	}

	private void initLeaAddonButtonPerformed() {
		ProfilesInitLEAaddonPanel profilesInitLEAaddonPanel = new ProfilesInitLEAaddonPanel(
				profilesFacade);
		profilesInitLEAaddonPanel.setVisible(true);
	}

	public JLabel getStatus() {
		return status;
	}

	public void setStatus(JLabel status) {
		this.status = status;
	}
}
