package com.lea.ui.profile;

import java.awt.Image;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.File;
import java.util.Locale;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;

import com.lea.exception.FinderException;
import com.lea.service.CommonService;
import com.lea.service.ProfileService;
import com.lea.ui.Facade;

/**
 * This code was edited or generated using CloudGarden's Jigloo SWT/Swing GUI
 * Builder, which is free for non-commercial use. If Jigloo is being used
 * commercially (ie, by a corporation, company or business for any purpose
 * whatever) then you should purchase a license for each developer using Jigloo.
 * Please visit www.cloudgarden.com for details. Use of Jigloo implies
 * acceptance of these licensing terms. A COMMERCIAL LICENSE HAS NOT BEEN
 * PURCHASED FOR THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED LEGALLY FOR
 * ANY CORPORATE OR COMMERCIAL PURPOSE.
 */
public class ProfilesInitLEAaddonPanel extends JDialog {

	private Facade profilesFacade;
	private JTextField textFieldUserConfigLea;
	private JLabel labelProfile;
	private JLabel labelPreferences;
	private JLabel labelApply;
	private JButton buttonPreferences;
	private JButton buttonCancel;
	private JButton buttonApply;
	private JButton buttonSelect;
	private JLabel labelUserConfigLea;

	public ProfilesInitLEAaddonPanel(Facade profilesFacade) {
		super(profilesFacade.getProfilesEditor(),
				"Initialize @LEA with selected profile", true);

		this.profilesFacade = profilesFacade;
		this.setResizable(false);
		this.setSize(430, 180);
		this.setLayout(null);

		Image icone = Toolkit
				.getDefaultToolkit()
				.getImage(
						java.lang.ClassLoader
								.getSystemResource("resources/pictures/system/lea.png"));
		setIconImage(icone);

		this.setLocation((int) profilesFacade.getProfilesEditor().getLocation()
				.getX()
				+ profilesFacade.getProfilesEditor().getWidth()
				/ 2
				- this.getWidth() / 2, (int) profilesFacade.getProfilesEditor()
				.getLocation().getY()
				+ profilesFacade.getProfilesEditor().getHeight()
				/ 2
				- this.getHeight() / 2);
		{
			labelUserConfigLea = new JLabel();
			getContentPane().add(labelUserConfigLea);
			labelUserConfigLea.setText("\\ ..\\ userconfig");
			labelUserConfigLea.setBounds(10, 43, 81, 21);
		}
		{
			textFieldUserConfigLea = new JTextField();
			getContentPane().add(textFieldUserConfigLea);
			textFieldUserConfigLea.setBounds(91, 43, 240, 21);
		}
		{
			buttonSelect = new JButton();
			getContentPane().add(buttonSelect);
			buttonSelect.setText("Select");
			buttonSelect.setBounds(337, 39, 70, 27);
		}
		{
			buttonApply = new JButton();
			getContentPane().add(buttonApply);
			buttonApply.setText("Apply");
			buttonApply.setBounds(144, 111, 98, 27);
		}
		{
			buttonCancel = new JButton();
			getContentPane().add(buttonCancel);
			buttonCancel.setText("Cancel");
			buttonCancel.setBounds(337, 109, 70, 27);
		}
		{
			labelProfile = new JLabel();
			getContentPane().add(labelProfile);
			labelProfile.setText("Please specify path to userconfig folder.");
			labelProfile.setBounds(101, 18, 230, 18);
		}
		{
			buttonPreferences = new JButton();
			getContentPane().add(buttonPreferences);
			buttonPreferences.setText("Preferences");
			buttonPreferences.setBounds(144, 70, 98, 27);
		}
		{
			labelApply = new JLabel();
			getContentPane().add(labelApply);
			labelApply.setText("Apply profile to @LEA");
			labelApply.setBounds(12, 115, 120, 19);
		}
		{
			labelPreferences = new JLabel();
			getContentPane().add(labelPreferences);
			labelPreferences.setText("Edit preferences");
			labelPreferences.setBounds(12, 77, 120, 19);
		}
		buttonApply.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				buttonApplyPerformed();
			}
		});
		buttonSelect.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				buttonSelectPerformed();
			}
		});

		buttonCancel.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				menuExitPerformed();
			}
		});
		buttonPreferences.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				buttonPreferencesPerformed();
			}
		});
		// Add Listeners
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				menuExitPerformed();
			}
		});
		init();
	}

	private void init() {
		CommonService commonService = new CommonService();
		String path = commonService.getUserconfigLeaPath();
		if (path != null) {
			textFieldUserConfigLea.setText(path);
		} else {
			textFieldUserConfigLea.setText("");
		}
	}

	private void buttonApplyPerformed() {

		String path = textFieldUserConfigLea.getText();

		if (path.equals("")) {
			JOptionPane.showMessageDialog(this, "userconfig path is empty!",
					"Error", JOptionPane.WARNING_MESSAGE);
			return;
		}

		File userconfigFolder = new File(path);
		if (!userconfigFolder.exists()) {
			JOptionPane.showMessageDialog(this,
					"userconfig folder doest not exists!", "Error",
					JOptionPane.WARNING_MESSAGE);
			return;
		}

		CommonService commonService = new CommonService();
		commonService.setUserconfigLeaPath(path);
		ProfileService profileService = new ProfileService();

		try {
			profilesFacade.getProfilesEditor().saveProfileLoadout(profilesFacade.getId());
			profileService.applyProfileListItemsPreferences(profilesFacade.getId());
			profileService.applyProfileListOpticalsPreferences(profilesFacade.getId());
			profileService.applyProfileListEquipPreferences(profilesFacade.getId());
			profileService.saveProfile(profilesFacade.getId());
			profileService.initLeaAddon(profilesFacade.getId(), path,profilesFacade.isNoACE());
			JOptionPane.showMessageDialog(this,
					"@LEA addon has been successfully initialized.", "@LEA",
					JOptionPane.INFORMATION_MESSAGE);
			this.dispose();
		} catch (Exception e) {
			e.printStackTrace();
			JOptionPane
					.showMessageDialog(this, "Can't initialize @LEA addon!"
							+ "\n" + e.getMessage(), "Error",
							JOptionPane.ERROR_MESSAGE);
		}
	}

	private void buttonSelectPerformed() {

		JFileChooser fc = new JFileChooser();

		fc.setLocale(Locale.ENGLISH);
		fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		int returnVal = fc.showOpenDialog(ProfilesInitLEAaddonPanel.this);

		if (returnVal == JFileChooser.APPROVE_OPTION) {
			File file = fc.getSelectedFile();
			String path = file.getAbsolutePath();

			String userconfig = path.substring(path.length() - 10, path
					.length());

			if (!userconfig.toUpperCase().contains("USERCONFIG")) {
				JOptionPane.showMessageDialog(this,
						"Path to userconfig folder is invalid!", "Error",
						JOptionPane.WARNING_MESSAGE);
				return;
			}
			textFieldUserConfigLea.setText(path);
		}
	}

	private void buttonPreferencesPerformed() {
		ProfilesPreferencesPanel profilesPreferencesPanel = new ProfilesPreferencesPanel(
				profilesFacade);
		profilesPreferencesPanel.setVisible(true);
	}

	private void menuExitPerformed() {
		this.dispose();
	}

}
