package com.lea.ui.profile;

import java.awt.Image;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.UnsupportedLookAndFeelException;

import com.lea.exception.WritingException;
import com.lea.service.ProfileService;
import com.lea.ui.Facade;



public class ProfilesNewProfilePanel extends JDialog {

	private Facade profilesFacade;
	private JTextField textFieldProfileName;
	private JButton buttonCancel;
	private JButton buttonNew;

	public ProfilesNewProfilePanel(Facade profilesFacade) {
		super(profilesFacade.getProfilesEditor(),"New Profile", true);

		this.profilesFacade = profilesFacade;
		setLocationRelativeTo(profilesFacade.getProfilesEditor());
		this.setResizable(false);
		this.setSize(240, 110);
		this.setLayout(null);

		Image icone = Toolkit
				.getDefaultToolkit()
				.getImage(
						java.lang.ClassLoader
								.getSystemResource("resources/pictures/system/lea.png"));
		setIconImage(icone);

		this.setLocation((int) profilesFacade.getProfilesEditor().getLocation()
				.getX()
				+ profilesFacade.getProfilesEditor().getWidth()
				/ 2
				- this.getWidth() / 2, (int) profilesFacade.getProfilesEditor()
				.getLocation().getY()
				+ profilesFacade.getProfilesEditor().getHeight()
				/ 2
				- this.getHeight() / 2);

		textFieldProfileName = new JTextField();
		this.add(textFieldProfileName);
		textFieldProfileName.setBounds(15, 11, 203, 23);
		{
			buttonNew = new JButton();
			getContentPane().add(buttonNew);
			buttonNew.setText("New");
			buttonNew.setBounds(24, 40, 67, 25);
		}
		{
			buttonCancel = new JButton();
			getContentPane().add(buttonCancel);
			buttonCancel.setText("Cancel");
			buttonCancel.setBounds(101, 40, 65, 25);
		}
		// Add Listeners
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				menuExitPerformed();
			}
		});
		buttonNew.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				String profileName = textFieldProfileName.getText();
				if (!profileName.equals(""))
					newButtonPerformed(profileName);
			}
		});
		buttonCancel.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				menuExitPerformed();
			}
		});
	}

	private void newButtonPerformed(String profileName) {
		if (profileName != null) {
			try {
				ProfileService profileService = new ProfileService();
				int profileId;
				if (profilesFacade.isVehicle())
					profileId = profileService.createNewProfile(profileName, true);
				else
					profileId = profileService.createNewProfile(profileName, false);
				
				profilesFacade.getProfilesPanel().init();
				profilesFacade.getProfilesPanel().loadProfiles();
			} catch (WritingException e) {
				JOptionPane
				.showMessageDialog(this, e.getMessage(), "New profile",
						JOptionPane.ERROR_MESSAGE);
			} finally {
				dispose();
				profilesFacade.getProfilesEditor().setEnabled(true);
				profilesFacade.getProfilesEditor().toFront();
				profilesFacade.getProfilesEditor().setRenameButton(false);
				profilesFacade.getProfilesEditor().setDeleteButton(false);
				profilesFacade.getProfilesEditor().setSaveButton(false);
			}
		}
	}

	private void menuExitPerformed() {
		this.dispose();
	}
}
