package com.lea.ui.profile;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.StringTokenizer;

import javax.swing.BorderFactory;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JTree;
import javax.swing.border.BevelBorder;
import javax.swing.event.TreeExpansionEvent;
import javax.swing.event.TreeExpansionListener;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreeNode;
import javax.swing.tree.TreePath;
import javax.swing.tree.TreeSelectionModel;

import com.lea.dto.ProfileDTO;
import com.lea.exception.FinderException;
import com.lea.service.CommonService;
import com.lea.service.ProfileService;
import com.lea.ui.Facade;

/**
 * This code was edited or generated using CloudGarden's Jigloo
 * SWT/Swing GUI Builder, which is free for non-commercial
 * use. If Jigloo is being used commercially (ie, by a corporation,
 * company or business for any purpose whatever) then you
 * should purchase a license for each developer using Jigloo.
 * Please visit www.cloudgarden.com for details.
 * Use of Jigloo implies acceptance of these licensing terms.
 * A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
 * THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
 * LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
 */
/**
 * Profile panel, component of ProfileEditor main frame.
 * 
 */

public class ProfilesPanel extends JPanel {

	private DefaultMutableTreeNode racine, units, vehicles;
	private JScrollPane jScrollPane_IL;
	private JPanel jPanel1;
	private String unitsTitle = "Profiles";
	private JTree arbre;
	private Facade profilesFacade;
	private List<ProfileDTO> listProfileDTOUnits, listProfileDTOVehicles;
	private DefaultTreeModel treeModel;
	private JPopupMenu popup;
	private Collection<ProfileDTO> profilesDTO;
	private ProfilesPanelLoader profilesLoader;

	public ProfilesPanel(final Facade profilesFacade) {

		this.profilesFacade = profilesFacade;
		this.profilesFacade.setProfilesPanel(this);
		this.setPreferredSize(new java.awt.Dimension(252, 630));
		this.setLayout(null);

		jPanel1 = new JPanel();
		this.add(jPanel1);
		jPanel1.setBounds(0, 0, 241, 630);
		jPanel1.setBorder(BorderFactory.createTitledBorder(BorderFactory
				.createEmptyBorder(), unitsTitle));
		jPanel1.setLayout(null);

		racine = new DefaultMutableTreeNode("Racine");
		units = new DefaultMutableTreeNode("Units");
		vehicles = new DefaultMutableTreeNode("Vehicles/Crates");
		racine.add(units);
		racine.add(vehicles);

		treeModel = new DefaultTreeModel(racine);

		arbre = new JTree(treeModel);

		// arbre.setEditable(true);
		arbre.getSelectionModel().setSelectionMode(
				TreeSelectionModel.SINGLE_TREE_SELECTION);
		// arbre.setShowsRootHandles(true);
		arbre.setRootVisible(false);
		arbre.setPreferredSize(new java.awt.Dimension(207, 363));
		arbre.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));

		jScrollPane_IL = new JScrollPane(arbre);
		jPanel1.add(jScrollPane_IL);
		jScrollPane_IL.setBounds(9, 23, 211, 603);
		jScrollPane_IL.setBorder(BorderFactory
				.createEtchedBorder(BevelBorder.LOWERED));
		jPanel1.add(jScrollPane_IL);

		arbre.addTreeExpansionListener(new TreeExpansionListener() {
			public void treeExpanded(TreeExpansionEvent event) {
				onTreeExpanded();
			}

			public void treeCollapsed(TreeExpansionEvent event) {
				onTreeCollapsed();
			}
		});
		arbre.addTreeSelectionListener(new TreeSelectionListener() {
			public void valueChanged(TreeSelectionEvent evt) {

				TreePath treePath = arbre.getSelectionPath();

				if (treePath != null) {
					System.out.println("treepath = " + treePath.toString());
					profilesFacade.setEnableUpdate(false);
					profilesFacade.setToBeSaved(true);
					profilesFacade.getLoadoutPanel().enableClearButton(false);
					profilesFacade.getLoadoutPanel().setBackhandButton(false);
					profilesFacade.getProfilesEditor().setNewButton(true);
					profilesFacade.getProfilesEditor().setRenameButton(false);
					profilesFacade.getProfilesEditor().setDeleteButton(false);
					profilesFacade.getProfilesEditor().setSaveButton(false);
					profilesFacade.getProfilesEditor().setRefreshButton(false);
					profilesFacade.getProfilesEditor().setInitLeaAddon(false);
					profilesFacade.getProfilesEditor().setApplyProfileButton(false);
					
					StringTokenizer st = new StringTokenizer(treePath
							.toString(), ",]");
					st.nextToken();
					String type = st.nextToken().trim();

					if (type.equals("Vehicles/Crates")) {
						profilesFacade.setVehicle(true);
					} else {
						profilesFacade.setVehicle(false);
					}

					if ((treePath.getPathCount() == 3)) {

						profilesFacade.getProfilesEditor()
								.setRenameButton(true);
						profilesFacade.getProfilesEditor()
								.setDeleteButton(true);
						profilesFacade.getProfilesEditor().setSaveButton(true);
						profilesFacade.getProfilesEditor().setRefreshButton(true);
						profilesFacade.getProfilesEditor()
								.setApplyProfileButton(true);
						if (type.equals("Vehicles/Crates")) {
							profilesFacade.getProfilesEditor().setInitLeaAddon(
									false);
						} else {
							profilesFacade.getProfilesEditor().setInitLeaAddon(
									true);
						}
						profilesFacade.setEnableUpdate(true);
						onTreeSelected(evt, treePath.toString());
					} else if (profilesFacade.isToBeSaved()) {
						profilesFacade.getProfilesEditor().saveProfileLoadout(
								profilesFacade.getId());
						profilesFacade.setToBeSaved(false);
						profilesFacade.getLoadoutPanel().init();
						profilesFacade.getRuckandModsPanel().init();
						profilesFacade.setId(CommonService.intNoValue());
					}
				}
			}
		});
	}

	public void init() {
		profilesFacade.setId(CommonService.intNoValue());

	}

	public void loadProfiles() {

		try {
			ProfileService profileService = new ProfileService();
			profilesDTO = profileService.loadProfiles();

			listProfileDTOUnits = new ArrayList<ProfileDTO>();
			listProfileDTOVehicles = new ArrayList<ProfileDTO>();

			for (ProfileDTO profileDTO : profilesDTO) {
				if (!profileDTO.isVehicle())
					listProfileDTOUnits.add(profileDTO);
				if (profileDTO.isVehicle())
					listProfileDTOVehicles.add(profileDTO);
			}

			units.removeAllChildren();
			vehicles.removeAllChildren();

			for (ProfileDTO profileDTO : listProfileDTOUnits) {
				DefaultMutableTreeNode nodeUnit = new DefaultMutableTreeNode(
						profileDTO.getProfileName());
				units.add(nodeUnit);
			}
			for (ProfileDTO profileDTO : listProfileDTOVehicles) {
				DefaultMutableTreeNode nodeVehicle = new DefaultMutableTreeNode(
						profileDTO.getProfileName());
				vehicles.add(nodeVehicle);
			}

			int numberRowShown = arbre.getRowCount();
			arbre.setVisibleRowCount(numberRowShown);
			arbre.setPreferredSize(arbre.getPreferredScrollableViewportSize());
			arbre.updateUI();
			expand(new TreePath(arbre.getModel().getRoot()));
			jScrollPane_IL.updateUI();
			profilesFacade.getProfilesEditor().getStatus().setText("");

		} catch (FinderException e) {
			//Profles list is empty
			
			if (!e.getMessage().equals("Profiles list is empty.")) {
				e.printStackTrace();
			}
			profilesFacade.getProfilesEditor().getStatus().setText("");
			units.removeAllChildren();
			vehicles.removeAllChildren();
			int numberRowShown = arbre.getRowCount();
			arbre.setVisibleRowCount(numberRowShown);
			arbre.setPreferredSize(arbre.getPreferredScrollableViewportSize());
			arbre.updateUI();
			jScrollPane_IL.updateUI();
		}
	}

	private void expand(TreePath path) {
		TreeNode node = (TreeNode) path.getLastPathComponent();
		if (node.getChildCount() >= 0) {
			java.util.Enumeration e = node.children();
			while (e.hasMoreElements()) {
				TreeNode n = (TreeNode) e.nextElement();
				expand(path.pathByAddingChild(n));
			}
		}
		arbre.expandPath(path);
	}

	private void onTreeSelected(TreeSelectionEvent evt, String treepath) {

		StringTokenizer st = new StringTokenizer(treepath, ",]");
		st.nextToken();
		st.nextToken();

		String profileName = st.nextToken().trim();
		profilesFacade.setProfileName(profileName);

		int tempProfileId = profilesFacade.getId();

		try {
			ProfileService profileService = new ProfileService();
			ProfileDTO profileDTO = profileService.findProfile(profileName);
			int profileId = profileDTO.getProfileId();
			profilesFacade.setId(profileId);

			if (tempProfileId != profileId
					&& tempProfileId != CommonService.intNoValue()) {
				profilesFacade.getProfilesEditor().saveProfileLoadout(
						tempProfileId);
				tempProfileId = profileId;
			}

			profilesFacade.getProfilesEditor().loadProfileLoadout(
					profilesFacade.getId());

			if (profilesFacade.getLoadoutPanel().getBackWeapon() == null)
				profilesFacade.getLoadoutPanel().setBackhandButton("on back");
			else
				profilesFacade.getLoadoutPanel().setBackhandButton("in hands");

			if (!profileDTO.isVehicle()) {
				profilesFacade.getRuckandModsPanel().setTitle("Ruck content");
				profilesFacade.getLoadoutPanel().enableVehicleButton(false);
				profilesFacade.getLoadoutPanel()
						.setTextVehicleButton("vehicle");
				profilesFacade.getLoadoutPanel().enableClearButton(true);
				profilesFacade.getLoadoutPanel().enableWeightPanel(true);
				// Desable ACE back weapon feature if ACE mod is not selected
				if (profilesFacade.isNoACE()) {
					profilesFacade.getLoadoutPanel().setBackhandButton(false);
				} else {
					profilesFacade.getLoadoutPanel().setBackhandButton(true);
				}
			} else {
				profilesFacade.getRuckandModsPanel()
						.setTitle("Vehicle content");
				profilesFacade.getLoadoutPanel().enableVehicleButton(false);
				profilesFacade.getLoadoutPanel()
						.setTextVehicleButton("vehicle");
				profilesFacade.getLoadoutPanel().enableClearButton(true);
				profilesFacade.getLoadoutPanel().enableWeightPanel(false);
				profilesFacade.setRuckOpened(true);
				// Desable ACE back weapon feature if ACE mod is not selected
				if (profilesFacade.isNoACE()) {
					profilesFacade.getLoadoutPanel().setBackhandButton(false);
				} else {
					profilesFacade.getLoadoutPanel().setBackhandButton(true);
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	private void onTreeExpanded() {
		int numberRowShown = arbre.getRowCount();
		arbre.setVisibleRowCount(numberRowShown);
		arbre.setPreferredSize(arbre.getPreferredScrollableViewportSize());
		jScrollPane_IL.updateUI();
	}

	private void onTreeCollapsed() {
		int numberRowShown = arbre.getRowCount();
		arbre.setVisibleRowCount(numberRowShown);
		arbre.setPreferredSize(arbre.getPreferredScrollableViewportSize());
		jScrollPane_IL.updateUI();
	}

	public ProfilesPanelLoader getProfilesPanelLoader() {
		return profilesLoader;
	}

}
